C                 STRUVIR originates from :
C
C
C ************************************************************
C ************************************************************
C ***                                                      ***
C ***                   STRUPLO'84                         ***
C ***                                                      ***
C ***             A FORTRAN PLOTPROGRAM                    ***
C ***                                                      ***
C ***             FOR CRYSTAL STRUCTURE                    ***
C ***                                                      ***
C ***                  ILLUSTRATIONS                       ***
C ***                                                      ***
C ***                                                      ***
C ***  AUTHOR: REINHARD X. FISCHER                         ***
C ***          INSTITUT FUER MINERALOGIE                   ***
C ***          DER UNIVERSITAET                            ***
C ***          AM HUBLAND                                  ***
C ***          D-8700 WUERZBURG, FRG                       ***
C ***                                                      ***
C ************************************************************
C ************************************************************
C
C              MORE OR LESS COMPLETE HISTORY :
C
C VERSION   1986  (6000 ATOMS, 1000 POLYHEDRA)
C
C Written by R. X. Fischer (J. Appl. Cryst. (1985). 18, 258-262).
C Augmented by A. Le Lirzin, 1989 (COLO, PRES, BZRR)
C and by D. Kassner, 1990 (RES, NRES in PARA, incorporation of
C Burzlaff routine in SPGR, logic of VIEW and ROTA, addressing
C in SHAD, reorganization of COMMON-block structure).
C
C Received at MSU 17Aug92, via Tim McCarthy from Giaquinta at MIT.
C M.S.U. writeup by Donald L. Ward from the original by W. H. Baur.
C MSU version: 09-Sep-1992, Donald L. Ward
C
C Received at Laboratoire des Fluorures March 1996 from D.L. Ward
C
C Augmented by A. Le Bail, 1996,
C           Laboratoire des Fluorures, CNRS URA 449
C           Universite du Maine
C           72017 Le Mans Cedex
C           FRANCE
C           Email armel@fluo.univ-lemans.fr
C           http://fluo.univ-lemans.fr:8001/
C           April 1996
C                  HPGL output (STRUVIR.HGL)
C                  VRML output (PO.WRL and WI.WRL)
C
C Augmented by M. Koennnecke, 1996,
C                  POVRAY output (STRUPLO.POV)
C
C    PROGRAM STRUPLO	
      character*20 file
      character*24 temp
      EQUIVALENCE (YC35,YC(35))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(48,3,4),
     *YF(900),MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(5,21,7),
     *MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
      COMMON/WRL/AID,NAID,CART,IO5,IO7,IO8,NCIRC,ICOL,NCOL,NPT
      CHARACTER*28 CR
      CHARACTER TIT*40,BL*4
C      CHARACTER  IDATE*9, ITIME*8
      LOGICAL LOG,LOG2,LOG3,LOG4,QEX
      DIMENSION IYA(4,6000)
      DIMENSION NAID(6000),CART(6000,3),NCIRC(6000),NCOL(20,2)
      DIMENSION ICOL(6000)
      INTEGER AID(6000,2)
      EQUIVALENCE (IYA(1,1),YA(1,1))
      PARAMETER (IYAQ=1000,IYAQ1=10)
*BER**DEC nicht definiert --> DEC=0 setzen***************************
        DEC=0.
*********************************************************************
C
*BER  CALL TINIT
C      WRITE(6,2000)
C2000  FORMAT('$Eingabefile: ')
C
C  MODIF ALB: initializations deplaced from the BLOCK DATA
C             with consequence that the size of struvir.c
C             created by f2c is now divided by 2.
C
      CALL ZERO
C
C     FILE  DECLARATIONS
C
      IOK=IO4
      IO5=15
      IO7=16    
      IO8=17
      PRINT 6000
6000  FORMAT(' Entry file (without .dat extension ) ? ',$)
      READ 5000,file
5000  format(A20)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
         lfile=lfile-1
      enddo
      temp=file(1:lfile)//'.dat'
      call open_read1(IO1,temp)
      INQUIRE(FILE='struvir.imp',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2010
      CALL FILEDEL(IO2,'struvir.imp')
2010  OPEN (IO2,FILE='struvir.imp',FORM='FORMATTED',STATUS='NEW')
      INQUIRE(FILE='wi.wrl',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2013
      CALL FILEDEL(IO5,'wi.wrl')
2013  OPEN (IO5,FILE='wi.wrl',STATUS='NEW')
      INQUIRE(FILE='po.wrl',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2014
      CALL FILEDEL(IO7,'po.wrl')
2014  OPEN (IO7,FILE='po.wrl',STATUS='NEW')
C
C     Get time/date information, write welcome message
C
C      CALL DATE (IDATE)
C      CALL TIME (ITIME)
C      WRITE (6, 2001) IDATE, ITIME
      WRITE (6, 2001)
2001  FORMAT (/,' STRUVIR - (version beta-3 September-96)')
*BER*******
C     OPEN (1,FILE='TEMP')

*BER*****************************************************************
      WRITE (6,2002)
2002  FORMAT(' Output listing      : STRUVIR.IMP'/
     *' HPGL file           : STRUVIR.HGL'/
     *' File for PSPLOT.EXE : STRUPLO.XYZ'/
     *' VRML wireframe file : WI.WRL'/
     *'      polyhedra file : PO.WRL'/
     *' POVRAY file         : STRUPLO.POV')
C
      CALL READ
      LOG2=MI(45).EQ.0
      LOG3=YC(29).LT.-10..OR.MI(45).NE.2
C
C *** CALCULATE ORTHOGONAL MATRIX ***
C
      YD(1)=SIN(YC(26)*YC35)
      YD(2)=SIN(YC(27)*YC35)
      YD(3)=SIN(YC(28)*YC35)
      YD(4)=COS(YC(26)*YC35)
      YD(5)=COS(YC(27)*YC35)
      YD(6)=COS(YC(28)*YC35)
      YD(7)=(YD(4)*YD(5)-YD(6))/(YD(1)*YD(2))
      YC(37)=YC(23)*YD(2)*SQRT(1.-YD(7)*YD(7))
      YC(38)=-YC(23)*YD(2)*YD(7)
      YC(39)=YC(24)*YD(1)
      YC(40)=YC(23)*YD(5)
      YC(41)=YC(24)*YD(4)
      YC(42)=YC(25)
C
C *** CALCULATE INVERSE MATRIX ***
C
      YC(48)=1./YC(42)
      YC(46)=1./YC(40)
      YC(43)=1./YC(37)
      YC(47)=-(YC(41)*YC(48))/YC(40)
      YC(44)=-(YC(38)*YC(43)*YC(46))
      YC(45)=-YC(43)*(YC(38)*YC(47)+YC(39)*YC(48))
      IF (PP(1).GT.-1E10) CALL VIEW
C
C *** CALCULATE RANGE FOR ATOMS OUTSIDE THE UNITCELL ***
C
    1 IF (LOG2)THEN
        DO 2 I=1,24,3
    2   CALL CORTH
        YD(1)=YC(56)*YC(60)-YC(57)*YC(59)
        YD(2)=YC(57)*YC(58)-YC(55)*YC(60)
        YD(3)=YC(55)*YC(59)-YC(56)*YC(58)
        YD(4)=YC(53)*YC(60)-YC(54)*YC(59)
        YD(5)=YC(54)*YC(58)-YC(52)*YC(60)
        YD(6)=YC(52)*YC(59)-YC(53)*YC(58)
        YD(7)=YC(53)*YC(57)-YC(54)*YC(56)
        YD(8)=YC(54)*YC(56)-YC(52)*YC(57)
        YD(9)=YC(52)*YC(56)-YC(53)*YC(55)
        YD(10)=SQRT(YD(1)*YD(1)+YD(2)*YD(2)+YD(3)*YD(3))
        YD(11)=SQRT(YD(4)*YD(4)+YD(5)*YD(5)+YD(6)*YD(6))
        YD(12)=SQRT(YD(7)*YD(7)+YD(8)*YD(8)+YD(9)*YD(9))
        C73=AMAX1(YC(9)+YC(10),YC(17)+YC(18))
        YD(4)=ABS(C73*YD(10)/(YD(1)*YC(37)+YD(2)*YC(38)+YD(3)*YC(40)))
        YD(7)=ABS(C73*YD(11)/(YD(5)*YC(39)+YD(6)*YC(41)))
        YD(8)=ABS(C73*YD(12)/(YD(9)*YC(42)))
        YC(1)=-YD(4)
        YC(3)=-YD(7)
        YC(5)=-YD(7)
        YC(2)=YD(4)+1.
        YC(4)=YD(7)+1.
        YC(6)=YD(8)+1.
        WRITE (IO2,1000) (YC(J),J=1,6)
      ELSE
        WRITE (IO2,1013) (YC(J),J=1,6)
      ENDIF
C
C *** SET -X,-Y,-Z OPERATOR ***
C
    4 IF (MI(44).EQ.1)THEN
        DO 6 I=1,MI(5)
        L=I+MI(5)
        DO 6 J=1,3
        DO 6 K=1,4
    6   YY(L,J,K)=-YY(I,J,K)
        MI(5)=L
        WRITE (IO2,1014)
      ELSE
        WRITE (IO2,1015)
      ENDIF
C
C *** PREPARE DO LOOP PARAMETERS ***
C
    8 DO 9 I=1,6
        MO(I)=IFIX(YC(I)-SIGN(1E-4,YC(I))+10.)
9     CONTINUE
C
C *** READ ATOMIC PARAMETERS ***
C
      DO 42 I=9,6000
      GOTO (10,18,19,21,20),MI(9)
   10 K=0
   11 READ (IO1,1004,END=43) (MN(J),J=1,80)
      IF (MN(1).EQ.MM( 1).AND.MN(2).EQ.MM( 1)) GOTO 11
      IF (MN(1).EQ.MM(41).AND.MN(2).EQ.MM(28)) GOTO 11
      IF (MN(1).EQ.MM(24).AND.MN(2).EQ.MM(34)) GOTO 11
      IF (MN(1).EQ.MM(27).AND.MN(2).EQ.MM(34)) GOTO 43
      IF (MN(1).NE.MM(21).OR. MN(2).NE.MM(40)) GOTO 13
      MN(3)=MM(1)
      MN(4)=MM(1)
      CALL READN
      DO 12 J=1,30
      IF (YD(J).LT.-1E20) GOTO 11
      K=K+1
   12 YF(K)=YD(J)
      GOTO 11
   13 DO 14 J=19,44
   14 IF (MN(1).EQ.MM(J)) GOTO 15
      GOTO 11
   15 MN(81)=MN(1)
      MN(82)=MN(2)
      CALL READN
      MN(3)=IFIX(YD(1))
      DO 17 J=3,5
      IF (YD(J).LE.15.)THEN
        YD(J-1)=YD(J)
      ELSE
        K=IFIX((YD(J)+5.)*0.1)
        YD(J-1)=(YD(J)-FLOAT(K*10))*YF(K)
      ENDIF
   17 CONTINUE
      MN(1)=MN(81)
      MN(2)=MN(82)
      GOTO 22
   18 READ (IO1,1002,END=43) (MN(J),J=1,3) , (YD(J),J=2,4)
      GOTO 22
   19 READ (IO1,1003,END=43) (MN(J),J=1,3) , (YD(J),J=2,4)
      GOTO 22
   20 READ (IO1, MH ,END=43) (MN(J),J=1,3) , (YD(J),J=2,4)
      GOTO 22
   21 READ (IO1,1004,END=43) (MN(J),J=1,80)
      N1=MN(1)
      N2=MN(2)
      CALL READN
      MN(1)=N1
      MN(2)=N2
      MN(3)=IFIX(YD(1))
   22 IYA(1,MI(8)+1)=IPACK(1)
C
C *** STORE ATOM NAME ***
C
      IF (MI(24).GT.0)THEN
        DO 24 J=1,MI(24)
   24   IF (MN(3) .EQ. MI(J+24)) GOTO 26
      ENDIF
      MI(24)=MI(24)+1
      MI(MI(24)+24)=MN(3)
C
C *** GENERATE EQUIVALENT POSITIONS ***
C
   26 ITEMP=IYA(1,MI(8)+1)
      MN(2)=MI(8)
      DO 41 J=1,MI(5)
      DO 40 K=1,3*MI(4),3
      MI(8)=MI(8)+1
      IYA(1,MI(8))=ITEMP
      DO 27 L=1,3
      YA(L+1,MI(8))=YY(J,L,1)+YB(K+L+11)+
     *YY(J,L,2)*YD(2)+YY(J,L,3)*YD(3)+YY(J,L,4)*YD(4)
   27 CONTINUE
C
C *** REDUCE COORDINATES TO RANGE OF UNIT CELL ***
C
      DO 31 L=2,4
      YA(L,MI(8))=AMOD(YA(L,MI(8)),1.)
      IF(YA(L,MI(8)).LT.0.)YA(L,MI(8))=YA(L,MI(8))+1.
   31 CONTINUE
C
C *** CHECK SPECIAL POSITIONS ***
C
      IF (J.EQ.1 .OR. K.GT.1) GOTO 36
      DO 35 L=MN(2),MI(8)-1
      IF (ABS(YA(2,L) - YA(2,MI(8))) .GE. 0.001)GO TO 35
      IF (ABS(YA(3,L) - YA(3,MI(8))) .GE. 0.001)GO TO 35
      IF (ABS(YA(4,L) - YA(4,MI(8))) .GE. 0.001)GO TO 35
      MI(8)=MI(8)-1
      GOTO 41
   35 CONTINUE
C
C *** CHECK LIMITS FOR ALL ATOMS ***
C
   36 IF (YA(2,MI(8)) .LT. YC(1) .OR. YA(2,MI(8)) .GT. YC(2)) GOTO 37
      IF (YA(3,MI(8)) .LT. YC(3) .OR. YA(3,MI(8)) .GT. YC(4)) GOTO 37
      IF (YA(4,MI(8)) .LT. YC(5) .OR. YA(4,MI(8)) .GT. YC(6)) GOTO 37
      GOTO 38
   37 IYA(1,MI(8))=-ABS(IYA(1,MI(8)))
      GOTO 40
C
C *** CHECK LIMITS FOR CIRCLES ***
C
   38 IF (LOG3) GOTO 40
      IF (YA(2,MI(8)) .LT. YC(29) .OR. YA(2,MI(8)) .GT. YC(30)) GOTO 39
      IF (YA(3,MI(8)) .LT. YC(31) .OR. YA(3,MI(8)) .GT. YC(32)) GOTO 39
      IF (YA(4,MI(8)) .LT. YC(33) .OR. YA(4,MI(8)) .GT. YC(34)) GOTO 39
      GOTO 40
   39 IYA(1,MI(8))=(IYA(1,MI(8))/IYAQ1)*IYAQ1+5
   40 CONTINUE
   41 CONTINUE
   42 CONTINUE
C
C *** GENERATE ATOMS OUTSIDE THE UNIT CELL ***
C
   43 MI(36)=MI(8)
      DO 47 I=9,MI(36)
      ITEMP=ABS(IYA(1,I)/IYAQ1)*IYAQ1
      YD(2)=YA(2,I)
      YD(3)=YA(3,I)
      YD(4)=YA(4,I)
      DO 47 J=MO(1),MO(2)
      DO 47 K=MO(3),MO(4)
      DO 47 L=MO(5),MO(6)
      IF (J.EQ.10 .AND. K.EQ.10 .AND. L.EQ.10) GOTO 47
      MI(8)=MI(8)+1
      IYA(1,MI(8))=ITEMP
      YA(2,MI(8))=YD(2)+FLOAT(J)-10.
      YA(3,MI(8))=YD(3)+FLOAT(K)-10.
      YA(4,MI(8))=YD(4)+FLOAT(L)-10.
C
C *** CHECK LIMITS ***
C
      IF (YA(2,MI(8)) .LT. YC(1) .OR. YA(2,MI(8)) .GT. YC(2)) GOTO 44
      IF (YA(3,MI(8)) .LT. YC(3) .OR. YA(3,MI(8)) .GT. YC(4)) GOTO 44
      IF (YA(4,MI(8)) .LT. YC(5) .OR. YA(4,MI(8)) .GT. YC(6)) GOTO 44
      GOTO 45
   44 MI(8)=MI(8)-1
      GOTO 47
C
C *** CHECK LIMITS FOR CIRCLES ***
C
   45 IF (LOG3) GOTO 47
      IF (YA(2,MI(8)) .LT. YC(29) .OR. YA(2,MI(8)) .GT. YC(30)) GOTO 46
      IF (YA(3,MI(8)) .LT. YC(31) .OR. YA(3,MI(8)) .GT. YC(32)) GOTO 46
      IF (YA(4,MI(8)) .LT. YC(33) .OR. YA(4,MI(8)) .GT. YC(34)) GOTO 46
      GOTO 47
   46 IYA(1,MI(8))=(IYA(1,MI(8))/IYAQ1)*IYAQ1+5
   47 CONTINUE
C
C *** OMIT ATOMS ***
C
      I=356
   48 IF (I.GE.MI(11))GO TO 54
      I=I+1
      IF (MN(I+1).LT.0)THEN
        MN(1)= MN(I)
        MN(2)=-MN(I+1)
        I=I+1
      ELSE
        MN(1)=MN(I)
        MN(2)=MN(I)
      ENDIF
      DO 53 J=MN(1),MN(2)
   53 IYA(1,J)=-IYA(1,J)
      GO TO 48
C
C *** ADD ATOMS ***
C
   54 IF (MI(2).GT.0)THEN
        DO 56 I=156,MI(10),4
        MI(8)=MI(8)+1
        IYA(1,MI(8))=ABS(IYA(1,MN(I)))
        YA(2,MI(8))=YA(2,MN(I))+FLOAT(MN(I+1))-5.
        YA(3,MI(8))=YA(3,MN(I))+FLOAT(MN(I+2))-5.
   56   YA(4,MI(8))=YA(4,MN(I))+FLOAT(MN(I+3))-5.
      ENDIF
C
C *** IF NO OUTLINES: ORIGIN ATOMS ARE NOT GRAPHED (INCREASING PLOTTER SCALE)
C
      IF(MI(48).EQ.0)THEN
        DO 57 I=1,8
   57   IYA(1,I)=-ABS(IYA(1,I))
      ENDIF
C
      YD( 7)= 1E5
      YD( 9)= 1E5
      YD( 8)=-1E5
      YD(10)=-1E5
      WRITE (IO2,1009)
      WRITE (IO2,1007)
C MODIF ALB
      NPT=MI(8)
C 
      K=0
      DO 66 I=1,MI(8)
      IF (I.EQ.9)THEN
        WRITE (IO2,1010)
        WRITE (IO2,1007)
      ENDIF
      IF (I.EQ.1+MI(36))THEN
        WRITE (IO2,1011)
        WRITE (IO2,1007)
        K=1
      ENDIF
      II=I
      CALL UNPACK(II)
C
C *** CALCULATE ORTHOGONAL COORDINATES ***
C
      YD(1)=YA(2,I)
      YD(2)=YA(3,I)
      YD(3)=YA(4,I)
      CALL CORTH
C
C *** ROTATE COORDINATES ***
C
      YA(2,I)=YB( 4)*YD(4)+YB( 5)*YD(5)+YB( 6)*YD(6)
      YA(3,I)=YB( 7)*YD(4)+YB( 8)*YD(5)+YB( 9)*YD(6)
      YA(4,I)=YB(10)*YD(4)+YB(11)*YD(5)+YB(12)*YD(6)
C
C     IF (I.LE.MI(36) .AND. I.GT.8 .AND. IO2.NE.6)
C    *  WRITE (IO2,1005) I,(MH(J),J=1,3),(YD(J),J=1,3),(YA(J,I),J=2,4)
C
C *** FIND MINIMUM AND MAXIMUM FOR SCALECALCULATION ***
C
      IF (IYA(1,I).GT.0)THEN
        YD( 7)=AMIN1(YD( 7),YA(2,I))
        YD( 8)=AMAX1(YD( 8),YA(2,I))
        YD( 9)=AMIN1(YD( 9),YA(3,I))
        YD(10)=AMAX1(YD(10),YA(3,I))
C
        DEC=AMAX1(DEC,YA(4,I))
C
        WRITE (IO2,1005) I,(MH(J),J=1,3),(YD(J),J=1,3),(YA(J,I),J=2,4)
C MODIF ALB
      AID(I,1)=MH(1)
      AID(I,2)=MH(2)
      NAID(I)=MH(3)
      CART(I,1)=YA(2,I)
      CART(I,2)=YA(3,I)
      CART(I,3)=YA(4,I)
C
      ELSE
        WRITE (IO2,1006) I,(MH(J),J=1,3),(YD(J),J=1,3),(YA(J,I),J=2,4)
C MODIF ALB
      AID(I,1)=MH(1)
      AID(I,2)=MH(2)
      NAID(I)=MH(3)
      CART(I,1)=YA(2,I)
      CART(I,2)=YA(3,I)
      CART(I,3)=YA(4,I)
C
      ENDIF
   66 CONTINUE
C MODIF ALB
C
C  Color attribution for VRML output
C
      J=1
      ICOL(9)=1
      NCOL(1,1)=AID(9,1)
      NCOL(1,2)=AID(9,2)
      DO 660 I=10,MI(8)
      JJ=J
      DO 658 K=1,JJ
      IF(AID(I,1).EQ.NCOL(K,1).AND.AID(I,2).EQ.NCOL(K,2))GO TO 670
658   CONTINUE
      J=J+1
      NCOL(J,1)=AID(I,1)
      NCOL(J,2)=AID(I,2)
670   CONTINUE
      IF(J.GT.20)PRINT *,'More than 20 different atom names = STOP !'
      IF(J.GT.20)STOP
      DO 659 K=1,J
      IF(AID(I,1).EQ.NCOL(K,1).AND.AID(I,2).EQ.NCOL(K,2))ICOL(I)=K
659   CONTINUE
660   CONTINUE
      PRINT *,'Number of different atoms is ',J
C
C  End of color attribution
C
      DO 67 I=1,80
   67 MN(I)=-1
C
C *** MOVE ORIGIN TO CENTER OF THE PLOT ***
C
      YB(10)=YD( 7)
      YB(11)=YD( 8)
      YB(12)=YD( 9)
      YB(13)=YD(10)
      YB(18)=(YB(10)+YB(11))*0.5
      YB(19)=(YB(12)+YB(13))*0.5
      DO 500 I=1,MI(8)
      YA(2,I)=YA(2,I)-YB(18)
      YA(3,I)=YA(3,I)-YB(19)
  500 YA(4,I)=YA(4,I)-DEC
      IF (MI(7).LE.0)GO TO 80
C
C *** STORE ATOM NUMBERS TO BE GRAPHED AS CIRCLES ***
C
C *** A) GIVEN AS INTEGERS ***
C
      I=456
      J=1
      L=0
   69 I=I+1
      IF (MN(I).LE.0)THEN
        J=J+1
        GOTO 78
      ENDIF
      IF (MN(I+1).LE.0 .AND. MN(I+1).GE.-5000)THEN
        MN(1)=MN(I)
        MN(2)=-MN(I+1)
      ELSE
        MN(1)=MN(I)
        MN(2)=MN(I)
        J=J+1
      ENDIF
      I=I+1
      DO 77 K=MN(1),MN(2)
      IYA(1,K)=IYA(1,K)+J
      L=L+1
      IF (L.GE.3000)THEN
        WRITE (IO3,1003)
        STOP
      ENDIF
   77 MO(L)=K
   78 IF (I-MI(7).LT.456)GO TO 69
      MI(7)=L
   80 IF (MI(38).LE.0)GO TO 86
C
C *** B) GIVEN AS ATOM NAMES ***
C
      DO 85 I=9,MI(8)
C MODIF ALB
      NCIRC(I)=0
C
      IF (IYA(1,I).LE.0.)GO TO 85
      MN(1)=IYA(1,I)/IYAQ1
      MN(2)=IYA(1,I)/IYAQ
      IF (IYA(1,I).NE.MN(1)*IYAQ1) GOTO 85
      DO 83 J=557,MI(38)+556
      MN(3)=MN(J)/100
      IF (MN(3).EQ.MN(2))THEN
        MI(7)=MI(7)+1
        MO(MI(7))=I
C  MODIF ALB
C  STRUVIR MARK ON CIRCLES TO BECOME SPHERES
               NCIRC(I)=I
C
        IYA(1,I)=IYA(1,I)+MN(J)-MN(3)*10*IYAQ1
        GO TO 85
      ENDIF
   83 CONTINUE
   85 CONTINUE
   86 IF (IABS(MI(7))+IABS(MI(38)).LE.0)GO TO 91
C
C *** SORT CIRCLES ***
C
      DO 90 I=1,MI(7)-1
      K=0
      YD(1)=DIST(MO(I))
      DO 88 J=I+1,MI(7)
      IF(YD(1).GE.DIST(MO(J)))THEN
        YD(1)=DIST(MO(J))
        K=J
      ENDIF
   88 CONTINUE
      IF (K.GT.0)THEN
        L    =MO(I)
        MO(I)=MO(K)
        MO(K)=L
      ENDIF
   90 CONTINUE
   91 KK=0
      LL=0
      DO 94 I=9,MI(8)
      IF(I.EQ.MI(36)+1) KK=0
      IF (MI(39)+MI(40).EQ.0) GOTO 94
C
C *** CALCULATE INTERATOMIC DISTANCES AND ANGLES ***
C
      J=I
      LOG=J.GT.MI(36)
      IF (LOG.AND.LOG2) GOTO 95
      LOG4=IABS(IYA(1,I)/IYAQ1).EQ.IABS(IYA(1,I-1)/IYAQ1)
      LOG=LOG4.OR.LOG
      DO 203 JJ=1,5
      IF(IABS(IYA(1,I)/IYAQ).EQ.IFIX(YP(JJ,1)))THEN
        IF(.NOT.LOG4) KK=KK+1
        IF(LOG.AND.IYA(1,I).LE.0) GOTO 94
        LL=LL+1
C MODIF ALB: no more than 1000 zarbi polyhedra
      IF(LL.GT.1000)WRITE(6,1050)
      IF(LL.GT.1000)STOP
C
        MV(LL,13)=I
        MV(LL,14)=KK
        GOTO 207
      ENDIF
  203 CONTINUE
  207 IF (.NOT.LOG)THEN
        CALL UNPACK(J)
        WRITE (IO2,1008) J,MH(1),MH(2),MH(3)
      ENDIF
      CALL ANDI(J,II,NN,LOG)
*BER**
      IF(LL.EQ.0) GOTO 208
      IF(MV(LL,13).EQ.I)THEN
        CALL FIND(LL,NN,JJ,LOG)
        GOTO 94
      ENDIF
208   CONTINUE
C
C *** SEARCH POLYHEDRA ***
C
      IF (IYA(1,I)     .LE.0. ) GOTO 94
      IF (IYA(1,I)/IYAQ.EQ.459) GOTO 94
      IF (IYA(1,I)/IYAQ.EQ. 81) GOTO 94
      CALL SEARCH(J,II)
C
   94 CONTINUE
C
   95 IF ((MI(37)+LL).GT.0)CALL WRITE(LL)
C
C  MODIF ALB
        WRITE(6,961)
961     FORMAT(' Do you want .HGL and .XYZ output (Yes=0/No=1) ?')
        READ(5,*)ITEST
	IF(ITEST.EQ.1) STOP
      INQUIRE(FILE='struplo.xyz',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2011
      CALL FILEDEL(9,'struplo.xyz')
2011  OPEN (9,FILE='struplo.xyz',STATUS='NEW')
      INQUIRE(FILE='struvir.hgl',EXIST=QEX)
      IF(QEX.EQ..FALSE.) GO TO 2012
      CALL FILEDEL(IO4,'struvir.hgl')
2012  OPEN (IO4,FILE='struvir.hgl',STATUS='NEW')
C
      YB(14)=ABS(YB(10)-YB(11))
      YB(15)=ABS(YB(12)-YB(13))
      YB(16)=YB(14)*0.5
      YB(17)=YB(15)*0.5
      YB(18)=(YB(10)+YB(11))*0.5
      YB(19)=(YB(12)+YB(13))*0.5
      IF (MI(46).LE.0)GO TO 109
C
C *** GENERATE PLOT ***
C
C
C *** SET FRAME ***
C
      PA1=MAX(PA1,AR1)
      PA2=MAX(PA2,AR2)
*BER  CALL FRAME(PA1,PA2)
C     CALL PLOT(0.0,0.0,3)
C     CALL PLOT(AR1,0.0,2)
C     CALL PLOT(AR1,AR2,2)
C     CALL PLOT(0.0,AR2,2)
C     CALL PLOT(0.0,0.0,2)
C
C *** PLOT TITLE ***
C
*BER  IF(TIT.NE.' ')THEN
*BER    CALL SYMBOL(1.,PA2-.7,0.4,TIT,0.,40)
*BER    AR2=MIN(AR2,PA2-1.)
*BER  ENDIF
C
C *** CALCULATE SCALE FACTOR ***
C
C     YC(75)=AMIN1(AR1/YB(14),AR2/YB(15))*FAC*0.9
      YC(75)=AMIN1(AR1/YB(14),AR2/YB(15))*FAC
      C75=AMIN1(1024./YB(14),750./YB(15))*FAC*0.9
      YC(77)=PA1*0.5
      YC(78)=PA2*0.5
C
*BER**WRITE SCALE FACTOR TO STRUPLO.XYZ******
      WRITE(9,7771) YC(75)   
7771  FORMAT(F10.4)
***************************************************
C  
      WRITE (IO3,1016) PA1,PA2,YC(75),YC(77)+OR1,YC(78)+OR2,
     * (YB(10)-YB(18))*YC(75),(YB(11)-YB(18))*YC(75),
     * (YB(12)-YB(19))*YC(75),(YB(13)-YB(19))*YC(75),
     *  YB(14)        *YC(75), YB(15)        *YC(75)
C
*BER**Titel, Frame auf Datei 9 schreiben****************
       WRITE(9,1030) TIT
       WRITE(9,1031) YC(77),YC(78)
1030   FORMAT(A80)
1031   FORMAT(2(F10.4,1X))
**********************************************************************
C
C *** SET ORIGIN ***
C
*     CALL PLOT(YC(77)+OR1,YC(78)+OR2,-3)
C
C *** SET SCALE FACTOR
C
*BER  CALL FACTOR(YC(75))
C
C *** START PLOT ***
C
*BER  CALL TIMER(1,LAST_TIMER)
      CALL DRAW
*BER  CALL TIMER(2,LAST_TIMER)
*BER  CALL TIMOUT
      CLOSE (IO1)
      CLOSE (IO2)
      CLOSE (IO5)
      CLOSE (IO7)
*BER**Datei 9 schlieaen**********************************************
      CLOSE (9)
C     close (1)
*********************************************************************
*BER  CALL FINISH
  109 CALL HPOFF
      STOP
 1000 FORMAT (///,1X,'DEFAULT RANGE FOR GENERATING ATOMS IS X:',F8.4,1X,
     &'TO',F7.4,/,39X,'Y:',F8.4,' TO',F7.4,/,39X,'Z:',F8.4,' TO',F7.4)
C1001 FORMAT (2A1,I2,5X,3F10.5)
 1002 FORMAT (2A1,I2,26X,3F10.6)
 1003 FORMAT (2A1,I2,3F10.6)
 1004 FORMAT (80A1)
 1005 FORMAT ('(',I4,')',1X,2A1,I3,3F10.5,1X,3F10.5)
 1006 FORMAT ('(',I4,')',1X,2A1,I3,3F10.5,1X,3F10.5,1X,'NOT G.')
 1007 FORMAT ('NO',6X,'ATOM',3X,'X/A',7X,'Y/B',7X,'Z/C',8X,'XO',8X,
     &'YO',8X,'ZO',/,'--------------------------------------------------
     &-----------------------------')
 1008 FORMAT (///,1X,'DISTANCES TO ATOM (',I4,')',1X,2A1,I2,//,3X,'NO',
     &5X,'NAME',10X,'DIST.'/,1X,'-----------------------------')
 1009 FORMAT (///,1X,'ORIGIN SPECIFICATION',//)
 1010 FORMAT (///,1X,'FRACTIONAL AND ORTHOGONAL COORDINATES OF ATOMS INS
     &IDE THE UNIT CELL',//)
 1011 FORMAT (///,1X,'FRACTIONAL AND ORTHOGONAL COORDINATES OF ATOMS OUT
     &SIDE THE UNIT CELL',//)
 1013 FORMAT (///,1X,'GIVEN RANGE FOR GENERATING ATOMS IS X:',F8.4,1X,
     &'TO',F7.4,/,37X,'Y:',F8.4,' TO',F7.4,/,37X,'Z:',F8.4,' TO',F7.4)
 1014 FORMAT (///,1X,'THE CRYSTAL STRUCTURE IS CENTROSYMMETRIC WITH CENT
     &RE IN THE ORIGIN')
 1015 FORMAT (///,1X,'THERE IS NO CENTRE IN THE ORIGIN OF THE CRYSTAL ST
     &RUCTURE')
 1016 FORMAT (///' THE PLOT IS SCALED INTO A FRAME OF X=',F8.2,
     *'CM AND Y=',F8.2,'CM'/
     *' THE SCALE FACTOR IS:',F7.3/
     *' THE ORIGIN IS SHIFTED TO X=',F7.2,'CM AND Y=',F7.2,'CM'//
     *' PARAMETERS AFTER SCALING ARE:'/
     *' MINIMUM AND MAXIMUM VALUES IN X=',F6.2,'CM AND',F6.2,'CM'/
     *' MINIMUM AND MAXIMUM VALUES IN Y=',F6.2,'CM AND',F6.2,'CM'/
     *' LENGTH AND WIDTH OF THE DRAWING ARE X=',F7.2,'CM AND Y=',F7.2)
 1050 FORMAT ('  No more than 1000 bizarre polyhadra is allowed')
C1017 FORMAT (1X,'4 ',I1,';')
C1018 FORMAT (1X,'ONLY 3000 ATOMS CAN BE REPRESENTED AS CIRCLES, JOB IS
C    &TERMINATED')
C1020 FORMAT (1X,'VS ',F4.2,';')
C1026 FORMAT (1X,4(I6,' '))
C1027 FORMAT (1X,4(I4,' '))
C1028 FORMAT (1X,5(I6,' '))
      END
*BER**Function AMAX1 und AMIN1 definieren****************************
*
      FUNCTION AMAX1(WERT1,WERT2)
      IF(WERT1.GT.WERT2) THEN
        AMAX1=WERT1
      ELSE
        AMAX1=WERT2
      ENDIF
      RETURN
      END
*
      FUNCTION AMIN1(WERT1,WERT2)
      IF(WERT1.LT.WERT2) THEN
        AMIN1=WERT1
      ELSE
        AMIN1=WERT2
      ENDIF
      RETURN
      END
*********************************************************************
      SUBROUTINE ANDI(I,II,L,LOG)
      EQUIVALENCE (YC36,YC(36))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(106),YZ(100,5),
     *YE(200,5),MH(20),MI(11198),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      LOGICAL LOG
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
C
      L=0
      MH(17)=MH(1)
      MH(18)=MH(2)
      MH(19)=MH(3)
      DO 4 J=9,MI(8)
      IF (IYA(1,J).LE.0 .AND. LOG) GOTO 4
      IF (J.EQ.I) GO TO 4
      DO 3 K=2,4
    3 IF (ABS(YA(K,I)-YA(K,J)).GT.YC(89)) GOTO 4
      L=L+1
      YZ(L,1)=FLOAT(J)
      YZ(L,2)=YA(2,I)-YA(2,J)
      YZ(L,3)=YA(3,I)-YA(3,J)
      YZ(L,4)=YA(4,I)-YA(4,J)
      YZ(L,5)=SQRT(YZ(L,2)*YZ(L,2)+
     *             YZ(L,3)*YZ(L,3)+
     *             YZ(L,4)*YZ(L,4))
      IF (YZ(L,5).GT.YC(89)) L=L-1
    4 CONTINUE
      II=0
      CALL SORT1(L)
      IF (LOG) GOTO 6
      DO 5 I1=1,L
      I2=I1
      MH(13)=IFIX(YZ(I1,1))
      CALL UNPACK(MH(13))
    5 WRITE (IO2,1001) MH(13),(MH(I2),I2=1,3),YZ(I1,5)
      WRITE (IO2,1002) I,MH(17),MH(18),MH(19)
    6 DO 13 J=1,L-1
      IF (YZ(J,5).GT.YC(90)) GO TO 13
      DO 12 K=J+1,L
      IF (YZ(K,5).GT.YC(90)) GO TO 13
      II=II+1
      YE(II,1)=YZ(J,1)
      YE(II,2)=YZ(K,1)
      MH(8)=IFIX(YE(II,2))
      CALL UNPACK(MH(8))
      MH(4)=MH(1)
      MH(5)=MH(2)
      MH(6)=MH(3)
      MH(7)=IFIX(YE(II,1))
      CALL UNPACK(MH(7))
      IF (ABS(YZ(J,5)*YZ(K,5)).GE.1E-8)THEN
        ARCO=(YZ(J,2)*YZ(K,2)+YZ(J,3)*YZ(K,3)+YZ(J,4)*YZ(K,4))/
     &  (YZ(J,5)*YZ(K,5))
        IF(ARCO.GT. 1.)ARCO= 1.
        IF(ARCO.LT.-1.)ARCO=-1.
      ELSE
        ARCO=1.
        WRITE (IO3,1003)
      ENDIF
      YE(II,3)=ACOS(ARCO)*YC36
      YE(II,4)=YZ(J,5)
      YE(II,5)=YZ(K,5)
      IF (LOG) GOTO 12
      YB(1)=SQRT((YA(2,MH(7))-YA(2,MH(8)))**2+
     *           (YA(3,MH(7))-YA(3,MH(8)))**2+
     *           (YA(4,MH(7))-YA(4,MH(8)))**2)
C MODIF ALB : T format gave problems on my PC...
C     WRITE (IO2,1004) (MH(I1),I1=1,8) , (YE(II,I1),I1=3,5) , YB(1)
      WRITE (IO2,1004)MH(7),MH(1),MH(2),MH(3),MH(8),MH(4),MH(5),MH(6),
     &(YE(II,I1),I1=3,5) , YB(1)
C
      IF(IYA(1,IFIX(YE(II,1))).LT.0 .OR.
     *   IYA(1,IFIX(YE(II,2))).LT.0) II=II-1
   12 CONTINUE
   13 CONTINUE
      RETURN
 1001 FORMAT (1X,'(',I4,')',3X,2A1,I3,5X,F10.5)
 1002 FORMAT (///,1X,'DISTANCES AND ANGLES AROUND CENTRAL ATOM CA (',I4,
     &')',1X,2A1,I2,//,3X,'ATOM 1',13X,'ATOM 2',7X,'ANGLE',6X,'A1-CA',5X
     &,'A2-CA',5X,'A1-A2',/,'-------------------------------------------
     &-----------------------------')
 1003 FORMAT (' !!! WARNING !!! THE ARGUMENT IN ACOS IS GREATER THAN',
     *' 1., THE ANGLE IS SET TO 0.0,'/
     *' CHECK DISTANCE TABLE FOR DOUBLE ENTRY')
C 1004 FORMAT (1X,T1,'(',T8,2A1,I2,T20,'(',T27,2A1,I2,T2,I4,')'
C     &,T21,I4,')',T14,'-CA-',T34, 4F10.5)
 1004 FORMAT (1X,'(',I4,')',1X,2A1,I2,2X,'-CA-',2X,'(',I4,')',
     &2A1,I2,4X,4F10.5)
      END
C-----------------------------------------------------------------------
      SUBROUTINE ZERO
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(1626),MI(104),MM(226),
     *MZ2(10844),MZ(24),MU(14735),IO1,IO2,IO3,IO4
      DIMENSION IYA(4,6000)
      EQUIVALENCE(IYA,YA)
      CHARACTER MM*4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      COMMON/BZR/BX
      INTEGER BX(27)
      CHARACTER TIT*40,BL*4
      DO 1 I=1,14735
1     MU(I)=0
      DO 2 I=1,300
2     MZ2(I)=0
      DO 3 I=301,7844
3     MZ2(I)=-1
      DO 4 I=7845,10844
4     MZ2(I)=0
      DO 5 I=1,4
      DO 5 J=1,6000
5     YA(I,J)=0.
      YA(1,1)=439010.
      YA(1,2)=439020.
      YA(2,2)=1.
      YA(1,3)=439030.
      YA(3,3)=1.
      YA(1,4)=439040.
      YA(4,4)=1.
      YA(1,5)=439050.
      YA(2,5)=1.
      YA(3,5)=1.
      YA(1,6)=439060.
      YA(2,6)=1.
      YA(4,6)=1.
      YA(1,7)=439070.
      YA(3,7)=1.
      YA(4,7)=1.
      YA(1,8)=439080.
      YA(2,8)=1.
      YA(3,8)=1.
      YA(4,8)=1.
      RETURN
      END
      BLOCK DATA
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(1626),MI(104),MM(226),
     *MZ2(10844),MZ(24),MU(14735),IO1,IO2,IO3,IO4
      DIMENSION IYA(4,6000)
      EQUIVALENCE(IYA,YA)
      CHARACTER MM*4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      COMMON/BZR/BX
      INTEGER BX(27)
      CHARACTER TIT*40,BL*4
      DATA ID,PA1,PA2,AR1, AR2, OR1,OR2,RES,FAC,NRES,IBUR
     *     /1, 0., 0.,28.8,21.6,0., 0.,.01, 1.,  0,  1/
      DATA PP/10*-1E30/,NH/1,49*0,3000,49*0,9,49*0/,IS/1/
      DATA BL/'    '/
*BER  DATA (IYA(1,I),I=1,8)/439010,439020,439030,439040,
*BER *                      439050,439060,439070,439080/
      DATA YP/70*0./
      DATA YB/3*0.,1.,3*0.,1.,3*0.,1.,12*0.,1E30/
      DATA YC/6*-1E30,109.,20.,1.62,0.2,15.,3*0.,90.,20.,1.97,0.4,15.,
     &3*0.,3*10.,3*90.,6*-1.,1.745329E-02,57.29578,1.,0.,0.,1.,0.,
     &2*1.,0.,0.,1.,0.,1.,3*0.,1.,3*0.,1.,3*0.,3*1.,0.,1.,0.,1.,0.,5*1.,
     &28.8,18.7,1.,100.,40.,15.,10*1.,3.2,4.,
     &30*-1E30,154*0.,1.,191*0.,1.,191*0.,1.,967*0./
      DATA MI/3*0,2*1,2*0,8,4,156,356,13*0,4403,8*0,1,4*0,3*1,2*0,1,0,
     &3*1,4*2,4*7,2*2,3,2,2*3,4,5,2*3,5,4,2*3,2*4,5,4,2*6,4,5,2*6,4,3*5,
     &20*1/
      DATA MM/' ','+','0','1','2','3','4','5','6','7','8','9','.','-',
     &';',',','(',')','P','I','F','C','B','A','R','D','E','G','H','J',
     &'K',
     &'L','M','N','O','Q','S','T','U','V','W','X','Y','Z','TI','CE','SY'
     &,'SP','FO','AD','OM','RO','TE','OC','CI','XY','BO','EN','PA','FI',
     &'MO','VI','SH','CO','PE','BZ',4*'  ',156*' '/
      DATA MZ/1,2,5,3,1,4,6,8,7,2,5,3,2,5,3,1,4,6,8,7,4,6,8,7/
      DATA IO1,IO2,IO3,IO4/3,4,6,7/
      DATA CR/'(C) REINHARD X. FISCHER 1986'/
      DATA BX/27*0/
      END
C-----------------------------------------------------------------------------
      SUBROUTINE BURZ (ISYSTM,ISYMCE,IBRAVL,NG,SS,TS,NT)
C-----ROUTINE TO INTERPRET HERMANN MAUGUIN SYMBOL FOR SPACE GROUP
C-----THIS ROUTINE HAS BEEN ADAPTED FROM A PROGRAM SUPPLIED BY
C-----PROF. BURZLAFF, UNIVERSITY OF ERLANGEN, GERMANY
C     COMMON /POSIT/ RN,RD,S1,S2,S3,NT
      INTEGER E(3,3),ZEI(3,4),SS(24,3,3),SYS
      DIMENSION NT(76), IBRA(7), NMA(3), SH(3)
C     DIMENSION RN(3), RD(3), S1(3), S2(3), S3(3)
      DIMENSION TS(24,3), TE(3)
      DIMENSION ISYS(7)
      INTEGER N3(20)
      DATA ISYS/7,1,2,4,6,5,3/
      DATA IBRA/'P','A','B','C','F','I','R'/,NMA/3*0/,SH/3*0.25/
      DATA N3/'1','2','3','4',' ','6','A','B','C','D','M','N','P',
     1        ' ','/','-',4*' '/
C     WRITE (6,6020) NT
C6020 FORMAT(1X,76A1)
 1    NBL=-1
      NG=1
      NS=1
      DO 2 I=1,24
      DO 2 J=1,3
      TS(I,J)=0.0
      DO 2 K=1,3
      E(J,K)=0
      SS(I,J,K)=0
 2    CONTINUE
      SS(1,1,1)=1
      SS(1,2,2)=1
      SS(1,3,3)=1
      DO 3 I=1,3
      TE(I)=0.0
      DO 3 J=1,4
 3    ZEI(I,J)=0
      DO 8 I=1,36
      KXK=NT(I)
      IF (KXK.NE.N3(17)) GO TO 4
      NLQ=0
      IC=0
      GO TO 8
 4    IF (NBL.GE.0) GO TO 7
      DO 5 J=1,7
      NBR=J
C     WRITE(6,6004) KXK
C6004 FORMAT(1X,'BRAVAIS=',1X,A1)
      IF (KXK.EQ.IBRA(J)) GO TO 6
 5    CONTINUE
      NBR=8
 6    NBL=0
      IBRAVL=NBR
C     WRITE(6,6003) IBRAVL
C6003 FORMAT(1X,'BRAVAIS =',I3)
      GO TO 8
 7    IF (NLQ.EQ.0) NBL=NBL+1
      IC=IC+1
      ZEI(NBL,IC)=KXK
      NLQ=1
      IF (KXK.EQ.N3(15)) NS=0
 8    CONTINUE
      DO 9 I=1,4
      IF (ZEI(2,I).NE.N3(3)) GO TO 9
      SYS=6
      GO TO 15
 9    CONTINUE
      DO 11 I=1,4
      IF (ZEI(1,I).NE.N3(3).AND.ZEI(1,I).NE.N3(6)) GO TO 10
      SYS=5
      GO TO 15
 10   IF (ZEI(1,I).NE.N3(4)) GO TO 11
      SYS=4
      GO TO 15
 11   CONTINUE
      IF (NBL.GT.1) GO TO 14
      IF (ZEI(1,1).NE.N3(1).AND.ZEI(1,1).NE.N3(16)) GO TO 12
      SYS=1
      GO TO 15
 12   SYS=2
      DO 13 I=1,4
 13   ZEI(2,I)=ZEI(1,I)
      ZEI(1,1)=N3(1)
      ZEI(3,1)=N3(1)
 14   SYS=3
      IF (ZEI(1,1).EQ.N3(1).OR.ZEI(2,1).EQ.N3(1)) SYS=2
 15   GO TO (16,17,22,46,58,68), SYS
C-----TRICLINIC
 16   IF (ZEI(1,1).EQ.N3(16)) NS=0
      GO TO 76
C-----MONOCLINIC
 17   NG=2
      DO 18 I=1,3
 18   IF (ZEI(I,1).NE.N3(1)) IND=I
      ID=1
      IF (ZEI(IND,1).EQ.N3(2)) ID=-1
C     WRITE(6,6000) ID,IND
C6000 FORMAT(1X,'ID= ',I3,' IND= ',I3)
      DO 19 I=1,3
 19   SS(2,I,I)=SS(1,I,I)*ID
C     WRITE(6,6001) SS(2,3,3)
C6001 FORMAT(1X,'SS(2,3,3)=',F10.1)
      SS(2,IND,IND)=-SS(2,IND,IND)
C     WRITE(6,6001) SS(2,IND,IND)
      DO 21 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(2,I)=0.5
      DO 21 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(2,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(2,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(2,3)=0.5
      IF (ZEI(I,J).EQ.N3(12)) GO TO 20
      GO TO 21
 20   K=I+1
      IF (K.GT.3) K=K-3
      TS(2,K)=0.5
      TS(2,6-K-I)=0.5
 21   CONTINUE
      GO TO 76
C-----ORTHORHOMBIC
 22   NG=4
      IC=0
      IND=1
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(2,1).NE.N3(2).AND.ZEI(3,1).NE.N3(2))
     1IND=-1
      IF (IND.EQ.-1) NS=0
      DO 24 I=1,3
      ID=1
      IF (ZEI(I,1).EQ.N3(2)) ID=-1
      DO 23 J=1,3
 23   SS(1+I,J,J)=SS(1,J,J)*ID*IND
 24   SS(1+I,I,I)=-SS(1+I,I,I)
      DO 28 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(1+I,I)=0.5
      DO 28 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(1+I,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(1+I,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(1+I,3)=0.5
      IF (ZEI(I,J).EQ.N3(12).OR.ZEI(I,J).EQ.N3(10)) GO TO 25
      GO TO 28
 25   K=I+1
      IF (K.GT.3) K=K-3
      IF (ZEI(I,J).EQ.N3(10)) GO TO 26
      TS(1+I,K)=0.5
      TS(1+I,6-K-I)=0.5
      GO TO 28
 26   IC=1
      IF (NS.EQ.1) GO TO 27
      TS(1+I,K)=0.25
      TS(1+I,6-K-I)=0.25
      GO TO 28
 27   TS(1+I,1)=0.25
      TS(1+I,2)=0.25
      TS(1+I,3)=0.25
 28   CONTINUE
      IF (IC.EQ.1) GO TO 76
      IF (NS.EQ.1) GO TO 36
      DO 29 I=1,3
      K=1+I
      IF (K.GT.3) K=K-3
      TC=TS(1+K,I)+TS(1+6-I-K,I)
      IF (TC.EQ.1.0) TC=0.0
 29   TS(1+I,I)=TC
C-----SPECIAL TREATMENT OF C M M A, C M C A, I M M A
      IF (NBR.EQ.1.OR.NBR.EQ.5) GO TO 76
      MA=0
      DO 31 I=1,3
      DO 30 J=1,4
 30   IF (ZEI(I,J).EQ.N3(11)) NMA(I)=1
 31   MA=MA+NMA(I)
      IF (NBR.EQ.6.AND.MA.EQ.2) GO TO 33
      IF (MA.EQ.0.OR.MA.EQ.3.OR.NBR.EQ.6) GO TO 76
      DO 32 I=1,3
      IF (NMA(NBR-1).EQ.1) GO TO 76
 32   SH(NBR-1)=0.
C-----ORIGIN SHIFT
 33   DO 35 I=1,NG
      DO 35 J=1,3
      DO 34 K=1,3
      ID=1
      IF (J.NE.K) ID=0
 34   TS(I,J)=TS(I,J)+(ID-SS(I,J,K))*SH(K)
      IF (TS(I,J).GT.1.) TS(I,J)=TS(I,J)-1.
 35   IF (TS(I,J).LT.1.0) TS(I,J)=TS(I,J)+1.
      GO TO 76
 36   IC=0
      DO 37 I=1,3
 37   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.-1) IC=1
      IF (IC.EQ.1) GO TO 41
      TC=TS(2,1)+TS(3,2)+TS(4,3)
      IF (TC.EQ.0.0) GO TO 76
      DO 40 I=1,3
      K=I+1
      IF (K.GT.3) K=K-3
      IF (TC.GT.0.5) GO TO 38
      IF (TS(1+I,I).EQ.0.0) GO TO 40
      M=I-1
      IF (M.EQ.0) M=M+3
      TS(1+M,I)=0.5
      GO TO 40
 38   IF (TC.GT.1.0) GO TO 39
      IF (TS(1+I,I).NE.0.0) GO TO 40
      L=K+1
      IF (L.GT.3) L=L-3
      TS(1+K,L)=0.5
      TS(1+L,K)=0.5
      GO TO 40
 39   TS(1+I,K)=0.5
 40   CONTINUE
      GO TO 76
 41   DO 42 I=1,3
 42   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.1) ID=I
      DO 45 I=1,3
      TC=TS(2,I)+TS(3,I)+TS(4,I)
      IF (TC.EQ.0.0.OR.TC.EQ.1.0) GO TO 45
      IF (ZEI(1,1).EQ.N3(11).AND.ZEI(2,1).EQ.N3(12).OR.ZEI(2,1).EQ.
     1N3(11).AND.ZEI(3,1).EQ.N3(12).OR.ZEI(3,1).EQ.N3(11).AND.ZEI(1,1)
     2.EQ.N3(12)) GO TO 44
      DO 43 J=1,3
      IF (ID.EQ.J) GO TO 43
      IF (TS(1+J,I).EQ.0.5) GO TO 43
      TS(1+J,I)=0.5
 43   CONTINUE
      GO TO 45
 44   K=I-1
      IF (K.EQ.0) K=K+3
      TS(1+K,I)=0.5
 45   CONTINUE
      GO TO 76
C-----TETRAGONAL
 46   NG=4
      IF (NBL.EQ.3) NG=8
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      M=ZEI(1,1)
      N=ZEI(1,2)
      DO 47 I=1,3
      DO 47 J=1,3
 47   IF (M.EQ.N3(16)) SS(2,I,J)=-SS(2,I,J)
      IF (M.EQ.N3(16)) GO TO 50
      IF (N.EQ.N3(1)) TS(2,3)=0.25
      IF (N.EQ.N3(2)) TS(2,3)=0.5
      IF (N.EQ.N3(3)) TS(2,3)=0.75
      IF (ZEI(1,3).EQ.N3(12).OR.(ZEI(1,4).EQ.N3(12).AND.NBL.EQ.3))
     1TS(2,1)=0.5
      IF ((ZEI(1,4).EQ.N3(12).AND.NBL.EQ.1).OR.(N.EQ.N3(1).AND.NS.EQ.1.
     1AND.NBR.EQ.6)) TS(2,2)=0.5
      IF (N.EQ.N3(1).AND.NS.EQ.0.AND.NBR.EQ.6) GO TO 48
      IF (ZEI(2,2).EQ.N3(1).OR.(ZEI(1,4).NE.N3(12).AND.ZEI(2,1).EQ.
     1N3(12).AND.ZEI(3,1).EQ.N3(11))) GO TO 49
      GO TO 50
 48   TS(2,1)=0.25
      TS(2,2)=0.75
      IF (NBL.EQ.1) TS(2,1)=0.75
      IF (NBL.EQ.1) TS(2,2)=0.25
      GO TO 50
 49   TS(2,1)=0.5
      TS(2,2)=0.5
 50   SS(3,1,1)=-1
      SS(3,2,2)=-1
      SS(3,3,3)=1
      TS(3,1)=SS(2,1,2)*TS(2,2)+TS(2,1)
      TS(3,2)=SS(2,2,1)*TS(2,1)+TS(2,2)
      TS(3,3)=SS(2,3,3)*TS(2,3)+TS(2,3)
      DO 51 I=1,3
 51   IF (NBR.EQ.6.AND.TS(3,1).EQ.0.5.AND.TS(3,2).EQ.0.5.AND.TS(3,3).EQ.
     10.5) TS(3,I)=0.0
      DO 52 I=1,3
      TS(4,I)=TS(2,I)
      DO 52 J=1,3
      TS(4,I)=TS(4,I)+SS(2,I,J)*TS(3,J)
      DO 52 K=1,3
 52   SS(4,I,J)=SS(4,I,J)+SS(2,I,K)*SS(3,K,J)
      IF (NBL.EQ.1) GO TO 76
      IF (NS.EQ.0) GO TO 56
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.NE.N3(2).AND.N.NE.N3(2)) GO TO 55
      IF (M.EQ.N3(2).AND.N.EQ.N3(2)) GO TO 54
      IF (M.EQ.N3(2)) GO TO 53
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.NE.N3(12).AND.M.NE.N3(8)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 53   E(1,1)=1
      E(2,2)=-1
      E(3,3)=-1
      IF (N.EQ.N3(9)) TE(3)=0.5
      IF (N.EQ.N3(10)) TE(3)=0.25
      IF (N.EQ.N3(10)) TE(2)=0.5
      IF (ZEI(2,2).NE.N3(1)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 54   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      IF (ZEI(2,2).NE.0.OR.NBR.EQ.6.OR.ZEI(1,2).EQ.0) GO TO 57
      IF (ZEI(1,2).EQ.N3(1)) TE(3)=0.75
      IF (ZEI(1,2).EQ.N3(2)) TE(3)=0.5
      IF (ZEI(1,2).EQ.N3(3)) TE(3)=0.25
      GO TO 57
 55   M=ZEI(2,1)
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(1)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(2)=0.5
      GO TO 57
 56   E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (ZEI(2,1).EQ.N3(9).OR.ZEI(2,1).EQ.N3(12)) TE(3)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(2)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(1)=0.5
      IF (ZEI(1,3).EQ.N3(12).OR.ZEI(1,4).EQ.N3(12)) TE(1)=TE(1)+0.5
 57   NE=4
      GO TO 74
C-----HEXAGONAL
 58   NG=3
      M=ZEI(1,1)
      N=ZEI(1,2)
      IF (M.EQ.N3(16).AND.N.EQ.N3(3)) NS=0
      IF (M.EQ.N3(6)) GO TO 61
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,2,2)=-1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/3.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/3.0
      SS(3,1,1)=-1
      SS(3,2,1)=-1
      SS(3,1,2)=1
      SS(3,3,3)=1
      TS(3,3)=2.0*TS(2,3)
      IF (TS(3,3).GE.1.0) TS(3,3)=TS(3,3)-1.0
      IF (NBL.EQ.1.AND.N.NE.N3(6)) GO TO 76
      IF (N.NE.N3(6)) GO TO 60
      NG=NG+NG
      DO 59 I=1,3
      DO 59 J=1,3
      DO 59 K=1,3
      SS(3+I,J,K)=SS(I,J,K)
 59   SS(3+I,3,3)=-1
 60   IF (NBL.EQ.1) GO TO 76
      IF (ZEI(2,1).NE.N3(9).AND.ZEI(3,1).NE.N3(9)) GO TO 63
      TS(4,3)=0.5
      TS(5,3)=0.5
      TS(6,3)=0.5
      GO TO 63
 61   NG=NG+NG
      SS(2,1,1)=1
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/6.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/6.0
      IF (N.EQ.N3(3)) TS(2,3)=3.0/6.0
      IF (N.EQ.N3(4)) TS(2,3)=4.0/6.0
      IF (N.EQ.N3(5)) TS(2,3)=5.0/6.0
      DO 62 I=1,4
      DO 62 J=1,3
      TS(2+I,J)=TS(2,J)
      DO 62 K=1,3
      TS(2+I,J)=TS(2+I,J)+SS(2,J,K)*TS(1+I,K)
      IF (TS(2+I,J).GT.1.0) TS(2+I,J)=TS(2+I,J)-1.0
      DO 62 L=1,3
 62   SS(2+I,J,K)=SS(2+I,J,K)+SS(2,J,L)*SS(1+I,L,K)
      IF (NBL.EQ.1) GO TO 76
 63   NG=NG+NG
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.EQ.N3(1)) GO TO 65
      IF (M.EQ.N3(2)) GO TO 64
      E(1,2)=-1
      E(2,1)=-1
      E(3,3)=1
      IF (M.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 64   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
C-----GROUP P 31 I 2 AND P 32 I 2
      IF (ZEI(1,1).EQ.N3(3).AND.(ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.
     1N3(2))) TE(3)=0.
      GO TO 67
 65   IF (N.EQ.N3(2)) GO TO 66
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (N.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 66   E(1,2)=-1
      E(2,1)=-1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
      IF (TE(3).GT.1.0) TE(3)=TE(3)-1.0
 67   NE=6
      IF (ZEI(1,1).EQ.N3(3).OR.(ZEI(1,2).EQ.N3(3).AND.ZEI(1,1).EQ.
     1N3(16))) NE=3
      GO TO 74
C-----CUBIC
 68   NG=12
      IF (NBL.EQ.3) NG=24
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(1,1).NE.N3(4).AND.ZEI(1,1).NE.
     1N3(16)) NS=0
      DO 69 I=1,3
      DO 69 J=1,3
      SS(1+I,J,J)=1
      IF (I.EQ.J) GO TO 69
      SS(1+I,J,J)=-1
      IF (ZEI(1,1).EQ.N3(12)) TS(1+I,J)=0.5
      IF (ZEI(1,1).EQ.N3(10)) TS(1+I,J)=0.25
 69   CONTINUE
      IF (ZEI(1,1).NE.N3(7).AND.ZEI(3,1).NE.N3(10).AND.ZEI(1,2).NE.N3(3)
     1.AND.ZEI(1,2).NE.N3(1).OR.NBR.EQ.5) GO TO 71
      DO 70 I=1,3
      TS(1+I,I)=0.5
      K=I+1
      IF (K.EQ.4) K=1
 70   TS(1+I,K)=0.5
 71   DO 72 I=1,4
      DO 72 J=1,3
      DO 72 K=1,3
      L=J+1
      IF (L.EQ.4) L=1
      M=J-1
      IF (M.EQ.0) M=3
      SS(4+I,J,K)=SS(I,L,K)
      SS(8+I,J,K)=SS(I,M,K)
      TS(4+I,J)=TS(I,L)
 72   TS(8+I,J)=TS(I,M)
      IF (NG.EQ.12) GO TO 76
      NE=12
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (ZEI(3,1).EQ.N3(2)) E(3,3)=-1
      IF (ZEI(3,1).EQ.N3(9)) TE(3)=0.5
      DO 73 I=1,3
      IF (ZEI(3,1).EQ.N3(12).OR.ZEI(1,2).EQ.N3(2)) TE(I)=0.5
 73   IF (ZEI(3,1).EQ.N3(10).OR.ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.N3(3))
     1TE(I)=0.25
      IF (ZEI(1,2).EQ.N3(1).AND.NBR.EQ.1) TE(1)=0.75
      IF ((ZEI(1,2).NE.N3(1).OR.NBR.NE.6).AND.(ZEI(1,2).NE.N3(3).OR.NBR
     1.NE.1)) GO TO 74
      TE(2)=0.75
      TE(3)=0.75
 74   DO 75 I=1,NE
      DO 75 J=1,3
      TS(NE+I,J)=TE(J)
      DO 75 K=1,3
      TS(NE+I,J)=TS(NE+I,J)+E(J,K)*TS(I,K)
      DO 75 L=1,3
 75   SS(NE+I,J,K)=SS(NE+I,J,K)+E(J,L)*SS(I,L,K)
 76   DO 81 I=1,NG
      DO 81 J=1,3
 77   IF (TS(I,J).GE.1.0) GO TO 78
      GO TO 79
 78   TS(I,J)=TS(I,J)-1.0
      GO TO 77
 79   IF (TS(I,J).LT.0.0) GO TO 80
      GO TO 81
 80   TS(I,J)=TS(I,J)+1.0
      GO TO 79
 81   CONTINUE
      ISYSTM=ISYS(SYS)
      ISYMCE=1-NS
C     WRITE(6,6010) ISYMCE,NG
C6010 FORMAT(' ISYMCE=',I3,' NG=',I3)
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE BZRR(JJ,II)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(106),YZ(100,5),
     *YE(200,5),MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/BZR/BX,BY,BZ
      INTEGER BY(13),BZ(4),BX(10)
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DIMENSION W(30)
C      LOGICAL IND
      LOGICAL LOG
      I=1
      IF(JJ.EQ.1) GOTO 41
      DO 42 I=1,JJ-1
      IF(DIST(MV(I,13)).LE.DIST(MV(JJ,13))) GOTO 42
      DO 43 M=1,14
      DO 44 K=JJ,I,-1
   44 MV(K+1,M)=MV(K,M)
      MV(I,M)=MV(JJ+1,M)
   43 MV(JJ+1,M)=0
      GOTO 41
   42 CONTINUE
   41 N=I
   45 W(27)=0
      W(28)=0
      W(29)=0
      DO 1 J=1,3
      W(27)=W(27)+YA(2,MV(N,J))*(1./3.)
      W(28)=W(28)+YA(3,MV(N,J))*(1./3.)
      W(29)=W(29)+YA(4,MV(N,J))*(1./3.)
    1 MU(MV(N,14),2,J)=J
      MU(MV(N,14),2,7)=3
      MU(MV(N,14),1,3)=1
      W(2)=YA(2,MV(N,13))
      W(3)=YA(3,MV(N,13))
      W(4)=YA(4,MV(N,13))
      DO 2 I=4,MIN(II,12)
      IF(MV(N,I).EQ.0) GOTO 37
      M=0
      W(5)=YA(2,MV(N,I))
      W(6)=YA(3,MV(N,I))
      W(7)=YA(4,MV(N,I))
      DO 3 J=2,MU(MV(N,14),1,3)+1
      DO 5 L=2,4
      W(1)=YA(L,MV(N,MU(MV(N,14),J,1)))
      DO 4 K=2,3
C *** W de 8 a 13 definis comme 2-1 et 3-1 ***
    4 W(3*K+L)=YA(L,MV(N,MU(MV(N,14),J,K)))-W(1)
      W(12+L)=W(3+L)-W(1)
      W(15+L)=W(25+L)-W(1)
    5 CONTINUE
      W(20)=W( 9)*W(13)-W(10)*W(12)
      W(21)=W(10)*W(11)-W( 8)*W(13)
      W(22)=W( 8)*W(12)-W( 9)*W(11)
C *** W(23) represente le det (2-1,3-1,i-1) ****
C *** W(24) represente le det avec le barycentre ***
      W(23)=W(20)*W(14)+W(21)*W(15)+W(22)*W(16)
      IF(MU(MV(N,14),1,3).NE.1) GOTO 202
      IF(ABS(W(23)).GE.1E-4) GOTO 203
      DO 300 K=1,MU(MV(N,14),J,7)
      L=MOD(K,MU(MV(N,14),J,7))+1
      M=MOD(K-2+MU(MV(N,14),J,7),MU(MV(N,14),J,7))+1
      DO 301 NN=2,4
      W(6+NN)=YA(NN,MV(N,MU(MV(N,14),J,L)))
     *       -YA(NN,MV(N,MU(MV(N,14),J,K)))
      W(9+NN)=YA(NN,MV(N,MU(MV(N,14),J,M)))
     *       -YA(NN,MV(N,MU(MV(N,14),J,K)))
  301 W(12+NN)=W(3+NN)-YA(NN,MV(N,MU(MV(N,14),J,K)))
      W(17)=W( 9)*W(13)-W(10)*W(12)
      W(18)=W(10)*W(11)-W( 8)*W(13)
      W(19)=W( 8)*W(12)-W( 9)*W(11)
      W(11)=W( 9)*W(16)-W(10)*W(15)
      W(12)=W(10)*W(14)-W( 8)*W(16)
      W(13)=W( 8)*W(15)-W( 9)*W(14)
      W(20)=W(17)*W(11)+W(18)*W(12)+W(19)*W(13)
      IF(W(20).LT.0) GOTO 302
  300 CONTINUE
      WRITE (IO3,*) 'impossible d inserer un atome a une face plate'
      STOP
  302 DO 303 M=MU(MV(N,14),J,7),L,-1
  303 MU(MV(N,14),J,M+1)=MU(MV(N,14),J,M)
      MU(MV(N,14),J,L)=I
      MU(MV(N,14),J,7)=MU(MV(N,14),J,7)+1
      MU(MV(N,14),1,2)=4
      GOTO 100
  203 DO 204 K=1,MU(MV(N,14),2,7)
  204 BX(K)=1
      BZ(1)=2
      CALL MERGE(MV(N,14))
      CALL SPLIT(MV(N,14),I,.TRUE.)
      GOTO 100
  202 IF(ABS(W(23)).LE.1E-4) GOTO 25
      W(24)=W(20)*W(17)+W(21)*W(18)+W(22)*W(19)
      W(23)=W(23)*W(24)
      IF(W(23).GE.0) GOTO 3
   25 M=M+1
      BZ(M)=J
    3 CONTINUE
      LOG=.FALSE.
      CALL MERGE(MV(N,14))
      IF(BY(11).NE.0) GOTO 747
      STOP
  747 DO 30 J=1,BY(11)
      K=MOD(J-2+BY(11),BY(11))+1
      L=MOD(J,BY(11))+1
      DO 31 M=2,4
      W(1  )=YA(M,MV(N,BY(J)))
      W(6+M)=YA(M,MV(N,BY(K)))-W(1)
      W(9+M)=YA(M,MV(N,BY(L)))-W(1)
   31 W(12+M)=W(3+M)-W(1)
      DO 35 M=2,4
   35 IF(ABS(W(9+M)-W(6+M)).GE.1E-8) GOTO 36
      W(30)=(W(5)-W(2))**2+(W(6)-W(3))**2+(W(7)-W(4))**2
      MU(MV(N,14),1,1)=IFIX(SQRT(W(30))*999)
      GOTO 37
   36 W(21)=W(9)*W(13)-W(10)*W(12)
      W(22)=W(10)*W(11)-W(8)*W(13)
      W(23)=W(8)*W(12)-W(9)*W(11)
      W(24)=W(21)*W(14)+W(22)*W(15)+W(23)*W(16)
      IF(ABS(W(24)).LE.1E-4) GOTO 32
      BX(J)=1
      GOTO 30
   32 W(24)=W( 9)*W(16)-W(10)*W(15)
      W(25)=W(10)*W(14)-W( 8)*W(16)
      W(26)=W( 8)*W(15)-W( 9)*W(14)
      W( 1)=W(21)*W(24)+W(22)*W(25)+W(23)*W(26)
      IF(W(1).GE.0) GOTO 30
      BX(J)=1
      BX(K)=1
C **** 34 remplace par 30 *******
   30 CONTINUE
      CALL SPLIT(MV(N,14),I,LOG)
  100 DO 50 K=1,10
   50 BX(K)=0
      DO 51 K=1,4
   51 BZ(K)=0
      DO 52 K=1,13
   52 BY(K)=0
      W(27)=((I-1)*W(27)+W(5))/I
      W(28)=((I-1)*W(28)+W(6))/I
      W(29)=((I-1)*W(29)+W(7))/I
    2 CONTINUE
   37 MU(MV(N,14),1,2)=I-1
      RETURN
      END
C-----------------------------------------------------------------------------
      SUBROUTINE CHECK(J)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(582),MF(600),MG(68),MI(48),
     *MK(36),ML(20),MM(70),MN(1000,8),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C      INTEGER L,KP,KN
CNOUSEINTEGER Z(28)
C
C *** CHECK OVERLAPS WITH POLYHEDRA ***
C
      MG( 4)=0
      MG( 5)=0
      MG(11)=0
      K=MG(1)
      IF(J.EQ.1) K=K-1
      IF(K.NE.0)THEN
        DO 3 I=1,K
        P=     PFAKT(MN(I,1))
        YB(4)=P*YA(2,MN(I,1))
        YB(5)=P*YA(3,MN(I,1))
        YB(7)=FLOAT(MN(I,8))*1E-3
        YB(8)=SQRT((YB(1)-YB(4))**2+(YB(2)-YB(5))**2)
        IF(YB(8)-YB(3).LT.YB(7))THEN
          MG(4)=MG(4)+1
          MC(MG(4))=I
        ENDIF
    3   CONTINUE
      ENDIF
C
C *** CHECK OVERLAPS WITH CIRCLES ***
C
      K=MG(2)
      IF (J.EQ.2) K=K-1
      IF (K.NE.0)THEN
        DO 6 I=1,K
        P=     PFAKT(MO(I))
        YB(4)=P*YA(2,MO(I))
        YB(5)=P*YA(3,MO(I))
        YB(7)=P*RAD (MO(I))
        YB(8)=SQRT((YB(1)-YB(4))**2+(YB(2)-YB(5))**2)
        IF(YB(8).LT.YB(3)+YB(7))THEN
          MG(5)=MG(5)+1
          MD(MG(5))=I
        ENDIF
    6   CONTINUE
      ENDIF
C
C *** CHECK OVERLAPS WITH BIZARRE POLYHEDRA ***
C
      K=MG(10)
      IF(J.EQ.3) K=K-1
      IF(K.NE.0)THEN
        DO 9 I=1,K
        P=     PFAKT(MV(I,13))
        YB(4)=P*YA(2,MV(I,13))
        YB(5)=P*YA(3,MV(I,13))
        YB(7)=P*FLOAT(MU(MV(I,14),1,1))*1E-3
        YB(8)=SQRT((YB(4)-YB(1))**2+(YB(5)-YB(2))**2)
        IF(YB(8)-YB(3).LT.YB(7))THEN
          MG(11)=MG(11)+1
          ME(MG(11))=I
        ENDIF
    9   CONTINUE
      ENDIF
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE CORTH
      COMMON/ALL1/YA(4,6000),YP(95),YC(90),YD(40),YY(1496),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      YD(4)=YC(37)*YD(1)
      YD(5)=YC(38)*YD(1)+YC(39)*YD(2)
      YD(6)=YC(40)*YD(1)+YC(41)*YD(2)+YC(42)*YD(3)
      RETURN
      END
      FUNCTION DIST(I)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(1651),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
      IF(YB(25).GT.1000.)THEN
        DIST=-YA(4,I)
      ELSE
        DIST=SQRT(YA(2,I)**2+YA(3,I)**2+(YA(4,I)-YB(25))**2)
      ENDIF
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE DRAW
      EQUIVALENCE (YC35,YC(35))
      EQUIVALENCE (YC36,YC(36))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(10,2),MM(70),MN(1000,8),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      CHARACTER TIT*40,BL*4
      INTEGER L,KL,KP,MA1(28)
      EQUIVALENCE (MA(1,1),MA1(1))
      LOGICAL LOG,IND
      DIMENSION TBSICO(91)
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
      PARAMETER (IYAQ=1000)
C
C *** OUTPUT DEV = XY-PLOTTER HP 7475
C
      CALL HPON
      VFT=AMIN1(11040./1024.,7721./750.)
C      PM3=PM3/VFT
C      PM4=PM4/VFT
      IPAPER=4
C      IF(PM1.GT.12000..OR.PM2.GT.8401.)IPAPER=3
      CALL PS(IPAPER)
      CALL SP(1)
      VIT=20.
      CALL VS(VIT)
C
C ************************************************************
C ***                                                      ***
C *** START MAIN ROUTINE FOR DRAWING CIRCLES AND POLYHEDRA ***
C ***                                                      ***
C ************************************************************
C
      DO 1 I=1,91
    1 TBSICO(I)=SIN(YC35*5.*FLOAT(I-37))
      MG(1)=0
      MG(2)=0
      MG(10)=0
      YD(23)=0.
      YD(24)=0.
      IF (MI(48).GT.0)THEN
        KL=1
        CALL NEWPEN(KL)
      CALL SP(KL)
        CALL OUTLIN
      ENDIF
      IF (MI(34).EQ.0)THEN
        DO 100 I=1,MI(37)-1
        DO 100 J=I+1,MI(37)
        DD=(YA(2,MN(I,1))-YA(2,MN(J,1)))**2+
     *     (YA(3,MN(I,1))-YA(3,MN(J,1)))**2+
     *     (YA(4,MN(I,1))-YA(4,MN(J,1)))**2
        IF (DD.LE.16.)THEN
          P=PFAKT(MN(I,1))
          XP=YA(2,MN(I,1))*C75+512.
          YPP=YA(3,MN(I,1))*C75+375.
          CALL PLOTHGL(XP,YPP,3)
          CALL PLOT(P*YA(2,MN(I,1)),P*YA(3,MN(I,1)),3)
          P=PFAKT(MN(J,1))
          XP=YA(2,MN(J,1))*C75+512.
          YPP=YA(3,MN(J,1))*C75+375.
          CALL PLOTHGL(XP,YPP,2)
          CALL PLOT(P*YA(2,MN(J,1)),P*YA(3,MN(J,1)),2)
        ENDIF
  100   CONTINUE
      ENDIF
    5 IF(MV(MG(10)+1,13).EQ.0) GOTO 102
* BER
      IF(MG(1).GE.MI(37)) GOTO 101
      IF (DIST(MV(MG(10)+1,13)).GE.DIST(MN(MG(1)+1,1))) GOTO 102
  101 IF(MG(2).GE.MI( 7)) GOTO 103
      IF(DIST(MV(MG(10)+1,13)).GE.DIST(MO(MG(2)+1))  ) GOTO 102
      GOTO 103
  102 IF (MG(1).GE.MI(37))GO TO 47
      IF (MG(2).GE.MI(7)) GOTO 104
      IF  (DIST(MN(MG(1)+1,1)  ).GT.DIST(MO(MG(2)+1)))GO TO 48
C
C ***********************
C *** DRAW POLYHEDRON ***
C ***********************
C
  104 MG(1)=MG(1)+1
      KP=IYA(1,MN(MG(1),1))/IYAQ
      KL=1
      DO 88 L=1,10
   88 IF(KP.EQ.ML(L,1)) KL=ML(L,2)
      CALL NEWPEN(KL)
      CALL SP(KL)
      IF (MI(34).EQ.0) GOTO 5
      DO 9 I=1,28
    9 MA1(I)=-1
      IF (MN(MG(1),7).LE.0)THEN
        MG(12)=9
        MG(13)=12
      ELSE
        MG(12)=1
        MG(13)=8
      ENDIF
      CALL OBSC
C
C *** CHECK OVERLAPS ***
C
      P=     PFAKT(MN(MG(1),1))
      YB(1)=P*YA(2,MN(MG(1),1))
      YB(2)=P*YA(3,MN(MG(1),1))
      YB(3)= FLOAT(MN(MG(1),8))*1E-3
      CALL CHECK(1)
CVALUES ARE NOT CHANGED IN CHECK:
COBSOLETE P=     PFAKT(MN(MG(1),1))
COBSOLETE YB(1)=P*YA(2,MN(MG(1),1))
COBSOLETE YB(2)=P*YA(3,MN(MG(1),1))
C
C *** SEND LINE PARAMETERS TO INTER ***
C
      K=18
C
C *** COUNT LINES ***
C
      DO 21 I=1,19
      IF (MA(I+1,1).LE.0)GO TO 22
   21 CONTINUE
      I=20
C
C *** SEND LINE PARAMETERS TO INTER AND CHECK OUTLINES ***
C
   22 MG(18)=3
      DO 27 J=1,I
      P=      PFAKT(MA(J,1))
      YB( 9)=P*YA(2,MA(J,1))
      YB(10)=P*YA(3,MA(J,1))
      P=      PFAKT(MA(J,2))
      YB(11)=P*YA(2,MA(J,2))
      YB(12)=P*YA(3,MA(J,2))
      YD(13)=YB(1)
      YD(14)=YB(2)
      YD(15)=0.5*(YB( 9)+YB(11))
      YD(16)=0.5*(YB(10)+YB(12))
      YD(21)=(YD(13)-YD(15))**2+(YD(14)-YD(16))**2
      DO 26 L=1,I
      IF (J.EQ.L)GO TO 26
      P=      PFAKT(MA(L,1))
      YD(17)=P*YA(2,MA(L,1))
      YD(18)=P*YA(3,MA(L,1))
      P=      PFAKT(MA(L,2))
      YD(19)=P*YA(2,MA(L,2))
      YD(20)=P*YA(3,MA(L,2))
      CALL INTLL
      IF (ABS(YD(5)-0.5).GT.0.5)GO TO 26
      IF (YD(6).LT.0.)GO TO 26
      YD(22)=(YD(13)-YD(1))**2+(YD(14)-YD(2))**2
      IF (YD(22).GT.YD(21))GO TO 27
   26 CONTINUE
      K=K+1
      MG(K)=J
   27 CALL INTER
      IF (MI(41).LT.0)GO TO 36
C
C *** SHADE POLYHEDRON ***
C
      MG(18)=1
      DO 35 I=1,6
      IF (MB(I).LE.0)GO TO 36
      MG(7)=MK(MB(I),1)
      MG(8)=MK(MB(I),2)
      MG(9)=MK(MB(I),3)
      YD(25)=0.
      YD(26)=0.
      IF (YA(4,MN(MG(1),MG(7))).LE.YA(4,MN(MG(1),MG(8))))THEN
        J    =MG(7)
        MG(7)=MG(8)
        MG(8)=J
      ENDIF
      IF (YA(4,MN(MG(1),MG(7))).LE.YA(4,MN(MG(1),MG(9))))THEN
        J    =MG(7)
        MG(7)=MG(9)
        MG(9)=J
      ENDIF
      P=      PFAKT(MN(MG(1),MG(7)))
      YD(27)=P*YA(2,MN(MG(1),MG(7)))
      YD(28)=P*YA(3,MN(MG(1),MG(7)))
      P=      PFAKT(MN(MG(1),MG(8)))
      YD(29)=P*YA(2,MN(MG(1),MG(8)))
      YD(30)=P*YA(3,MN(MG(1),MG(8)))
      P=      PFAKT(MN(MG(1),MG(9)))
      YD(31)=P*YA(2,MN(MG(1),MG(9)))
      YD(32)=P*YA(3,MN(MG(1),MG(9)))
      YD(33)=YD(29)-YD(27)
      YD(34)=YD(30)-YD(28)
      YD(35)=YD(31)-YD(27)
      YD(36)=YD(32)-YD(28)
      JN=MN(MG(1),1)
      DO 600 II=1,IS
      IF (JN.GE.NH(II,1) .AND. JN.LE.NH(II,2)) GOTO 601
  600 CONTINUE
C MODIF ALB : DEFAULT NUMBER OF SHADE IS 4 INSTEAD OF 9
      JN=4
C
      STEP=1./FLOAT(JN+1)
      GOTO 602
  601 JN=NH(II,3)
      STEP=1./FLOAT(JN+1)
  602 IF (JN.GT.0)THEN
        DO 34 J=1,JN
        YD(37)=J*STEP
        YB( 9)=YD(27)+YD(37)*YD(33)
        YB(10)=YD(28)+YD(37)*YD(34)
        YB(11)=YD(27)+YD(37)*YD(35)
        YB(12)=YD(28)+YD(37)*YD(36)
   34   CALL INTER
      ENDIF
   35 CONTINUE
C
C *** SORT OUTLINES ***
C
   36 L=3
      MN(MG(1),2)=MA(MG(19),1)
      MN(MG(1),3)=MA(MG(19),2)
   37 DO 43 I=20,K
      IF (MG(I).LE.0)GO TO 43
      IF (MA(MG(I),1).EQ.MN(MG(1),L))THEN
        L=L+1
        MN(MG(1),L)=MA(MG(I),2)
      ELSE
        IF (MA(MG(I),2).NE.MN(MG(1),L))GO TO 43
        L=L+1
        MN(MG(1),L)=MA(MG(I),1)
      ENDIF
      MG(I)=-1
      IF (L.LT.7)GO TO 37
      IF (L.EQ.7)GO TO 45
      WRITE (IO3,1000)
      STOP
   43 CONTINUE
      MN(MG(1),L)=-1
   45 IF (MN(MG(1),2).EQ.MN(MG(1),L))MN(MG(1),L)=-1
      GOTO 185
C
C ********************
C ***              ***
C *** DRAW CIRCLES ***
C ***              ***
C ********************
C
   47 IF (MG(2).GE.MI(7)) GOTO 185
   48 MG(2)=MG(2)+1
      KP=ABS(IYA(1,MO(MG(2))))/IYAQ
      KL=1
      DO 89 L=1,10
   89 IF(KP.EQ.ML(L,1)) KL=ML(L,2)
      CALL NEWPEN(KL)
      CALL SP(KL)
      P=     PFAKT(MO(MG(2)))
      YB(1)=P*YA(2,MO(MG(2)))
      YB(2)=P*YA(3,MO(MG(2)))
      YB(3)=P*RAD (MO(MG(2)))
C     IF (M(34).EQ.0) GOTO 58
C
C *** CHECK OVERLAPS ***
C
      CALL CHECK(2)
C
C *** SET STARTING POINT ***
C
      MG(15)=2
      YR(1,1)= YB(3)*.01745
      YR(1,2)=-YB(3)
      YR(1,3)=-181.
      YR(2,1)=-YR(1,1)
      YR(2,2)= YR(1,2)
      YR(2,3)= 181.
      IF (MI(34).EQ.0) GOTO 69
      IF (MG(4).LE.0)GO TO 69
C
C *** CALCULATE OVERLAPS WITH POLYHEDRA ***
C
      YB(19)=YB(1)
      YB(20)=YB(2)
      DO 68 I=1,MG(4)
      LOG=.FALSE.
      MG(16)=6
      DO 67 J=2,7
      IF (MN(MC(I),J+1).LE.0)THEN
        MG(16)=J-1
        LOG=.TRUE.
      ENDIF
      P=      PFAKT(MN(MC(I),J))
      YB( 9)=P*YA(2,MN(MC(I),J))
      YB(10)=P*YA(3,MN(MC(I),J))
      MG(13)=J-1
      MG(14)=MOD(MG(13),MG(16))+2
      P=      PFAKT(MN(MC(I),MG(14)))
      YB(11)=P*YA(2,MN(MC(I),MG(14)))
      YB(12)=P*YA(3,MN(MC(I),MG(14)))
      CALL INTLC
      IF (LOG) GOTO 68
   67 CONTINUE
   68 CONTINUE
   69 IF (MG(5).LE.0)GO TO 705
C
C *** CALCULATE OVERLAPS WITH CIRCLES ***
C
      DO 74 I=1,MG(5)
      P=     PFAKT(MO(MD(I)))
      YB(5)=P*YA(2,MO(MD(I)))
      YB(6)=P*YA(3,MO(MD(I)))
      YB(8)=P*RAD (MO(MD(I)))
      CALL INTCC
   74 CONTINUE
C
C *** CALCULATE INTERSECTIONS WITH BIZARRE POLYHEDRA ***
C
  705 IF(MG(11).LE.0)GO TO 75
      YB(19)=YB(1)
      YB(20)=YB(2)
      DO 707 I=1,MG(11)
      LOG=.FALSE.
      MG(16)=12
      DO 708 J=1,12
      IF(MV(ME(I),J+1).LE.0)THEN
        LOG=.TRUE.
        MG(16)=J
      ENDIF
      P=      PFAKT(MV(ME(I),J))
      YB( 9)=P*YA(2,MV(ME(I),J))
      YB(10)=P*YA(3,MV(ME(I),J))
      MG(13)=J+1
      MG(14)=MOD(MG(13),MG(16))
      P=      PFAKT(MV(ME(I),MG(14)))
      YB(11)=P*YA(2,MV(ME(I),MG(14)))
      YB(12)=P*YA(3,MV(ME(I),MG(14)))
      CALL INTLC
      IF(LOG) GOTO 707
  708 CONTINUE
  707 CONTINUE
C
C *** SORT INTERSECTIONS ***
C
   75 CALL SORT
      TEMP=1./YB(3)
      DO 76 I=1,MG(15)
      YR(I,1)=YR(I,1)*TEMP
   76 YR(I,2)=YR(I,2)*TEMP
C
C *** CHECK OBSCURING OF SEGMENTS ***
C
      DO 84 I=2,MG(15)
      YB(12)=0.5*(YR(I,3)+YR(I-1,3))
      YB(23)=YB(3)*SIN(YB(12)*YC35)+YB(1)
      YB(24)=YB(3)*COS(YB(12)*YC35)+YB(2)
      IF (MI(34).NE.0 .AND. MG(4).GT.0)THEN
        DO 77 J=1,MG(4)
        MG(3)=MC(J)
        CALL INOUT
        IF (MG(17).LE.0)GO TO 84
   77   CONTINUE
      ENDIF
      IF (MG(5).GT.0)THEN
        DO 80 J=1,MG(5)
        P=           PFAKT(MO(MD(J)))
        IF ((YB(23)-P*YA(2,MO(MD(J))))**2
     *     +(YB(24)-P*YA(3,MO(MD(J))))**2 .LE.
     *              (P*RAD(MO(MD(J))))**2      )GO TO 84
   80   CONTINUE
      ENDIF
      IF(MG(11).GT.0)THEN
        DO 803 J=1,MG(11)
        MG(3)=ME(J)
        CALL OUTIN
        IF(MG(17).LE.0)GO TO 84
  803   CONTINUE
      ENDIF
C
C *** DRAW SEGMENT ***
C *** CIRCLES ARE DRAWN 3X IN DO LOOP 83; REMOVE C AND ERASE 2. 81 ***
C
      II11=IFIX(.2*YR(I-1,3))+38
      II22=IFIX(.2*YR(I  ,3))+37
      NP=3
      DO 83 J=-NRES,NRES
      YC(6)=YB(3)+J*RES
      IF(MOD(J,2).EQ.0)THEN
        XP=YB(1)+YC(6)*YR(I-1,1)
        YPP=YB(2)+YC(6)*YR(I-1,2)
        CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
        CALL PLOT  (XP,YPP,NP)
        NP=2
        IF(II22.GE.II11)THEN
          DO 81 K=II11,II22
        XP=YB(1)+YC(6)*TBSICO(K)
        YPP=YB(2)+YC(6)*TBSICO(K+18)
        CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
   81     CALL PLOT(XP,YPP,NP)
        ENDIF
        XP=YB(1)+YC(6)*YR(I,1)
        YPP=YB(2)+YC(6)*YR(I,2)
        CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
        CALL PLOT(XP,YPP,NP)
      ELSE
        XP=YB(1)+YC(6)*YR(I,1)
        YPP=YB(2)+YC(6)*YR(I,2)
        CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
        CALL PLOT  (XP,YPP,NP)
        NP=2
        IF(II22.GE.II11)THEN
          DO 82 K=II22,II11,-1
          XP=YB(1)+YC(6)*TBSICO(K)
          YPP=YB(2)+YC(6)*TBSICO(K+18)
          CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
   82     CALL PLOT(XP,YPP,NP)
        ENDIF
        XP=YB(1)+YC(6)*YR(I-1,1)
        YPP=YB(2)+YC(6)*YR(I-1,2)
        CALL PLOTHGL(XP*C75+512.,YPP*C75+375.,NP)
        CALL PLOT(XP,YPP,NP)
      ENDIF
   83 CONTINUE
C
   84 CONTINUE
      IZ=MG(7)
      GOTO 185
C
C ********************
C ***              ***
C *** DRAW BIZARRE ***
C ***  POLYHEDRON  ***
C ***              ***
C ********************
C
  103 MG(10)=MG(10)+1
      KP=IYA(1,MV(MG(10),13))/IYAQ
      KL=1
      DO 107 K=1,10
  107 IF(KP.EQ.ML(K,1)) KL=ML(K,2)
      CALL NEWPEN(KL)
      CALL SP(KL)
C
C *** CHECK OVERLAPS ***
C
      P=       PFAKT(MV(MG(10),13))
      YB(1)=  P*YA(2,MV(MG(10),13))
      YB(2)=  P*YA(3,MV(MG(10),13))
      YB(3)=FLOAT(MU(MV(MG(10),14),1,1))*1E-3
      CALL CHECK(3)
      CALL SCOB
      P=     PFAKT(MV(MG(10),13))
      YB(1)=P*YA(2,MV(MG(10),13))
      YB(2)=P*YA(3,MV(MG(10),13))
      K=18
      DO 125 I=1,19
      IF(MA(I+1,1).LE.0) GOTO 126
  125 CONTINUE
      I=20
  126 MG(18)=3
      DO 127 J=1,I
      P=      PFAKT(MA(J,1))
      YB( 9)=P*YA(2,MA(J,1))
      YB(10)=P*YA(3,MA(J,1))
      P=      PFAKT(MA(J,2))
      YB(11)=P*YA(2,MA(J,2))
      YB(12)=P*YA(3,MA(J,2))
      YD(13)=YB(1)
      YD(14)=YB(2)
      YD(15)=0.5*(YB(9)+YB(11))
      YD(16)=0.5*(YB(10)+YB(12))
      YD(21)=(YD(13)-YD(15))**2+(YD(14)-YD(16))**2
      DO 128 L=1,I
      IF(J.EQ.L)GO TO 128
      P=      PFAKT(MA(L,1))
      YD(17)=P*YA(2,MA(L,1))
      YD(18)=P*YA(3,MA(L,1))
      P=      PFAKT(MA(L,2))
      YD(19)=P*YA(2,MA(L,2))
      YD(20)=P*YA(3,MA(L,2))
      CALL INTLL
      IF(ABS(YD(5)-0.5).GT.0.5)GO TO 128
      IF(YD(6).LT.0.)GO TO 128
      YD(22)=(YD(13)-YD(1))**2+(YD(14)-YD(2))**2
      IF(YD(22).GT.YD(21))GO TO 127
  128 CONTINUE
      K=K+1
      MG(K)=J
  127 CALL INTER
C
C *** SHADE BIZARRE POLYHEDRON ***
C
      KK=K
CNOTUSED:LL=1
      DO 166 NN=1,19
  166 IF(MA(NN+1,1).LE.0.) GOTO 167
      NN=20
  167 DO 162 I=3,NN
      IND=.FALSE.
  163 J=1
      MB(1)=I
      DO 164 K=2,6
  164 MB(K)=0
  151 CONTINUE
      P2=      PFAKT(MA(MB(J),2))
      P1=      PFAKT(MA(MB(J),1))
      YD(13)=P2*YA(2,MA(MB(J),2))-P1*YA(2,MA(MB(J),1))
      YD(14)=P2*YA(3,MA(MB(J),2))-P1*YA(3,MA(MB(J),1))
      YD(18)=1
      DO 154 K=1,NN
      DO 152 L=1,J
  152 IF(K.EQ.MB(L)) GOTO 154
      IF(MA(K,1).NE.MA(MB(J),2).AND.MA(K,2).NE.MA(MB(J),2)) GOTO 154
      IF(MA(K,1).NE.MA(MB(J),2))THEN
        LL     =MA(K,2)
        MA(K,2)=MA(K,1)
        MA(K,1)=LL
      ENDIF
      P2=      PFAKT(MA(K,2))
      P1=      PFAKT(MA(K,1))
      YD(15)=P2*YA(2,MA(K,2))-P1*YA(2,MA(K,1))
      YD(16)=P2*YA(3,MA(K,2))-P1*YA(3,MA(K,1))
      YD(17)=YD(13)*YD(16)-YD(14)*YD(15)
      IF(YD(17).LE.0) GOTO 154
      YD(17)=(YD(13)*YD(15)+YD(14)*YD(16))/
     *(SQRT(YD(13)**2+YD(14)**2)*SQRT(YD(15)**2+YD(16)**2))
      IF(YD(17).GE.YD(18)) GOTO 154
      IF(K.GE.I) GOTO 161
      YD(18)=YD(17)
      MB(J+1)=K
  154 CONTINUE
      J=J+1
      IF(MB(J).EQ.0) GOTO 161
      IF(MA(MB(J),2).NE.MA(MB(1),1))THEN
        IF(J.LE.6) GOTO 151
        WRITE (IO3,*)'FACE BIZARRE'
        STOP
      ENDIF
      DO 156 K=1,J
  156 MB(K)=MA(MB(K),1)
      L=1
      DO 157 K=2,J
  157 IF(YA(4,MB(K)).GE.YA(4,MB(L))) L=K
      MG(12)=L+1
      IF(L.EQ.J) MG(12)=1
      MG(13)=L-1
      IF(L.EQ.1) MG(13)=J
      P1=      PFAKT(MB(L))
      P2=      PFAKT(MB(MG(12)))
      P3=      PFAKT(MB(MG(13)))
      YD(13)=(P2*YA(2,MB(MG(12)))-P1*YA(2,MB(L)))*0.1
      YD(14)=(P2*YA(3,MB(MG(12)))-P1*YA(3,MB(L)))*0.1
      YD(15)=(P3*YA(2,MB(MG(13)))-P1*YA(2,MB(L)))*0.1
      YD(16)=(P3*YA(3,MB(MG(13)))-P1*YA(3,MB(L)))*0.1
      DEN=YD(16)*YD(13)-YD(15)*YD(14)
      IF(ABS(DEN).LT.1E-6)THEN
        WRITE (IO3,*) 'impossible de definir un pavage de cette face'
        GOTO 161
      ENDIF
      IF(J.EQ.3)THEN
        LIMX=8
        LIMY=8
      ELSE
        YD(17)=10.*DEN
        YD(18)=10.*DEN
        DO 158 K=1,J
        IF(K.NE.MG(12) .AND. K.NE.MG(13) .AND. K.NE.L)THEN
          P1=      PFAKT(MB(K))
          P2=      PFAKT(MB(L))
          YD(19)=P1*YA(2,MB(K))-P2*YA(2,MB(L))
          YD(20)=P1*YA(3,MB(K))-P2*YA(3,MB(L))
          VECT1=YD(16)*YD(19)-YD(15)*YD(20)
          VECT2=YD(20)*YD(13)-YD(19)*YD(14)
          IF(VECT1.GT.YD(17)) YD(17)=VECT1
          IF(VECT2.GT.YD(18)) YD(18)=VECT2
        ENDIF
  158   CONTINUE
        LIMX=IFIX(YD(17)/DEN-0.05)
        LIMY=IFIX(YD(18)/DEN-0.05)
      ENDIF
      DO 160 JX=1,LIMX
      DO 159 JY=1,LIMY
      P=      PFAKT(MB(L))
      YB(23)=P*YA(2,MB(L))+JX*YD(13)+JY*YD(15)
      YB(24)=P*YA(3,MB(L))+JX*YD(14)+JY*YD(16)
      CALL RETIN
      IF(J.EQ.3.AND.(JX+JY).EQ.9) GOTO 160
  159 CONTINUE
  160 CONTINUE
      YD(23)=YB(23)
      YD(24)=YB(24)
  161 IF(.NOT.IND)THEN
        LL     =MA(I,1)
        MA(I,1)=MA(I,2)
        MA(I,2)=LL
        IND=.TRUE.
        GOTO 163
      ENDIF
  162 CONTINUE
C
C *** SORT OUTLINES ***
C
      L=2
      MV(MG(10),1)=MA(MG(19),1)
      MV(MG(10),2)=MA(MG(19),2)
  137 DO 143 I=20,KK
      IF(MG(I).LE.0)GO TO 143
      IF(MA(MG(I),1).EQ.MV(MG(10),L))THEN
        L=L+1
        MV(MG(10),L)=MA(MG(I),2)
      ELSE
        IF(MA(MG(I),2).NE.MV(MG(10),L))GO TO 143
        L=L+1
        MV(MG(10),L)=MA(MG(I),1)
      ENDIF
      MG(I)=-1
      IF(L.LT.12)GO TO 137
      IF(L.EQ.12)GO TO 145
      WRITE (IO3,1000)
      STOP
  143 CONTINUE
      MV(MG(10),L)=-1
  145 IF(MV(MG(10),1).EQ.MV(MG(10),L))MV(MG(10),L)=-1
  185 IF(MG(1).LT.MI(37)) GOTO 5
      IF(MG(2).LT.MI(7)) GOTO 5
      IF(MV(MG(10)+1,13).NE.0) GOTO 5
C 110 CONTINUE
      RETURN
 1000 FORMAT (///,1X,'AN ERROR OCCURED IN DETERMINATION OF POLYHEDRAL OU
     &TLINES, THE JOB IS TERMINATED')
C1001 FORMAT (1X,'4 ',I1)
      END
C---------------------------------------------------------------------------
      SUBROUTINE DRAWL
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(1428),
     *MG(68),MI(25933),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
C
C START: YB(9/10) (->YD(23/24)
      IF ((YD(23)-YB(9))**2+(YD(24)-YB(10))**2.GT.1.E-4)THEN
        YD(23)=YB( 9)
        YD(24)=YB(10)
        XP=YD(23)*C75+512.
        YPP=YD(24)*C75+375.
        CALL PLOTHGL(XP,YPP,3)
        CALL PLOT(YD(23),YD(24),3)
      ENDIF
C END: YB(11/12)
        XP=YB(11)*C75+512.
        YPP=YB(12)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
      CALL PLOT(YB(11),YB(12),2)
C RETRACE
      IF (MG(18).GT.1 .AND. NRES.GT.0)THEN
        YD(10)=YD(24)-YB(12)
        YD(11)=YD(23)-YB(11)
        YD(12)=YD(10)*YD(10)+YD(11)*YD(11)
        IF(YD(12).GT.0.)THEN
          YD(12)=RES/SQRT(YD(12))
          YD(10)= YD(10)*YD(12)
          YD(11)=-YD(11)*YD(12)
          DO 1 I=1,NRES
           Y0=YD(10)*I
           Y1=YD(11)*I
        XP=(YB(11)+Y0)*C75+512.
        YPP=(YB(12)+Y1)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
           CALL PLOT(YB(11)+Y0,YB(12)+Y1,2)
        XP=(YD(23)+Y0)*C75+512.
        YPP=(YD(24)+Y1)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
           CALL PLOT(YD(23)+Y0,YD(24)+Y1,2)
        XP=(YD(23)-Y0)*C75+512.
        YPP=(YD(24)-Y1)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
           CALL PLOT(YD(23)-Y0,YD(24)-Y1,2)
        XP=(YB(11)-Y0)*C75+512.
        YPP=(YB(12)-Y1)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
1          CALL PLOT(YB(11)-Y0,YB(12)-Y1,2)
C       CALL PLOT(YB(11)+YD(10),YB(12)+YD(11),2)
C       CALL PLOT(YD(23)+YD(10),YD(24)+YD(11),2)
C       CALL PLOT(YD(23)-YD(10),YD(24)-YD(11),2)
C       CALL PLOT(YB(11)-YD(10),YB(12)-YD(11),2)
        ENDIF
      ENDIF
      YD(23)=YB(11)
      YD(24)=YB(12)
      RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE FIND(N,M,L,LOG)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(106),YZ(100,5),
     *YE(200,5),MH(20),MI(11198),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      LOGICAL LOG
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
C
      DO 1 J=1,MIN(M,12)
      IF(YZ(J,5).GT.YP(L,3)) GOTO 2
      IF(IYA(1,IFIX(YZ(J,1))).LE.0.) GOTO 14
      MV(N,J)=IFIX(YZ(J,1))
    1 CONTINUE
    2 J=J-1
      IF(.NOT.LOG) GOTO 13
      DO 3 I=1,N-1
    3 IF(MV(I,14).EQ.MV(N,14)) GOTO 5
      GOTO 13
    5 IF(YZ(J,5).LE.MU(MV(I,14),1,1)/1000.) GOTO 6
      J=J-1
      IF(J.GE.1) GOTO 5
    6 IF(J.GT.MU(MV(I,14),1,2)) GOTO 8
      IF(J.LT.MU(MV(I,14),1,2)) GOTO 14
      DO 7 K=J+1,MIN(M,12)
    7 MV(N,K)=0
      CALL RCGN(N,I)
      GOTO 16
    8 K=1
    9 IF(MV(K,14).NE.MV(N,14)) GOTO 12
      DO 11 I=1,14
      DO 10 J=K,N-1
   10 MV(J,I)=MV(J+1,I)
   11 MV(N,I)=0
      N=N-1
   12 K=K+1
      IF(K.LT.N) GOTO 9
   13 MU(MV(N,14),1,1)=YP(L,3)*1000.
      CALL BZRR(N,M)
      GOTO 16
   14 DO 15 K=1,14
   15 MV(N,K)=0
      N=N-1
   16 RETURN
      END
C--------------------------------------------------------------------------
      SUBROUTINE INOUT
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),MA(1428),
     *MG(68),MI(174),MN(1000,8),MO(3759),MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
C *** DETERMINE NUMBER OF EDGES ***
C
      DO 1 I=3,6
      IF (MN(MG(3),I+2).LE.0)GO TO 2
    1 CONTINUE
      I=6
C
C *** CHECK IF B(23),B(24) IS OBSCURED BY POLYHEDRON NO. F(3) ***
C
    2 K=I+MOD(I,2)-1
      DO 3 J=1,K,2
      MG(12)=MOD(J,I)+2
      MG(13)=MOD(J+1,I)+2
      MG(14)=MOD(J-1,I)+2
      P2=PFAKT(MN(MG(3),MG(12)))
*      write(1,1000) MG(3),(MG(i),MN(MG(3),MG(i)),i=12,14)
* 1000 format(1x,7i10)
      P3=PFAKT(MN(MG(3),MG(13)))
      P4=PFAKT(MN(MG(3),MG(14)))
      YB(13)=P3*YA(2,MN(MG(3),MG(13)))-P2*YA(2,MN(MG(3),MG(12)))
      YB(14)=P3*YA(3,MN(MG(3),MG(13)))-P2*YA(3,MN(MG(3),MG(12)))
      YB(15)=P4*YA(2,MN(MG(3),MG(14)))-P2*YA(2,MN(MG(3),MG(12)))
      YB(16)=P4*YA(3,MN(MG(3),MG(14)))-P2*YA(3,MN(MG(3),MG(12)))
      YD(11)=YB(23)-P2*YA(2,MN(MG(3),MG(12)))
      YD(12)=YB(24)-P2*YA(3,MN(MG(3),MG(12)))
C
C   Possibility to divide by zero..... MODIF ALB...
C
      YMANS=YB(15)*YB(14)-YB(16)*YB(13)
      IF(YMANS.EQ.0.)YMANS=0.0000000001
      YD( 5)=(YD(11)*YB(14)-YD(12)*YB(13))/YMANS
      YMANS=YB(13)*YB(16)-YB(14)*YB(15)
      IF(YMANS.EQ.0.)YMANS=0.0000000001
      YD( 6)=(YD(11)*YB(16)-YD(12)*YB(15))/YMANS
C
      YD(10)=AMIN1(YD(5),YD(6))
      IF (YD(10).LE.0.)GO TO 4
    3 CONTINUE
    4 MG(17)=-IFIX(SIGN(1.,YD(10)))
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE INTCC
      EQUIVALENCE (YC36,YC(36))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      YD( 9)=YB(5)-YB(1)
      YD(10)=YB(6)-YB(2)
      YD(11)=YD(9)**2+YD(10)**2
      YD(12)=(YD(11)+YB(3)**2-YB(8)**2)*0.5
      YD(13)=YB(3)**2*YD(11)-YD(12)**2
      IF(YD(13).GT.0.)THEN
        YD(11)=1./YD(11)
        YD(14)=YD(11)*YD(12)
        YD( 3)=YD(14)*YD( 9)
        YD( 4)=YD(14)*YD(10)
        YD(15)=YD(11)*SQRT(YD(13))
        YD(10)=YD(10)*YD(15)
        YD( 9)=-YD(9)*YD(15)
        YD(1)=YD(3)-YD(10)
        YD(2)=YD(4)-YD( 9)
        YD(3)=YD(3)+YD(10)
        YD(4)=YD(4)+YD( 9)
        MG(15)=MG(15)+1
        YR(MG(15),1)=YD(1)
        YR(MG(15),2)=YD(2)
        YR(MG(15),3)=YC36*ATAN2(YD(1),YD(2))
        MG(15)=MG(15)+1
        YR(MG(15),1)=YD(3)
        YR(MG(15),2)=YD(4)
        YR(MG(15),3)=YC36*ATAN2(YD(3),YD(4))
C     ELSE
C no intersection
C       YD(1)=YB(1)
C       YD(3)=YD(1)
C       YD(2)=YB(2)-YB(3)
C       YD(4)=YD(2)
C       WRITE(6,100)
C       WRITE(6,101)YB(1),YB(2),YB(3)
C       WRITE(6,101)YB(5),YB(6),YB(8)
      ENDIF
      RETURN
C100   FORMAT(' no intersection (x,y,r):')
C101   FORMAT(1X,3F10.6)
      END
C------------------------------------------------------------------------
      SUBROUTINE INTCL
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(1496),
     *MI(25933),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      YD(5)=-1.
      YD(6)=-1.
      YD( 7)=YB( 9)-YB(19)
      YD( 8)=YB(10)-YB(20)
      YD( 9)=YB(11)-YB( 9)
      YD(10)=YB(12)-YB(10)
      YD(11)=YD( 9)*YD( 9)+YD(10)*YD(10)
      YD(12)=YD( 7)*YD( 9)+YD( 8)*YD(10)
      YD(13)=YD(12)*YD(12)-YD(11)*
     *  (YD( 7)*YD( 7)+YD( 8)*YD( 8)-YB(3)*YB(3))
      IF (YD(13).GE.0.)THEN
C
C Possibility to divide by zero, MODIF ALB
C
        IF(YD(11).EQ.0.)YD(11)=0.0000000001
        YD(14)=-YD(12)/YD(11)
        YD(13)=SQRT(YD(13))/YD(11)
C
        YD(5)=YD(14)+YD(13)
        YD(1)=YB( 9)+YD(5)*YD( 9)
        YD(2)=YB(10)+YD(5)*YD(10)
        IF (YD(13).GT.1E-4)THEN
          YD(6)=YD(14)-YD(13)
          YD(3)=YB( 9)+YD(6)*YD( 9)
          YD(4)=YB(10)+YD(6)*YD(10)
        ENDIF
      ENDIF
      RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE INTLC
      EQUIVALENCE (YC36,YC(36))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(10,2),MM(70),MN(1000,8),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PA1,PA2,AR1,AR2,OR1,OR2,RES,FAC,NRES,IBUR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
C      INTEGER L,KP,KN
      CHARACTER TIT*40,BL*4
C     LOGICAL LOG,IND
CNOUSECOMMON/PLC/XPL1,XPL2,KPL
CNOUSEINTEGERZ(28)
CNOUSEEQUIVALENCE (ME(1,1),Z(1))
C
      CALL INTCL
      IF (ABS(YD(5)-0.5).LE.0.5)THEN
        MG(15)=MG(15)+1
        YR(MG(15),1)=YD(1)-YB(1)
        YR(MG(15),2)=YD(2)-YB(2)
        YR(MG(15),3)=YC36*ATAN2(YR(MG(15),1) , YR(MG(15),2))
      ENDIF
      IF (ABS(YD(6)-0.5).LE.0.5)THEN
        MG(15)=MG(15)+1
        YR(MG(15),1)=YD(3)-YB(1)
        YR(MG(15),2)=YD(4)-YB(2)
        YR(MG(15),3)=YC36*ATAN2(YR(MG(15),1) , YR(MG(15),2))
      ENDIF
      RETURN
      END
C--------------------------------------------------------------------------
      SUBROUTINE INTER
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(90),MN(1000,8),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
      YR(1,1)=YB(9)
      YR(1,2)=YB(10)
      YR(1,3)=0.
      YR(2,1)=YB(11)
      YR(2,2)=YB(12)
      YR(2,3)=SQRT((YB(9)-YB(11))**2+(YB(10)-YB(12))**2)
      MG(15)=2
      IF (MG(4).LE.0)GO TO 10
C
C *** CALCULATE OVERLAPS WITH OTHER POLYHEDRA ***
C
      YD(13)=YB( 9)
      YD(14)=YB(10)
      YD(15)=YB(11)
      YD(16)=YB(12)
      DO 9 I=1,MG(4)

      MG(16)=6
      DO 8 J=2,7
      IF (MN(MC(I),J)  .LT.1) GOTO 9
      IF (MN(MC(I),J+1).LE.0) MG(16)=J-1
      P=      PFAKT(MN(MC(I),J))
      YD(17)=P*YA(2,MN(MC(I),J))
      YD(18)=P*YA(3,MN(MC(I),J))
      MG(13)=J-1
      MG(14)=MOD(MG(13),MG(16))+2
      P=      PFAKT(MN(MC(I),MG(14)))
      YD(19)=P*YA(2,MN(MC(I),MG(14)))
      YD(20)=P*YA(3,MN(MC(I),MG(14)))
      CALL INTLL
      IF (ABS(YD(5)-0.5).GT.0.5)GO TO 8
      IF (ABS(YD(6)-0.5).GT.0.5)GO TO 8
      YB(8)=SQRT((YB(9)-YD(1))**2+(YB(10)-YD(2))**2)
      IF (YB(8).LE.1E-3)GO TO 8
      DO 6 K=1,MG(15)
      IF (ABS(YB(8)-YR(K,3)).LE.1E-5)GO TO 8
    6 CONTINUE
      MG(15)=MG(15)+1
      YR(MG(15),1)=YD(1)
      YR(MG(15),2)=YD(2)
      YR(MG(15),3)=YB(8)
    8 CONTINUE
    9 CONTINUE
C
C *** CALCULATE INTERSECTIONS WITH CIRCLES ***
C
   10 IF (MG(5).GT.0)THEN
        DO 15 I=1,MG(5)
        P=      PFAKT(MO(MD(I)))
        YB(3 )=P*RAD (MO(MD(I)))
        YB(19)=P*YA(2,MO(MD(I)))
        YB(20)=P*YA(3,MO(MD(I)))
        CALL INTCL
        IF (ABS(YD(5)-0.5).LE.0.5)THEN
          MG(15)=MG(15)+1
          YR(MG(15),1)=YD(1)
          YR(MG(15),2)=YD(2)
          YR(MG(15),3)=SQRT((YB(9)-YD(1))**2+(YB(10)-YD(2))**2)
        ENDIF
        IF (ABS(YD(6)-0.5).LE.0.5)THEN
          MG(15)=MG(15)+1
          YR(MG(15),1)=YD(3)
          YR(MG(15),2)=YD(4)
          YR(MG(15),3)=SQRT((YB(9)-YD(3))**2+(YB(10)-YD(4))**2)
        ENDIF
   15   CONTINUE
      ENDIF
C
C *** CALCULATE OVERLAPS WITH BIZARRE POLYHEDRA ***
C
      IF(MG(11).EQ.0) GOTO 39
      YD(13)=YB(9)
      YD(14)=YB(10)
      YD(15)=YB(11)
      YD(16)=YB(12)
      DO 24 I=1,MG(11)
      MG(16)=12
      DO 25 J=1,12
      IF(MV(ME(I),J)  .LT.1) GOTO 25
      IF(MV(ME(I),J+1).LE.0) MG(16)=J
      P=      PFAKT(MV(ME(I),J))
      YD(17)=P*YA(2,MV(ME(I),J))
      YD(18)=P*YA(3,MV(ME(I),J))
      MG(13)=J
      MG(14)=MOD(MG(13),MG(16))+1
      P=      PFAKT(MV(ME(I),MG(14)))
      YD(19)=P*YA(2,MV(ME(I),MG(14)))
      YD(20)=P*YA(3,MV(ME(I),MG(14)))
      CALL INTLL
      IF(ABS(YD(5)-0.5).GT.0.5)GO TO 25
      IF(ABS(YD(6)-0.5).GT.0.5)GO TO 25
      YB(8)=SQRT((YB(9)-YD(1))**2+(YB(10)-YD(2))**2)
      IF(YB(8).LE.1E-3)GO TO 25
      DO 30 K=1,MG(15)
      IF(ABS(YB(8)-YR(K,3)).LE.1E-5)GO TO 25
   30 CONTINUE
      MG(15)=MG(15)+1
      YR(MG(15),1)=YD(1)
      YR(MG(15),2)=YD(2)
      YR(MG(15),3)=YB(8)
   25 CONTINUE
   24 CONTINUE
C
C *** SORT INTERSECTIONS ***
C
   39 IF(MG(15).GT.0)CALL SORT
C
C *** CHECK OBSCURING OF LINE SEGMENTS ***
C
      DO 22 I=1,MG(15)-1
      YB( 9)=YR(I,1)
      YB(10)=YR(I,2)
      YB(11)=YR(I+1,1)
      YB(12)=YR(I+1,2)
      YB(23)=(YB( 9)+YB(11))*0.5
      YB(24)=(YB(10)+YB(12))*0.5
      IF (MG(1).NE.0 .AND. MG(4).NE.0)THEN
        DO 18 J=1,MG(4)
        MG(3)=MC(J)
        CALL INOUT
        IF (MG(17).LE.0)GO TO 22
   18   CONTINUE
      ENDIF
      IF (MG(2).NE.0 .AND. MG(5).NE.0)THEN
        DO 20 J=1,MG(5)
        P=      PFAKT(MO(MD(J)))
        YB( 8)=P*RAD (MO(MD(J)))
        YB(19)=P*YA(2,MO(MD(J)))
        YB(20)=P*YA(3,MO(MD(J)))
        YD(5)=SQRT((YB(23)-YB(19))**2+(YB(24)-YB(20))**2)
        IF (YD(5).LE.YB(8))GO TO 22
   20   CONTINUE
      ENDIF
      IF(MG(10).EQ.0.OR.MG(11).EQ.0) GOTO 21
      DO 33 J=1,MG(11)
      MG(3)=ME(J)
      CALL OUTIN
      IF(MG(17).LE.0)GO TO 22
   33 CONTINUE
C
C
C *** DRAW LINE ***
C
   21 CALL DRAWL
   22 CONTINUE
      RETURN
      END
C---------------------------------------------------------------
      SUBROUTINE INTLL
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(1536),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      YD( 9)=YD(15)-YD(13)
      YD(10)=YD(16)-YD(14)
      YD(11)=YD(19)-YD(17)
      YD(12)=YD(20)-YD(18)
      DEN=YD(9)*YD(12)-YD(10)*YD(11)
      IF (ABS(DEN)-1E-8) 1,1,2
    1 YD(5)=10.
      RETURN
    2 YD( 5)=(YD(10)*(YD(17)-YD(13))-YD(9)*(YD(18)-YD(14)))/DEN
      YD( 6)=(YD(12)*(YD(17)-YD(13))-YD(11)*(YD(18)-YD(14)))/DEN
      YD( 1)=YD(17)+YD(5)*YD(11)
      YD( 2)=YD(18)+YD(5)*YD(12)
      RETURN
      END
C------------------------------------------------------------------------
      FUNCTION IPACK(J)
      COMMON/ALL1/YA(4,6000),YP(1721),MI(104),MM(70),MN(8000),
     *MO(3024),MU(14735),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DO 1 I=19,44
    1 IF (MN(1).EQ.MM(I)) GOTO 2
      GO TO 5
    2 MN(1)=I-19
      DO 3 I=19,44
    3 IF (MN(2).EQ.MM(I)) GOTO 4
      IF (MN(2).NE.MM(1)) GOTO 5
      I=45
    4 MN(2)=I-19
      I=MN(1)*27+MN(2)+1
      IPACK=I*1000+MN(3)*10
      MN(3)=I
      RETURN
    5 WRITE (IO2,1000) MN(1),MN(2)
      WRITE (IO3,1000) MN(1),MN(2)
      STOP
 1000 FORMAT (1X,2A1,' IS NOT A COMMON ATOM NAME, ONLY LETTERS A-Z ARE
     &ACCEPTED, JOB IS TERMINATED')
      END
C-------------------------------------------------------------------------
      SUBROUTINE MERGE(NN)
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(106),YZ(100,5),YE(200,5),
     *MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
CNOTUSED:DIMENSION W(30)
      COMMON/BZR/BX,BY,BZ
      INTEGER BX(10),BY(13),BZ(4)
      LOGICAL LOG
C
      BY(11)=MU(NN,BZ(1),7)
      DO 40 I=1,BY(11)
   40 BY(I)=MU(NN,BZ(1),I)
      BZ(1)=-BZ(1)
      LL=1
   45 II=BY(LL)
      JJ=BY(MOD(LL,BY(11))+1)
   43 LOG=.FALSE.
      DO 3 I=2,4
      IF(BZ(I).LE.0) GOTO 3
      LOG=.TRUE.
      DO 2 J=1,MU(NN,BZ(I),7)
      IF(MU(NN,BZ(I),J).NE.II) GOTO 2
      K=MOD(J,MU(NN,BZ(I),7))+1
      IF(MU(NN,BZ(I),K).NE.JJ) GOTO 1
      BY(12)=BZ(I)
      BY(13)=K
      BZ(I)=-BZ(I)
      GOTO 4
    1 K=MOD(J-2+MU(NN,BZ(I),7),MU(NN,BZ(I),7))+1
      IF(MU(NN,BZ(I),K).NE.JJ) GOTO 3
      BY(12)=-BZ(I)
      BY(13)=J
      BZ(I)=-BZ(I)
      GOTO 4
    2 CONTINUE
    3 CONTINUE
      IF(.NOT.LOG) GOTO 46
      LL=LL+1
      IF(LL.GT.BY(11)) GOTO 46
      GOTO 45
    4 NM=MU(NN,ABS(BY(12)),7)-2
      DO 24 KK=BY(11),LL+1,-1
   24 BY(KK+NM)=BY(KK)
      IF(BY(12).GE.0) GOTO 27
      K=1
      M=LL+1
      N=NM+LL
      GOTO 28
   27 K=-1
      M=NM+LL
      N=LL+1
C rxf
   28 MUNN=MU(NN,ABS(BY(12)),7)
      J=MOD(BY(13),MUNN)+1
C rxf   28 J=MOD(BY(13),MU(NN,ABS(BY(12)),7))+1
      DO 9 L=M,N,K
      BY(L)=MU(NN,ABS(BY(12)),J)
C rxf
      MUNN=MU(NN,ABS(BY(12)),7)
    9 J=MOD(J,MUNN)+1
C rxf    9 J=MOD(J,MU(NN,ABS(BY(12)),7))+1
      BY(11)=BY(11)+NM
   41 LL=1
      GOTO 45
   46 DO 44 I=1,4
   44 BZ(I)=ABS(BZ(I))
      RETURN
      END
*BER**Subroutine Newpen schreibt Stiftnummer auf Datei 9*************
      SUBROUTINE NEWPEN(ISTIFT)
      INTEGER ISTIFT
      WRITE(9,50005) ISTIFT,ISTIFT
50005 FORMAT(' 4',1X,I2,1X,I2)
      RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE OBSC
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(1382),MG(68),MI(48),MK(12,3),ML(90),MN(1000,8),MO(17759),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
      DO 101 K=1,6
101   MB(K)=0
      K=0
      L=0
      DO 102 N=1,3
102   YB(N)= YA( N+1,MN(MG(1),1) )
C
      DO 130 I=MG(12),MG(13)
C
      DO 111 N=1,3
111   MG(N+6)=MN(MG(1),MK(I,N))
      DO 112 N=1,3
      YB(N+ 4)=YA(N+1,MG(8))-YA(N+1,MG(7))
      YB(N+ 7)=YA(N+1,MG(9))-YA(N+1,MG(7))
112   YB(N+13)=YB(N)        -YA(N+1,MG(7))
      YB(11)=YB(6)*YB(10)-YB(7)*YB( 9)
      YB(12)=YB(7)*YB( 8)-YB(5)*YB(10)
      YB(13)=YB(5)*YB( 9)-YB(6)*YB( 8)
C
      YB(17)=YB(11)*YB(14)+YB(12)*YB(15)+YB(13)*YB(16)
C
      YB(13)=YB(13)*
     *(YB(25)-YA(4,MG(7)))-YB(11)*YA(2,MG(7))-YB(12)*YA(3,MG(7))
C
      IF (YB(17).GE.0.)YB(13)=-YB(13)
      IF (YB(13).LE.0.)GO TO 130
      K=K+1
      MB(K)=I
      IF (L.GT.0)THEN
        DO 121 J=1,L
        IF (MK(I,1).EQ.MA(J,1) .AND. MK(I,2).EQ.MA(J,2)) GOTO 122
121     IF (MK(I,2).EQ.MA(J,1) .AND. MK(I,1).EQ.MA(J,2)) GOTO 122
      ENDIF
      L=L+1
      MA(L,1)=MK(I,1)
      MA(L,2)=MK(I,2)
122   IF (L.GT.1)THEN
        DO 123 J=1,L
        IF (MK(I,1).EQ.MA(J,1) .AND. MK(I,3).EQ.MA(J,2)) GOTO 124
123     IF (MK(I,3).EQ.MA(J,1) .AND. MK(I,1).EQ.MA(J,2)) GOTO 124
      ENDIF
      L=L+1
      MA(L,1)=MK(I,1)
      MA(L,2)=MK(I,3)
124   IF (L.GT.2)THEN
        DO 125 J=1,L
        IF (MK(I,2).EQ.MA(J,1) .AND. MK(I,3).EQ.MA(J,2)) GOTO 130
125     IF (MK(I,3).EQ.MA(J,1) .AND. MK(I,2).EQ.MA(J,2)) GOTO 130
      ENDIF
      L=L+1
      MA(L,1)=MK(I,2)
      MA(L,2)=MK(I,3)
130   CONTINUE
      DO 131 J=1,L
      DO 131 K=1,2
131   MA(J,K)=MN(MG(1),MA(J,K))
      IF(L.NE.20)THEN
        DO 132 J=L+1,20
        MA(J,1)=0
132     MA(J,2)=0
      ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTIN
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),MA(1428),
     *MG(68),MI(174),MN(1000,8),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
      DO 1 I=3,11
      IF(MV(MG(3),I+1).LE.0)GO TO 2
    1 CONTINUE
      I=12
    2 K=I+MOD(I,2)-1
      DO 3 J=1,K,2
      MG(12)=MOD(J,I)+1
      MG(13)=MOD(J+1,I)+1
      MG(14)=MOD(J-1,I)+1
      P2=PFAKT(MV(MG(3),MG(12)))
*      if(mg(13).gt.14) write(1,2001) k,j,i,mg(12),mg(13),mg(14)
*2001  format(7(1x,i10))
      P3=PFAKT(MV(MG(3),MG(13)))
      P4=PFAKT(MV(MG(3),MG(14)))
      YB(13)=P3*YA(2,MV(MG(3),MG(13)))-P2*YA(2,MV(MG(3),MG(12)))
      YB(14)=P3*YA(3,MV(MG(3),MG(13)))-P2*YA(3,MV(MG(3),MG(12)))
      YB(15)=P4*YA(2,MV(MG(3),MG(14)))-P2*YA(2,MV(MG(3),MG(12)))
      YB(16)=P4*YA(3,MV(MG(3),MG(14)))-P2*YA(3,MV(MG(3),MG(12)))
      YD(11)=YB(23)-P2*YA(2,MV(MG(3),MG(12)))
      YD(12)=YB(24)-P2*YA(3,MV(MG(3),MG(12)))
C
C   Possibility to divide by zero..... MODIF ALB...
C
      YMANS=YB(15)*YB(14)-YB(16)*YB(13)
      IF(YMANS.EQ.0.)YMANS=0.0000000001
      YD( 5)=(YD(11)*YB(14)-YD(12)*YB(13))/YMANS
      YMANS=YB(13)*YB(16)-YB(14)*YB(15)
      IF(YMANS.EQ.0.)YMANS=0.0000000001
      YD( 6)=(YD(11)*YB(16)-YD(12)*YB(15))/YMANS
C
      YD(10)=AMIN1(YD(5),YD(6))
      IF (YD(10).LE.0.)GO TO 4
    3 CONTINUE
    4 MG(17)=-IFIX(SIGN(1.,YD(10)))
      RETURN
      END
Cp------------------------------------------------------------------------
      SUBROUTINE OUTLIN
      COMMON/ALL1/YA(4,6000),YP(70),YB(1583),MG(68),MI(174),MN(1000,8),
     *MO(3000),MZ(12,2),MU(5,21,7),MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      MG(18)=1
      DO 1 I=1,12
      P=      PFAKT(MZ(I,1))
      YB( 9)=P*YA(2,MZ(I,1))
      YB(10)=P*YA(3,MZ(I,1))
      P=      PFAKT(MZ(I,2))
      YB(11)=P*YA(2,MZ(I,2))
      YB(12)=P*YA(3,MZ(I,2))
    1 CALL DRAWL
      RETURN
      END
C---------------------------------------------------------------------------
      FUNCTION PFAKT(I)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(1651),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
      DV=ABS(YB(25))
      IF(DV.GT.1000.)THEN
        PFAKT=1.
      ELSE
        PFAKT=DV/(DV-YA(4,I))
      ENDIF
      RETURN
      END
*BER**Subroutine Plot, schreibt Koordinaten auf Datei 9**************
      SUBROUTINE PLOT(XKOORD,YKOORD,INUMBER)
      REAL XKOORD,YKOORD
      INTEGER INUMBER
      WRITE(9,50004) INUMBER,XKOORD,YKOORD
50004 FORMAT(I2,1X,2(F10.4,1X))
      RETURN
      END
*********************************************************************
      FUNCTION RAD(J)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(1651),MI(25933),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
      PARAMETER (IYAQ=10)

      I=MOD(IYA(1,J),10)
      RAD=YB(I+103)
      RETURN
      END
C--------------------------------------------------------------------------
      SUBROUTINE RCGN(I,J)
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(106),YZ(100,5),YE(200,5),
     *MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DIMENSION W(30),NX(12)
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
C
      DO 11 K=1,12
   11 NX(K)=0
      K=0
   10 IF(K.GE.MU(MV(J,14),1,2)) GOTO 6
      K=K+1
      IF(MV(J,K).EQ.0) GOTO 6
      W(1)=YA(2,MV(J,K))-YA(2,MV(J,13))
      W(2)=YA(3,MV(J,K))-YA(3,MV(J,13))
      W(3)=YA(4,MV(J,K))-YA(4,MV(J,13))
      W(9)=SQRT(W(1)**2+W(2)**2+W(3)**2)
      DO 4 L=NX(K)+1,MU(MV(J,14),1,2)
      IF(NX(K)+1.LE.MU(MV(J,14),1,2)) GOTO 12
      WRITE (IO3,*)'AN ERROR OCCURED IN THE DETERMINATION OF A B.P.'
      DO 22 K=1,14
   22 MV(I,K)=0
      I=I-1
      GOTO 18
   12 IF(K.EQ.1) GOTO 13
      DO 9 M=1,K-1
    9 IF(L.EQ.NX(M)) GOTO 4
   13 IF(ABS(IYA(1,MV(I,L))).NE.ABS(IYA(1,MV(J,K)))) GOTO 4
      W(5)=YA(2,MV(I,L))-YA(2,MV(I,13))
      W(6)=YA(3,MV(I,L))-YA(3,MV(I,13))
      W(7)=YA(4,MV(I,L))-YA(4,MV(I,13))
      W(8)=SQRT(W(5)**2+W(6)**2+W(7)**2)
      IF(ABS(W(9)-W(8)).LE.1E-4) GOTO 21
      IF(W(8)-W(9)) 15,15,20
   21 IF(K.NE.1) GOTO 14
      NX(1)=L
      GOTO 10
   14 DO 5 M=1,K-1
      W(1)=YA(2,MV(J,M))-YA(2,MV(J,K))
      W(2)=YA(3,MV(J,M))-YA(3,MV(J,K))
      W(3)=YA(4,MV(J,M))-YA(4,MV(J,K))
      W(4)=SQRT(W(1)**2+W(2)**2+W(3)**2)
      W(5)=YA(2,MV(I,NX(M)))-YA(2,MV(I,L))
      W(6)=YA(3,MV(I,NX(M)))-YA(3,MV(I,L))
      W(7)=YA(4,MV(I,NX(M)))-YA(4,MV(I,L))
      W(8)=SQRT(W(5)**2+W(6)**2+W(7)**2)
    5 IF(ABS(W(4)-W(8)).GE.1E-4) GOTO 15
      NX(K)=L
      GOTO 3
   15 CONTINUE
    4 CONTINUE
   20 K=K-2
      NX(K+2)=0
    3 IF(K.LE.12) GOTO 10
    6 DO 7 N=1,K
    7 NX(N)=MV(I,NX(N))
      DO 8 K=1,12
    8 MV(I,K)=NX(K)
      DO 19 K=1,I-1
      IF(DIST(MV(K,13)).LE.DIST(MV(I,13))) GOTO 19
      IF(J.GE.K) J=J+1
      DO 16 L=1,14
      DO 17 M=I,K,-1
   17 MV(M+1,L)=MV(M,L)
      MV(K,L)=MV(I+1,L)
   16 MV(I+1,L)=0
      GOTO 18
   19 CONTINUE
   18 RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE READ
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(48,3,4),
     *YF(5,15,12),MH(20),MI(84),ML(10,2),MM(70),MN(8000),MO(3024),
     *MU(14735),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/MODI/ID,PM(6),RES,FAC,NRES,IBUR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      CHARACTER TIT*40,BL*4
      LOGICAL LOG,LOG3
CNOUSEDIMENSION P(3024)
CNOUSEEQUIVALENCE (MO(1),P(1))
      WRITE (IO2,1000)
      WRITE (IO2,1013)
C
C *** READ ALL OPTIONS ***
C
      READ (IO1,100) TIT
  100 FORMAT (4X,A)
      WRITE (IO2,103) TIT
  103 FORMAT (1X,'* TITL',A40)
      IS=0
    1 READ (IO1,1002) (MN(I),I=1,78)
      WRITE (IO2,1003) (MN(I),I=1,78)
      LOG3=.FALSE.
      DO 2 I=1,22
C
C 10 42 84  5 22 75 46 65  9 66 20 13 47 81 16 70  8  7 18  3 68 38
C AD BO BZ CE CI CO EN FI FO MO OC OM PA PE RO SH SP SY TE TI VI XY
C
C                                  TI CE SY SP FO AD OM RO TE OC CI
    2 IF (MN(1).EQ.MM(I+44)) GOTO ( 3, 5, 7, 8, 9,10,13,16,18,20,22,
     *38,42,46,47,65,66,68,70,75,81,84),I
C     XY BO EN PA FI MO VI SH CO PE BZ
C
      WRITE (IO2,1004) MN(1),MN(2)
      GOTO 1
C
C *** STORE TITLE ***
C
C  3:TI
    3 DO 4 I=3,78
    4 MN(I+76)=MN(I)
      GOTO 1
C
C *** STORE LATTICE CONSTANTS ***
C
C  5:CE
    5 CALL READN
      DO 6 I=1,6
    6 YC(I+22)=YD(I)
      GOTO 1
C
C *** STORE SYMMETRY OPERATORS ***
C
C  7:SY
C rxf if added
    7 if (ibur.ne.2) CALL READS
      IBUR=0
      GOTO 1
C
C *** GENERATE SYMMETRY OPERATORS ***
C
C  8:SP
    8 CALL SPGR
      GOTO 1
C
C *** STORE NUMBER OF ATOMS AND INPUT FORMAT ***
C
C  9:FO
    9 MI(1)=1
      CALL READN
      MI(9)=YD(1)
      GOTO 1
C
C *** STORE ADDED ATOMS ***
C
C 10:AD
   10 CALL READN
      DO 12 I=1,30
      IF (YD(I).LT.0.)GO TO 1
      MI(10)=MI(10)+1
   12 MN(MI(10))=IFIX(YD(I))
      GOTO 1
C
C *** STORE OMITTED ATOMS ***
C
C 13:OM
   13 CALL READN
      DO 15 I=1,30
      IF (YD(I).LE.-1E20)GO TO 1
      MI(11)=MI(11)+1
   15 MN(MI(11))=IFIX(YD(I))
      GOTO 1
C
C *** UPDATE ROTATION MATRIX ***
C
C 16:RO
   16 CALL READN
      MI(6)=1
      DO 17 I=1,3
   17 CALL ROTATE(I,YD(I))
      GOTO 1
C
C *** STORE TETRAHEDRA CONSTANTS ***
C
C 18:TE
   18 CALL READN
      MI(12)=1
      DO 19 I=1,8
   19 YC(I+6)=YD(I)
      GOTO 1
C
C *** STORE OCTAHEDRA CONSTANTS ***
C
C 20:OC
   20 CALL READN
      MI(13)=1
      DO 21 I=1,8
   21 YC(I+14)=YD(I)
      GOTO 1
C
C *** STORE CIRCLE NUMBERS ***
C
C 22:CI
   22 CALL READN
      MI(35)=MI(35)+1
      YC(MI(35)+78)=YD(1)
      I=2
      LOG=.FALSE.
      IF (YD(35).GT.0.)GO TO 34
   23 K=0
   24 I=I+1
      IF (I.GT.78)GO TO 1
      IF (MN(I).EQ.MM(1)) GOTO 24
      DO 26 J=19,44
   26 IF (MN(I).EQ.MM(J)) GOTO 27
      IF (.NOT.LOG) GOTO 24
      WRITE (IO2,1012) MN(I),MI(35)
      STOP
   27 LOG=.TRUE.
      IF (MN(I+1).EQ.MM(1))THEN
        L=45
        GOTO 31
      ENDIF
      DO 29 L=19,44
   29 IF (MN(I+1).EQ.MM(L)) GOTO 30
      WRITE (IO2,1012) MN(I+1),MI(35)
      STOP
   30 IF (MN(I+2).EQ.MM(1)) GOTO 31
      WRITE (IO2,1015) MN(I),MN(I+1),MN(I+2)
      STOP
   31 K=((J-19)*27+(L-18))*100+MI(35)
      MI(38)=MI(38)+1
      IF (MI(38).GE.44)THEN
        WRITE (IO2,1016)
        STOP
      ENDIF
      MN(MI(38)+556)=K
      I=I+1
      GOTO 23
   34 DO 36 I=2,30
      MI(7)=MI(7)+1
      IF (MI(7).GE.100)THEN
        WRITE (IO2,1017)
        STOP
      ENDIF
      IF (YD(I).LE.-1E10)GO TO 37
   36 MN(MI(7)+456)=YD(I)
      MI(7)=MI(7)+1
      IF (MI(7).GE.100)THEN
        WRITE (IO2,1017)
        STOP
      ENDIF
   37 MN(MI(7)+456)=-10000*MI(35)
      GOTO 1
C
C *** STORE XYZ-RANGE ***
C
C 38:XY
   38 CALL READN
      DO 39 I=1,6
   39 YC(I)=YD(I)
      MI(45)=1
      IF (YD(7).LE.-1E20)GO TO 1
      DO 41 I=7,12
   41 YC(I+22)=YD(I)
      MI(45)=2
      GOTO 1
C
C *** INTERPRET AND STORE BONDLENGTH AND TOLERANCE ***
C
C 42:BO
   42 CALL READN
      MN(1)=YD(1)
      MN(2)=IABS(MN(1))
      IF (MN(2).LE.0)GO TO 45
      MI(MN(2)+13)=MI(MN(2)+13)+1
      YF(MN(2),MI(MN(2)+13),1)=SIGN(YD(2),YD(1))
      DO 44 I=3,12
      IF (YD(I).LE.0.)GO TO 1
   44 YF(MN(2),MI(MN(2)+13),I-1)=YD(I)
      GOTO 1
   45 YC(32)=YD(2)
      YC(33)=YD(3)
      YC(34)=YD(4)
C
C *** THE END MARK HAS BEEN READ, RETURN TO MAIN ***
C
C 46:EN
   46 WRITE (IO2,1013)
      WRITE (IO2,1014)
      RETURN
C
C *** STORE PLOT SPECIFICATIONS ***
C
C 47:PA
   47 CALL READN
      DO 48 I=2,7
   48 IF (YD(I).LT.-1E2) YD(I)=-1.
      IF (YD(1).LE.1E-2) MI(46)=0
      FAC=YD(1)
C
      IF (IFIX(YD(2)).EQ.0)MI(44)=0
      IF (IFIX(YD(3)).EQ.0)MI(48)=0
      IF (IFIX(YD(4)).EQ.0)MI(34)=0
      IF (IFIX(YD(5)).EQ.0)MI(39)=0
      IF (IFIX(YD(6)).EQ.0)MI(40)=0
      IF (IFIX(YD(7)).EQ.0)MI(46)=0
      IF (YD(8).GT.0.)YC(89)=YD(8)
      IF (YD(9).GT.0.)NRES=NINT(YD(9))
      IF (YD(10).GT.0.)RES=YD(10)
      GOTO 1
C
C *** STORE FILE NUMBERS ***
C
C 65:FI
   65 CALL READN
      IF (YD(1).GT.0.) IO1=IFIX(YD(1))
      IF (YD(2).GT.0.) IO2=IFIX(YD(2))
      IF (YD(3).GT.0.) IO3=IFIX(YD(3))
      IF (YD(4).GT.0.) IO4=IFIX(YD(4))
      GOTO 1
C
C *** STORE DEVICE AND SCALE PARAMETERS ***
C
C 66:MO
   66 CALL READN
      ID=IFIX(YD(1))
      DO 67 I=2,7
      IF (YD(I).LT.-1E10) GOTO 1
   67 PM(I-1)=YD(I)
      GOTO 1
C
C *** STORE VIEW DIRECTION
C
C 68:VI
   68 CALL READN
      IF(MI(6).EQ.1)WRITE(IO2,1019)
      DO 69 I=1,6
   69 PP(I)=YD(I)
      GOTO 1
C
C *** STORE DO LOOP PARAMETERS FOR SHADING  ***
C
C 70:SH
   70 CALL READN
      I=1
      MI(41)=IFIX(YD(I))
   71 I=I+1
      IF (YD(I).LT.-1E20) GOTO 1
      IF (YD(I+1).LE.-1E20)THEN
        LOG3=.TRUE.
        YD(I+1)=-YD(I+1)
      ENDIF
      IS=IS+1
      NH(IS,1)=IFIX(YD(I))
      NH(IS,3)=MI(41)
      IF (YD(I+1).LT.0.)THEN
        NH(IS,2)=-IFIX(YD(I+1))
        I=I+1
      ELSE
        NH(IS,2)=NH(IS,1)
        IF (LOG3) GOTO 1
      ENDIF
      GOTO 71
C
C *** STORE PENS TO BE USED  ***
C
C 75:CO
   75 I=2
      K=1
   76 I=I+1
      IF(I.GT.76) GOTO 1
      IF(MN(I).EQ.MM(1)) GOTO 76
      DO 77 L=19,44
   77 IF(MN(I).EQ.MM(L)) MN(I)=L
      DO 78 L=19,44
   78 IF(MN(I+1).EQ.MM(L)) GOTO 82
      L=45
   82 MN(I+1)=L
      ML(K,1)=MN(I)*27+MN(I+1)-531
      IF(MN(I+1).NE.45) I=I+1
   79 I=I+2
      IF(MN(I).EQ.MM(1)) GOTO 79
      DO 80 L=4,9
   80 IF(MN(I).EQ.MM(L)) ML(K,2)=L-3
      K=K+1
      GOTO 76
C
C *** STORE STEREOVIEW PARAMETERS ***
C
C 81:PE
   81 CALL READN
      YB(25)=YD(1)
      GOTO 1
C
C *** STORE ATOMS TO BE DRAWN IN BIZARRE POLYHEDRA ***
C
C 84:BZ
   84 CALL READN
      DO 85 I=1,5
      IF(YP(I,1).EQ.0.) GOTO 86
   85 CONTINUE
      WRITE (IO3,1018)
   86 YP(I,3)=YD(1)
      K=0
   92 K=K+1
      DO 87 J=19,44
   87 IF(MN(K).EQ.MM(J)) GOTO 91
      GOTO 92
   91 MN(K)=J
      DO 88 J=19,44
   88 IF(MN(K+1).EQ.MM(J)) GOTO 89
      J=45
   89 MN(K+1)=J
      YP(I,1)=MN(K)*27+MN(K+1)-531
      GOTO 1
 1000 FORMAT ('1')
C1001 FORMAT (1X,29('*'),' INPUT CONTROL FROM UNIT',I2,1X,28('*'))
 1002 FORMAT (2A2,76A1)
 1003 FORMAT (' * ',2A2,71A1,' *')
 1004 FORMAT (' * !!! WARNING !!! THE LAST OPTION ',2A2,' IS IGNORED')
C1005 FORMAT (40A2)
C1006 FORMAT ('  !!! WARNING !!! THERE ARE TOO MANY CONSTRAINTS FOR BO
C    &NDS')
C1007 FORMAT (20A4)
C1008 FORMAT (2A1,I2,5X,3F10.5)
C1009 FORMAT (2A1,I2,26X,3F10.6)
C1010 FORMAT (2A1,I2,3F10.6)
C1011 FORMAT (80A1)
 1012 FORMAT ('  !!! ERROR !!! THE CHARACTER ',A1,' IN OPTION CIRC NO.
     & ',I3,' IS ILLEGAL, THE JOB IS TERMINATED')
 1013 FORMAT ('*',78X,'*')
 1014 FORMAT (1X,79('*'))
 1015 FORMAT (1X,3A1,' IS NOT A COMMON ATOM NAME, ONLY 2 LETTERS PER NAM
     &E ARE ACCEPTED, JOB IS TERMINATED')
 1016 FORMAT (' ONLY 44 SPECIFICATIONS ARE ACCEPTED DEFINED IN OPTION
     &CIRC,',/,' USE ATOM NUMBERS INSTEAD OF ATOM NAMES AND TRY AGAIN,',
     */,'JOB IS TERMINATED')
 1017 FORMAT (' THESE ARE TOO MANY CIRCLE SPECIFICATIONS,'/,' USE ATOM N
     *AMES INSTEAD OF NUMBERS AND TRY AGAIN'/'JOB IS TERMINATED')
 1018 FORMAT (' TOO MANY ATOMS IN BIZARRE POLYHEDRA')
 1019 FORMAT (' PREVIOUS ROTATIONS ARE APPLIED AFTER THIS INSTRUCTION')
      END
      SUBROUTINE READN
      COMMON/ALL1/YA(4,6000),YP(185),YD(40),YY(1496),MI(104),MM(70),
     *MN(8000),MO(17759),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      LOGICAL PNT,II
      DO 1 I=3,80
    1 IF (MN(I).EQ.MM(16)) MN(I)=MM(13)
      DO 2 I=1,30
    2 YD(I)=-1E30
      MN(1)=2
      MN(2)=0
      YD(35)=1.
    3 YD(31)=0.
      YD(32)=10.
      YD(33)=1.
      MI(26)=0
      EXP=1.
      PNT=.FALSE.
      II=.FALSE.
    4 MN(1)=MN(1)+1
      IF (MN(1)-76) 5,5,13
    5 IF (II) GOTO 6
      IF (MN(MN(1)).EQ.MM(1).OR.MN(MN(1)).EQ.MM(2)) GOTO 4
      II=.TRUE.
    6 DO 7 J=3,14
    7 IF (MN(MN(1)).EQ.MM(J)) GOTO 9
      IF (MN(MN(1)).EQ.MM(1)) GOTO 8
      YD(35)=-1.
      GOTO 3
    8 MN(2)=MN(2)+1
      YD(MN(2))=YD(31)*YD(33)
      GOTO 3
    9 IF (J-13) 10,11,12
   10 YD(34)=1.*J-3.
      IF (PNT)THEN
        MI(26)=MI(26)+1
        EXP=0.1*EXP
      ENDIF
      YD(31)=YD(31)*YD(32)+YD(34)*EXP
      GOTO 4
   11 PNT=.TRUE.
      YD(32)=1.
      GOTO 4
   12 YD(33)=-1.
      GOTO 4
   13 RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE READS
      COMMON/ALL1/YA(4,6000),YP(185),YD(40),YY(48,3,4),YF(920),MI(104),
     *MM(70),MN(8000),MO(17759),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      LOGICAL II,XYZ
C
      MN(1)=2
      II=.FALSE.
      XYZ=.FALSE.
C do not count if this was unit matrix
   99 IF(.NOT.XYZ)MI(5)=MI(5)+1
      XYZ=.TRUE.
      MN(2)=1
    1 YD(1)=1.
    2 MN(1)=MN(1)+1
      IF (MN(1).GT.78)GO TO 12
C skip blank or +
      IF (MN(MN(1)).EQ.MM(1).OR.MN(MN(1)).EQ.MM(2)) GOTO 2
C ',': next line of symmetry operations
      IF (MN(MN(1)).EQ.MM(16))THEN
        MN(2)=MN(2)+1
        GOTO 2
      ENDIF
C ';': new symmetry relationship
      IF (MN(MN(1)).EQ.MM(15))GO TO 99
C '-' in rotation matrix
      IF (MN(MN(1)).EQ.MM(14))THEN
        YD(1)=-1.
        GOTO 2
      ENDIF
    6 DO 7 J=4,9
    7 IF (MN(MN(1)).EQ.MM(J)) GOTO 9
      IF (II) WRITE (IO3,1000)
      DO 8 J=42,44
C rotation (J-40: 2-4 for x-z)
      IF (MN(MN(1)).EQ.MM(J))THEN
        YY(MI(5),MN(2),J-40)=YD(1)
        IF(YD(1).NE.1. .OR. MN(2).NE.J-40)XYZ=.FALSE.
        GOTO 1
      ENDIF
    8 CONTINUE
      WRITE (IO3,1000)
    9 IF (II)THEN
        II=.FALSE.
        XYZ=.FALSE.
C shift
        YY(MI(5),MN(2),1)=YD(2)/FLOAT(J-3)
        GOTO 2
      else
        II=.TRUE.
C shift numerator
        YD(2)=FLOAT(J-3)
C skip next and look for denominator
        MN(1)=MN(1)+2
        GOTO 6
      ENDIF
   12 RETURN
 1000 FORMAT (' UNKNOWN SYMBOL')
      END
C-----------------------------------------------------------------------
      SUBROUTINE RETIN
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(90),MN(1000,8),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
      COMMON/ALL2/CR
      CHARACTER*28 CR
C
C *** CHECK IF B(23),B(24) IS IN THE FACE DEFINED BY F(I) ***
C
      DO 1 I=3,5
      IF(MB(I+1).LE.0)GO TO 2
    1 CONTINUE
      I=6
    2 K=I+MOD(I,2)-1
      DO 3 J=1,K,2
      MG(12)=MOD(J,I)+1
      MG(13)=MOD(J+1,I)+1
      MG(14)=MOD(J-1,I)+1
      P2=      PFAKT(MB(MG(12)))
      P3=      PFAKT(MB(MG(13)))
      P4=      PFAKT(MB(MG(14)))
      YB(13)=P3*YA(2,MB(MG(13)))-P2*YA(2,MB(MG(12)))
      YB(14)=P3*YA(3,MB(MG(13)))-P2*YA(3,MB(MG(12)))
      YB(15)=P4*YA(2,MB(MG(14)))-P2*YA(2,MB(MG(12)))
      YB(16)=P4*YA(3,MB(MG(14)))-P2*YA(3,MB(MG(12)))
      YD(11)=YB(23)-P2*YA(2,MB(MG(12)))
      YD(12)=YB(24)-P2*YA(3,MB(MG(12)))
      YD( 5)=(YD(11)*YB(14)-YD(12)*YB(13))/(YB(15)*YB(14)-YB(16)*YB(13))
      YD( 6)=(YD(11)*YB(16)-YD(12)*YB(15))/(YB(13)*YB(16)-YB(14)*YB(15))
      YD(10)=AMIN1(YD(5),YD(6))
      IF (YD(10).LE.0)GO TO 4
    3 CONTINUE
    4 MG(17)=-IFIX(SIGN(1.,YD(10)))
      IF(MG(17).GE.0)GO TO 22
C
C *** CHECK IF B(23),B(24) IS OBSCURED ***
C
      IF (MG(1).NE.0 .AND. MG(4).NE.0)THEN
        DO 18 J=1,MG(4)
        MG(3)=MC(J)
        CALL INOUT
        IF (MG(17).LE.0)GO TO 22
   18   CONTINUE
      ENDIF
      IF (MG(2).NE.0 .AND. MG(5).NE.0)THEN
        DO 20 J=1,MG(5)
        P=      PFAKT(MO(MD(J)))
        YB( 8)=P*RAD (MO(MD(J)))
        YB(19)=P*YA(2,MO(MD(J)))
        YB(20)=P*YA(3,MO(MD(J)))
        YD(5)=SQRT((YB(23)-YB(19))**2+(YB(24)-YB(20))**2)
        IF (YD(5).LE.YB(8))GO TO 22
   20   CONTINUE
      ENDIF
      IF(MG(10).EQ.0.OR.MG(11).EQ.0) GOTO 21
      DO 33 J=1,MG(11)
      MG(3)=ME(J)
      CALL OUTIN
      IF(MG(17).LE.0)GO TO 22
   33 CONTINUE
C
C
C *** DRAW LINE ***
C
   21 CALL PLOT(YB(23),YB(24),3)
        XP=YB(23)*C75+512.
        YPP=YB(24)*C75+375.
        CALL PLOTHGL(XP,YPP,3)
      CALL PLOT(YB(23),YB(24),2)
        XP=YB(23)*C75+512.
        YPP=YB(24)*C75+375.
        CALL PLOTHGL(XP,YPP,2)
   22 CONTINUE
      RETURN
      END
C--------------------------------------------------------------------------
      SUBROUTINE ROTATE(NAX,ANGLE)
      EQUIVALENCE (YC35,YC(35))
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(48,3,4),
     *YF(5,15,12),MH(20),MI(84),ML(10,2),MM(70),MN(8000),MO(3024),
     *MU(14735),IO1,IO2,IO3,IO4
C
      IF(ANGLE.EQ.0.)RETURN
      T=ANGLE*YC35
C TO KEEP COMPATIBILITY WITH OLD VERSION
C ROTATION AROUND Y-AXIS IN OPPOSITE DIRECTION
*BER**Da kein I deklariert --> fr I NAX gesetzt*********************
*BER  IF(I.EQ.2)T=-T
      IF(NAX.EQ.2)T=-T
*********************************************************************
      C=COS(T)
      S=SIN(T)
      I1=3*(1+MOD(NAX  ,3))
      I2=3*(1+MOD(NAX+1,3))
      DO 1 I=1,3
      T=YB(I+I1)
      YB(I+I1)=C*T-S*YB(I+I2)
1     YB(I+I2)=S*T+C*YB(I+I2)
C      WRITE(IO2,13579)NAX,ANGLE
C13579 FORMAT(/' ACHSE, WINKEL:',I2,F8.2)
C      WRITE(IO2,97531)(YB(I),I=4,12)
C97531 FORMAT(3F10.6)
      RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE SCOB
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(10,2),MM(70),MN(1000,8),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
CNOUSEINTEGER Z(28)
C
      I=0
      M=MV(MG(10),14)
      DO 106 K=2,MU(M,1,3)+1
      DO 200 N=2,4
      YB(N-1)=YA(N,MV(MG(10),MU(M,K,3)))-YA(N,MV(MG(10),MU(M,K,2)))
  200 YB(N+2)=YA(N,MV(MG(10),MU(M,K,1)))-YA(N,MV(MG(10),MU(M,K,2)))
      YB(7)=YB(2)*YB(6)-YB(3)*YB(5)
      YB(8)=YB(3)*YB(4)-YB(1)*YB(6)
      YB(9)=YB(1)*YB(5)-YB(2)*YB(4)
      DO 201 N=2,4
  201 YB(N+2)=YA(N,MV(MG(10),13))-YA(N,MV(MG(10),MU(M,K,2)))
      YB(4)=YB(4)*YB(7)+YB(5)*YB(8)+YB(6)*YB(9)
      IF(ABS(YB(4)).LE.1E-4.AND.MU(MV(MG(10),14),1,3).EQ.1) GOTO 150
      YB(5)=YB(9)*(YB(25)-YA(4,MV(MG(10),MU(M,K,2))))
     &-YB(7)*YA(2,MV(MG(10),MU(M,K,2)))-YB(8)*YA(3,MV(MG(10),MU(M,K,2)))
      IF(YB(4)*YB(5).GE.-1E-4) GOTO 106
  150 DO 135 L=1,MU(M,K,7)
      JJ=MOD(L,MU(M,K,7))+1
      N1=MU(M,K,L)
      N2=MU(M,K,JJ)
      DO 137 NN=1,I
      IF(MA(NN,1).EQ.MV(MG(10),N1).AND.MA(NN,2).EQ.MV(MG(10),N2))
     * GOTO 135
      IF(MA(NN,2).EQ.MV(MG(10),N1).AND.MA(NN,1).EQ.MV(MG(10),N2))
     * GOTO 135
  137 CONTINUE
      I=I+1
      MA(I,1)=MV(MG(10),N1)
      MA(I,2)=MV(MG(10),N2)
  135 CONTINUE
  106 CONTINUE
  132 IF(I.EQ.20) GOTO 139
      DO 140 J=I+1,20
      MA(J,1)=0
  140 MA(J,2)=0
  139 CONTINUE
      RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE SEARCH(J,II)
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(106),YZ(100,5),YE(200,5),
     *MH(20),MI(104),MM(70),MN(1000,8),MO(17759),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      LOGICAL LOG
      IF (MI(40) .LE. 0)GO TO 20
      YC(91)=YC(15)
      YC(92)=YC(16)
      YC(93)=YC(17)
      YC(94)=YC(18)
      MH(1)=7
    2 LOG=.FALSE.
      YC(95)=1.414*(YC(17)+YC(18))
      MI(37)=MI(37)+1
      IF (MI(37).GT.1000)THEN
        WRITE (IO3,1000)
        STOP
      ENDIF
      MH(4)=3
      DO 10 I=1,II
      IF (ABS(YE(I,3)-YC(91)) .GT. YC(92))GO TO 10
      IF (ABS(YE(I,4)-YC(93)) .GT. YC(94))GO TO 10
      IF (ABS(YE(I,5)-YC(93)) .GT. YC(94))GO TO 10
      MH(2)=IFIX(YE(I,1))
      MH(3)=IFIX(YE(I,2))
      IF (.NOT.LOG)THEN
        MN(MI(37),2)=MH(2)
        MN(MI(37),3)=MH(3)
        LOG=.TRUE.
        GOTO 10
      ENDIF
      MH(5)=MH(4)
      DO 7 K=2,MH(5)
      IF (MH(2) .EQ. MN(MI(37),K))GO TO 8
    7 CONTINUE
      MH(4)=MH(4)+1
      MN(MI(37),MH(4))=MH(2)
    8 DO 9 K=2,MH(5)
      IF (MH(3) .EQ. MN(MI(37),K))GO TO 10
    9 CONTINUE
      MH(4)=MH(4)+1
      MN(MI(37),MH(4))=MH(3)
   10 CONTINUE
      IF (MH(4) .LT. MH(1))THEN
        MI(37)=MI(37)-1
        GOTO 18
      ENDIF
      MN(MI(37),1)=J
      YB(1)=0.
      P=PFAKT(MN(MI(37),1))
      YB(2)=P*YA(2,MN(MI(37),1))
      YB(3)=P*YA(3,MN(MI(37),1))
      DO 13 I=2,MH(1)
      P=PFAKT(MN(MI(37),I))
      YB(4)=P*YA(2,MN(MI(37),I))
      YB(5)=P*YA(3,MN(MI(37),I))
      YB(1)=AMAX1(YB(1),SQRT((YB(2)-YB(4))**2+(YB(3)-YB(5))**2))
   13 CONTINUE
      MN(MI(37),8)=IFIX(YB(1)*1E3)
      IF (MH(1) .NE. 7)GO TO 21
      DO 17 I=2,3
      YB(1)=YA(2,MN(MI(37),I))
      YB(2)=YA(3,MN(MI(37),I))
      YB(3)=YA(4,MN(MI(37),I))
      YC(96)=0.
      DO 16 J=I+1,9-I
      YB(4)=YA(2,MN(MI(37),J))
      YB(5)=YA(3,MN(MI(37),J))
      YB(6)=YA(4,MN(MI(37),J))
      YC(95)=SQRT((YB(4)-YB(1))**2+(YB(5)-YB(2))**2+(YB(6)-YB(3))**2)
      IF (YC(95) .GT. YC(96))THEN
        YC(96)=YC(95)
        MH(4)=J
      ENDIF
   16 CONTINUE
      J=MN(MI(37),MH(4))
      MN(MI(37),MH(4))=MN(MI(37),9-I)
      MN(MI(37),9-I)=J
   17 CONTINUE
   18 IF (MH(1) .NE. 7)GO TO 21
      IF (MI(39) .LE. 0)GO TO 21
   20 YC(91)=YC( 7)
      YC(92)=YC( 8)
      YC(93)=YC( 9)
      YC(94)=YC(10)
      MH(1)=5
      GOTO 2
   21 RETURN
 1000 FORMAT (1X,'THE MAXIMUM NUMBER OF POLYHEDRA IS 1000, THE JOB IS TE
     &RMINATED')
      END
C------------------------------------------------------------------------
      SUBROUTINE SORT
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(376),YR(194,3),MF(600),
     *MG(68),MI(25933),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DO 5 I=1,MG(15)-1
      K=I
      DO 2 J=I+1,MG(15)
      IF (YR(K,3).GT.YR(J,3))K=J
    2 CONTINUE
      IF (K.NE.I)THEN
        DO 4 J=1,3
        YB(14) =YR(I,J)
        YR(I,J)=YR(K,J)
    4   YR(K,J)=YB(14)
      ENDIF
    5 CONTINUE
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE SORT1(L)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(106),YZ(100,5),
     *YE(1020),MI(25933),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DO 4 I=1,L-1
      K=0
      YB(24)=YZ(I,5)
      DO 1 J=I+1,L
      IF (YB(24).LT.YZ(J,5)) GOTO 1
      YB(24)=YZ(J,5)
      K=J
    1 CONTINUE
      IF (K) 4,4,2
    2 DO 3 J=1,5
      YB(J)  =YZ(I,J)
      YZ(I,J)=YZ(K,J)
    3 YZ(K,J)=YB(J)
    4 CONTINUE
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE SPGR
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),YY(48,3,4),
     *YF(920),MI(104),MM(70),MN(25759),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
C rxf common added
      COMMON/MODI/ID,PM(6),RES,FAC,NRES,IBUR
      CHARACTER*28 CR
      DIMENSION IROTM(24,3,3),TS(24,3)
C rxf
      if (ibur.ne.0) then
      ibur=2
      CALL BURZ (ISYSTM,MI(44),IBRAVL,MI(5),IROTM,TS,MN(3))

      IF(MI(44).EQ.0)THEN
        WRITE(IO2,1001)
      ELSE
        WRITE(IO2,1002)
      ENDIF
      WRITE(IO2,1003)
      DO 1 N=1,MI(5)
        WRITE(IO2,1004)(TS(N,I),(IROTM(N,I,J),J=1,3),I=1,3)
        DO 1 I=1,3
          YY(N,I,1)=TS(N,I)
          DO 1 J=1,3
1           YY(N,I,J+1)=FLOAT(IROTM(N,I,J))
C rxf else inserted
      else
      do 100 i=3,78
      do 100 j=19,25
  100 if (mn(i).eq.mm(j)) ibravl=j-18
      endif
      GOTO (9,7,6,5,4,3,8,2),IBRAVL
    2 WRITE (IO2,1005)
      GO TO 9
    3 MI(4)=2
      YB(16)=0.5
      YB(17)=0.5
      YB(18)=0.5
      GO TO 9
    4 MI(4)=4
      YB(17)=0.5
      YB(18)=0.5
      YB(19)=0.5
      YB(21)=0.5
      YB(22)=0.5
      YB(23)=0.5
      GO TO 9
    5 MI(4)=2
      YB(16)=0.5
      YB(17)=0.5
      GO TO 9
    6 MI(4)=2
      YB(16)=0.5
      YB(18)=0.5
      GO TO 9
    7 MI(4)=2
      YB(17)=0.5
      YB(18)=0.5
      GO TO 9
    8 MI(4)=3
      YB(16)=0.33333333
      YB(17)=0.66666667
      YB(18)=0.66666667
      YB(19)=0.66666667
      YB(20)=0.33333333
      YB(21)=0.33333333
9     WRITE(IO2,1006)
      WRITE(IO2,1007)(YB(I+12),I=1,3*MI(4))
      RETURN
1001  FORMAT(' * -  no symmetry center at origin')
1002  FORMAT(' * -  symmetry center at origin')
1003  FORMAT(' * -  symmetry operations:')
1004  FORMAT(' * - ',3(F10.5,3I3))
1005  FORMAT(' * !!! bravais type not recognized,',
     *  ' default type is primitive !!!')
1006  FORMAT(' * -  translation vectors:')
1007  FORMAT(' * - ',3F10.5)
      END
C-------------------------------------------------------------------------
      SUBROUTINE SPLIT(I,J,LOG)
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(106),YZ(100,5),YE(200,5),
     *MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(5,21,7),MV(1000,14),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/BZR/BX,BY,BZ
      INTEGER BY(13),BZ(4),BX(10)
CNOUSEDIMENSION W(30)
      LOGICAL LOG,LOG1
*BER**LOG1 nicht def., Annahme: Voreinstellung LOG1=FALSE************
      LOG1=.FALSE.
*********************************************************************
C
      I1=1
      I3=2
      I9=0
      I4=1
    7 IF(BZ(I1).EQ.0) LOG=.TRUE.
      IF(LOG) GOTO 2
      I2=BZ(I1)
      I9=I9-1
      I1=I1+1
      GOTO 3
    2 I2=MU(I,1,3)+I3
      I3=I3+1
    3 I5=1
      IF(I4.EQ.1.AND.(.NOT.LOG1)) I6=I2
    6 MU(I,I2,I5)=BY(I4)
      I5=I5+1
      IF(LOG1) GOTO 11
      IF(BX(I4).EQ.1) GOTO 5
   11 LOG1=.FALSE.
      IF(I4.EQ.MIN(10,BY(11))) GOTO 9
      I4=I4+1
      GOTO 6
    9 I7=MU(I,I6,7)
      IF(.NOT.LOG) I9=I9+1
      I1=I1-1
      DO 8 I8=1,I5-1
      MU(I,I6,I8+I7)=MU(I,I2,I8)
    8 MU(I,I2,I8)=0
      MU(I,I6,7)=I7+I5-1
      GOTO 16
    5 MU(I,I2,I5)=J
      MU(I,I2,7)=I5
      I9=I9+1
      IF(I4.EQ.MIN(10,BY(11))) GOTO 10
      LOG1=.TRUE.
      GOTO 7
   10 I10=MU(I,I6,7)
      MU(I,I6,I10+1)=BY(I4)
      MU(I,I6,7)=I10+1
   16 MU(I,1,3)=MU(I,1,3)+I9
      IF(LOG) GOTO 13
      DO 12 I5=4,I1,-1
      IF(BZ(I5).EQ.0) GOTO 12
      DO 14 I2=1,7
      DO 15 I3=BZ(I5),MU(I,1,3)
   15 MU(I,I3,I2)=MU(I,I3+1,I2)
   14 MU(I,I3,I2)=0
      MU(I,1,3)=MU(I,1,3)-1
   12 CONTINUE
   13 RETURN
      END
C-------------------------------------------------------------------------
*BER  SUBROUTINE TIMER(N,LAST_TIMER)
*BER  INTEGER TIMTAB(10),NUMTAB(10),TIME
*BER  CALL LIB$STAT_TIMER(2,TIME)
*BER  LAST_TIMER=L
*BER  TIMTAB(N)=TIMTAB(N)+TIME
*BER  NUMTAB(N)=NUMTAB(N)+1
*BER  L=N
*BER  ENTRY TINIT
*BER  CALL LIB$INIT_TIMER
*BER  RETURN
*BER
*BER  ENTRY TIMOUT
*BER  DO I=1,10
*BER    IF(NUMTAB(I).GT.0)THEN
*BER      FTIME=0.01*FLOAT(TIMTAB(I))
*BER      WRITE(6,100)I,NUMTAB(I),FTIME,FTIME/NUMTAB(I)
*BER      SUM=SUM+FTIME
*BER    ENDIF
*BER  ENDDO
*BER  WRITE(6,101)SUM
*BER  RETURN
*BER100   FORMAT(I5,I8,F12.3,F12.4)
*BER101   FORMAT(F25.3)
*BER  END
C-----------------------------------------------------------------------------
      SUBROUTINE UNPACK(I)
      COMMON/ALL1/YA(4,6000),YP(1701),MH(20),MI(104),MM(70),MN(25759),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      DIMENSION IYA(4,6000)
      EQUIVALENCE (IYA,YA)
      PARAMETER (IYAQ=1000)
      PARAMETER (IYAQ1=10)
C
      MH(12)=ABS(IYA(1,I))
      MH(11)=MH(12)/IYAQ
      MH(12)=MH(12)-MH(11)*IYAQ
      MH(1)=(MH(11)-1)/27
      MH(2)=MH(11)-MH(1)*27
      MH(3)=MH(12)/IYAQ1
      MH(1)=MM(MOD(MH(1)+18,44)+1)
      MH(2)=MM(MOD(MH(2)+17,44)+1)
      RETURN
      END
C---------------------------------------------------------------------------
      SUBROUTINE VIEW
      EQUIVALENCE (YC36,YC(36))
      COMMON/ALL1/YA(4,6000),YP(70),YB(25),YC(90),YD(40),YY(48,3,4),
     *YF(900),MH(20),MI(104),MM(70),MN(8000),MO(3024),MU(14735),
     *IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      CHARACTER*28 CR
      COMMON/ADD1/NH(50,3),PP(10),IS
      COMMON/ADD2/TIT,BL
      CHARACTER TIT*40,BL*4
      DIMENSION ROT1(3),ROT2(3)
C
C TURN BACKWARD ACCUMULATED ROTATION MATRIX
      ROT2(3)=0.
      IF(YB(4).NE.0. .OR. YB(7).NE.0.)
     *ROT2(3)=YC36*ATAN2(YB(7),YB(4))
      CALL ROTATE(3,-ROT2(3))
      ROT2(2)=YC36*ATAN2(-YB(10),YB(4))
      CALL ROTATE(2,-ROT2(2))
      ROT2(1)=YC36*ATAN2(YB(11),YB(8))
      CALL ROTATE(1,-ROT2(1))
      DO 11 I=4,12
      YB(I)=0.
      IF(MOD(I,4).EQ.0)YB(I)=1.
11    CONTINUE
C
      IF(PP(2).LE.-1E6)PP(2)=1.
      IF(PP(3).LE.-1E6)THEN
        MO(7)=IFIX(PP(1))
        MO(8)=IFIX(PP(2))
        DO 1 I=1,3
        PP(I  )=YA(I+1,MO(7))
    1   PP(I+3)=YA(I+1,MO(8))
      ENDIF
      DO 2 I=1,3
      IF(PP(I+3).LE.-1E6)PP(I+3)=0.
    2 YD(I)=PP(I)-PP(I+3)

      CALL CORTH
      ROT1(1)=0.
      IF(YD(5).NE.0. .OR. YD(6).NE.0.)
     *ROT1(1)=YC36*ATAN2(YD(5),YD(6))
      ROT1(2)=YC36*ATAN2(-YD(4),SQRT(YD(5)*YD(5)+YD(6)*YD(6)))
      CALL ROTATE(1,ROT1(1))
      CALL ROTATE(2,ROT1(2))
C     place axis with longest projection across paper:
C     try a, b and c-axis (origin # 2,3 and 4)
C     with XYZR as factor, when given:
      PP(3)=0.
      DO 5 I=1,3
      IF(MI(45).EQ.0)THEN
        PP(6)=1.
      ELSE
        PP(6)=ABS(YC(I+I)-YC(I+I-1))
      ENDIF
      DO 3 J=1,3
    3 YD(J)=YA(J+1,I+1)*PP(6)
      CALL CORTH
C     projection: (4,5,6 is x,y,r)
      PP(4)=YB( 4)*YD(4)+YB( 5)*YD(5)+YB( 6)*YD(6)
      PP(5)=YB( 7)*YD(4)+YB( 8)*YD(5)+YB( 9)*YD(6)
      PP(6)=SQRT(PP(4)*PP(4)+PP(5)*PP(5))
      IF(PP(6).GT.PP(3))THEN
C     this is longer. memorize!
        DO 4 J=1,3
    4   PP(J)=PP(J+3)
      ENDIF
    5 CONTINUE
      ROT1(3)=YC36*ATAN2(-PP(2),PP(1))
      CALL ROTATE(3,ROT1(3))
      WRITE (IO2,1001) ROT1
      DO 6 I=1,3
    6 CALL ROTATE(I,ROT2(I))
      WRITE (IO2,1002) ROT2
 1001 FORMAT(' THE ROTATION ANGLES =',3F8.3,
     *' ARE CALCULATED FROM THE VIEW DIRECTION IN OPTION VIEW')
 1002 FORMAT(' UPON THIS VIEW ROTATIONS OF',3F8.3,' ARE PERFORMED.')
      RETURN
      END
C
C  MODIF ALB : A LOT............
C
      SUBROUTINE WRITE(LL)
      COMMON/ALL1/YA(4,6000),YP(225),MA(1476),MH(20),MI(104),
     *MM(70),MN(1000,8),MO(3759),MV(1000,14),IO1,IO2,IO3,IO4
      COMMON/ALL2/CR
      COMMON/WRL/AID,NAID,CART,IO5,IO7,IO8,NCIRC,ICOL,NCOL,NPT
      COMMON/WRLOUT/COOR,ICON,IO6,JCOR,JICO,NPOL,NCO,NID
      CHARACTER*28 CR
      INTEGER AID(6000,2)
      DIMENSION NA(13,3),ICON(6000,2),NPOL(6000),COLOR(20,3)
      DIMENSION NAID(6000),CART(6000,3),COOR(6000,3),NCIRC(6000)
      DIMENSION ICOL(6000),NCOL(20,2),NCO(6000),NID(6000)
C
      WRITE (IO2,1000)
      WRITE (IO2,1010)
      WRITE (6,1000)
      JCOR=0
      JICO=0
      NUM=0
      IO6=IO5
      IF(MI(37))201,201,200
200   DO 5 I=1,MI(37)-1
      K=0
      O=DIST(MN(I,1))
      DO 2 J=I+1,MI(37)
      IF(O-DIST(MN(J,1))) 2,1,1
    1 O=DIST(MN(J,1))
C     IF (O-A(H(J,1),4)) 2,1,1
C   1 O=A(H(J,1),4)
      K=J
    2 CONTINUE
      IF (K) 5,5,3
    3 DO 4 J=1,8
      L=MN(I,J)
      MN(I,J)=MN(K,J)
    4 MN(K,J)=L
    5 CONTINUE
      DO 11 I=1,MI(37)
      NUM=NUM+1
      DO 7 J=1,7
      IF (MN(I,J)) 8,8,6
    6 CALL UNPACK(MN(I,J))
      NA(J,1)=MH(1)
      NA(J,2)=MH(2)
    7 NA(J,3)=MH(3)
    8 IF (J-7) 9,10,10
    9 WRITE (IO2,1001)NUM,(MN(I,J),(NA(J,L),L=1,3),J=1,5)
      DO 100 J=1,5
      IF(MN(I,J).EQ.-1) GO TO 11
100   CONTINUE
      JCOR=JCOR+1
      WRITE(IO2,1005)NUM,MN(I,1),AID(MN(I,1),1),
     &AID(MN(I,1),2),(CART(MN(I,1),J),J=1,3)
      COOR(JCOR,1)=CART(MN(I,1),1)
      COOR(JCOR,2)=CART(MN(I,1),2)
      COOR(JCOR,3)=CART(MN(I,1),3)
      NPOL(JCOR)=0
      NID(JCOR)=MN(I,1)
      JT=JCOR
      DO 12,II=1,4
      JCOR=JCOR+1
      NPOL(JCOR)=4
      NID(JCOR)=MN(I,1)
      NCO(JCOR)=ICOL(MN(I,1))
      JJ=II+1
      WRITE(IO2,1006)MN(I,JJ),AID(MN(I,JJ),1),
     &AID(MN(I,JJ),2),(CART(MN(I,JJ),J),J=1,3)
      COOR(JCOR,1)=CART(MN(I,JJ),1)
      COOR(JCOR,2)=CART(MN(I,JJ),2)
      COOR(JCOR,3)=CART(MN(I,JJ),3)
      JICO=JICO+1
      ICON(JICO,1)=JT
      ICON(JICO,2)=JCOR
12    CONTINUE
      WRITE (6,1003) NUM,MN(I,1),(NA(1,L),L=1,3)
      GOTO 11
   10 WRITE (IO2,1002)NUM,(MN(I,J),(NA(J,L),L=1,3),J=1,7)
      DO 101 J=1,7
      IF(MN(I,J).EQ.-1) GO TO 11
101   CONTINUE
      JCOR=JCOR+1
      WRITE(IO2,1005)NUM,MN(I,1),AID(MN(I,1),1),
     &AID(MN(I,1),2),(CART(MN(I,1),J),J=1,3)
      COOR(JCOR,1)=CART(MN(I,1),1)
      COOR(JCOR,2)=CART(MN(I,1),2)
      COOR(JCOR,3)=CART(MN(I,1),3)
      NPOL(JCOR)=0
      NID(JCOR)=MN(I,1)
      JT=JCOR
      DO 13,II=1,6
      JCOR=JCOR+1
      NPOL(JCOR)=6
      NID(JCOR)=MN(I,1)
      NCO(JCOR)=ICOL(MN(I,1))
      JJ=II+1
      WRITE(IO2,1006)MN(I,JJ),AID(MN(I,JJ),1),
     &AID(MN(I,JJ),2),(CART(MN(I,JJ),J),J=1,3)
      COOR(JCOR,1)=CART(MN(I,JJ),1)
      COOR(JCOR,2)=CART(MN(I,JJ),2)
      COOR(JCOR,3)=CART(MN(I,JJ),3)
      JICO=JICO+1
      ICON(JICO,1)=JT
      ICON(JICO,2)=JCOR
13    CONTINUE
      WRITE (6,1004) NUM,MN(I,1),(NA(1,L),L=1,3)
   11 CONTINUE
C
C AND NOW THE ZARBI POLYHEDRA
C
      IF(LL)300,300,201
201   DO 299 I=1,LL
      NUM=NUM+1
      DO 202 J=1,12
      IF(MV(I,J).EQ.0)GO TO 203
202   CONTINUE
203   NPOLBZ=J-1
      DO 199 J=1,NPOLBZ
      CALL UNPACK(MV(I,J))
      NA(J,1)=MH(1)
      NA(J,2)=MH(2)
199   NA(J,3)=MH(3)
      CALL UNPACK(MV(I,13))
      NA(13,1)=MH(1)
      NA(13,2)=MH(2)
      NA(13,3)=MH(3)
C NPOLBZ is the number of corners in the zarbi polyhedron
      WRITE (IO2,2002)NUM,MV(I,13),(NA(13,L),L=1,3),
     &(MV(I,J),(NA(J,L),L=1,3),J=1,NPOLBZ)
      DO 204 J=1,13
      IF(MV(I,J).EQ.-1) GO TO 299
204   CONTINUE
      JCOR=JCOR+1
C  The central atom of the zarbi
      WRITE(IO2,1005)NUM,MV(I,13),AID(MV(I,13),1),
     &AID(MV(I,13),2),(CART(MV(I,13),J),J=1,3)
      COOR(JCOR,1)=CART(MV(I,13),1)
      COOR(JCOR,2)=CART(MV(I,13),2)
      COOR(JCOR,3)=CART(MV(I,13),3)
      NPOL(JCOR)=0
      NID(JCOR)=MV(I,13)
      JT=JCOR
C  The atoms at the zarbi corners
      DO 205,II=1,NPOLBZ
      JCOR=JCOR+1
      NPOL(JCOR)=NPOLBZ
C  those with 4 and 6 are distinguished by adding 10
      IF(NPOL(JCOR).EQ.4)NPOL(JCOR)=14
      IF(NPOL(JCOR).EQ.6)NPOL(JCOR)=16
      NID(JCOR)=MV(I,13)
      NCO(JCOR)=ICOL(MV(I,13))
      JJ=II
      WRITE(IO2,1006)MV(I,JJ),AID(MV(I,JJ),1),
     &AID(MV(I,JJ),2),(CART(MV(I,JJ),J),J=1,3)
      COOR(JCOR,1)=CART(MV(I,JJ),1)
      COOR(JCOR,2)=CART(MV(I,JJ),2)
      COOR(JCOR,3)=CART(MV(I,JJ),3)
      JICO=JICO+1
      ICON(JICO,1)=JT
      ICON(JICO,2)=JCOR
205   CONTINUE
      WRITE (6,1007) NUM,MV(I,13),(NA(13,L),L=1,3)
299   CONTINUE 
C
C
300   CALL DEFCOL(COLOR)
      CALL WRLWI(COLOR,MI(48))
      CALL WRLPO(COLOR,MI(48),MI(37),LL)
      CALL WRLPOV(COLOR,MI(48),MI(37),LL)
      RETURN
 1000 FORMAT (//,1X,'THE FOLLOWING ATOMS FORM POLYHEDRA:',/)
 1010 FORMAT (/,16X,'CA',12X,'A1',12X,'A2',12X,'A3',12X,'A4',12X,
     &'A5',12X,'A6',/,
     &'--------------------------------------------------------------
     &-----------------------------------------')
 1001 FORMAT (1X,'TET.',I3,2X,5('(',I4,')',1X,2A1,I2,3X))
 1002 FORMAT (1X,'OCT.',I3,2X,7('(',I4,')',1X,2A1,I2,3X))
 2002 FORMAT (1X,'BZR.',I3,2X,7('(',I4,')',1X,2A1,I2,3X)/
     &10X,6('(',I4,')',1X,2A1,I2,3X))
 1003 FORMAT (1X,'TETR.',1X,I3,3X,'(',I4,')',1X,2A1,I2)
 1004 FORMAT (1X,'OCTA.',1X,I3,3X,'(',I4,')',1X,2A1,I2)
 1005 FORMAT (1X,'POLY.',I3,3X,I4,2X,2A1,3F10.5)
 1006 FORMAT (4X,'ENVIR.',3X,I4,2X,2A1,3F10.5)
 1007 FORMAT (1X,'BZRR.',1X,I3,3X,'(',I4,')',1X,2A1,I2)
      END
C----------------------------------------------------------------------------
      SUBROUTINE WRLWI(COLOR,MCELL)
C  WIREFRAME MODEL wi.wrl
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/AID,NAID,CART,IO6,IO7,IO8,NCIRC,ICOL,NCOL,NPT
      DIMENSION NAID(6000),CART(6000,3),COOR(6000,3),NCIRC(6000)
      DIMENSION ICOL(6000),NCOL(20,2),NID(6000),COLOR(20,3)
      INTEGER ICON(6000,2),AID(6000,2),NPOL(6000),NCO(6000)
      WRITE(IO5,1010)
      WRITE(IO5,1009)
      WRITE(IO5,1011)
      WRITE(IO5,1012)
      WRITE(IO5,999)
      WRITE(IO5,1013)
      WRITE(IO5,1011)
      WRITE(IO5,1011)
      WRITE(IO5,1015)
      DO 1,I=1,JCOR
      WRITE(IO5,1000)(COOR(I,J),J=1,3)
1     CONTINUE
      WRITE(IO5,1016)
      KCO=NCO(ICON(1,2))
      WRITE(IO5,1014)(COLOR(KCO,KK),KK=1,3)
      WRITE(IO5,1017)
      DO 2,I=1,JICO
      IF(NCO(ICON(I,2)).EQ.KCO)GO TO 100
      KCO=NCO(ICON(I,2))
      WRITE(IO5,1016)
      WRITE(IO5,1014)(COLOR(KCO,KK),KK=1,3)
      WRITE(IO5,1017)
100   WRITE(IO5,1001)(ICON(I,J)-1,J=1,2)
2     CONTINUE
      WRITE(IO5,1016)
      WRITE(IO5,1019)
      WRITE(IO5,1019)
C
C  DRAW CELL AXES
C
      IF(MCELL.GT.0)THEN
      WRITE(IO5,1020)
      WRITE(IO5,1011)
      WRITE(IO5,1015)
      DO 3,I=1,8
      WRITE(IO5,1000)(CART(I,J),J=1,3)
3     CONTINUE
      WRITE(IO5,1016)
      WRITE(IO5,1017)
      WRITE(IO5,1021)
      WRITE(IO5,1016)
      WRITE(IO5,1019)
      ENDIF
      WRITE(IO5,1019)
      RETURN
C WRITE VRML header
999   FORMAT('  ShapeHints { shapeType UNKNOWN_SHAPE_TYPE }')
1000  FORMAT(5X,3F8.3,',')
1001  FORMAT(1X,I4,',',I4,',-1,')
1009  FORMAT('DEF BackgroundColor Info { string "1. 1. 1." }')
1010  FORMAT('#VRML V1.0 ascii')
1011  FORMAT('Separator{')
1012  FORMAT('Info{string"Created by STRUVIR" }')
1013  FORMAT('Material{'/'ambientColor 0.1 0.1 0.1'/
     &'   diffuseColor 0.75 0.75 0.75'/'specularColor 0.9 0.9 0.9'/
     &'   shininess 0.8 }'/'Normal{ vector 0 0 1 }')
1014  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1015  FORMAT('Coordinate3{point[')
1016  FORMAT(1X,']}')
1017  FORMAT('IndexedLineSet{coordIndex[')
1019  FORMAT(1X,'}')
1020  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1021  FORMAT(1X,'0,1,4,2,0,3,5,7,6,3,-1,1,5,-1,2,6,-1,4,7,-1')
      END
C------------------------------------------------------------------                                        
      SUBROUTINE WRLPO(COLOR,MCELL,MPOT,LL)
C  POLYHEDRA MODEL po.wrl
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/AID,NAID,CART,IO6,IO7,IO8,NCIRC,ICOL,NCOL,NPT
      DIMENSION NAID(6000),CART(6000,3),COOR(6000,3),NCIRC(6000)
      INTEGER ICON(6000,2),AID(6000,2),NPOL(6000),NCO(6000)
      DIMENSION ICOL(6000),NCOL(20,2),COLOR(20,3),NID(6000)
      DIMENSION NI(3,220),MAR(40,2),NQ(4,20)
      WRITE(IO7,1010)
      WRITE(IO7,1009)
      WRITE(IO7,1011)
      WRITE(IO7,1012)
      WRITE(IO7,999)
      WRITE(IO7,1013)
      WRITE(IO7,1011)
      WRITE(IO7,1011)
      I=0
      IPOL=1
1     I=I+1
      IF(I.GT.JCOR)GO TO 100
      IF(NPOL(I).EQ.0)GO TO 1
      IF(NPOL(I).EQ.6)GO TO 6
      IF(NPOL(I).EQ.3)GO TO 30
      IF(NPOL(I).EQ.14)GO TO 40
C      IF(NPOL(I).EQ.5)GO TO 50
      IF(NPOL(I).EQ.5)GO TO 60
      IF(NPOL(I).EQ.16)GO TO 60
      IF(NPOL(I).EQ.7)GO TO 60
      IF(NPOL(I).EQ.8)GO TO 60
      IF(NPOL(I).EQ.9)GO TO 60
      IF(NPOL(I).EQ.10)GO TO 60
      IF(NPOL(I).EQ.11)GO TO 60
      IF(NPOL(I).EQ.12)GO TO 60
C  THEN NPOL(I).EQ.4
      IF(NPOL(I).NE.4)GO TO 1
C
C  AX4 tetrahedron
C
      WRITE(IO7,1005)NID(I),AID(NID(I),1),AID(NID(I),2)
      WRITE(IO7,1014)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 2 JJ=I,I+3
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
2     CONTINUE
      I=JJ
      IPOL=IPOL+1
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      WRITE(IO7,1040)
      WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      WRITE(IO7,2001)
      GO TO 1
C
C  AX6 octahedron
C
6     WRITE(IO7,1005)NID(I),AID(NID(I),1),AID(NID(I),2)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 3 JJ=I,I+5
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
3     CONTINUE
      I=JJ
      IPOL=IPOL+1
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      WRITE(IO7,1050)
      WRITE(IO7,1051)
      WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      WRITE(IO7,2002)
      GO TO 1
C
C  AX3 Polyhedron : draw X3 in their plane
C
30    WRITE(IO7,1005)NID(I),AID(NID(I),1),AID(NID(I),2)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 31 JJ=I,I+2
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
31     CONTINUE
      I=JJ
      IPOL=IPOL+1
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      WRITE(IO7,3050)
      WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      WRITE(IO7,3051)
      GO TO 1
C
C  AX4 Polyhedron not being tetrahedron: presumably square
C               more or less plane
C
40    WRITE(IO7,1005)NID(I),AID(NID(I),1),AID(NID(I),2)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      CALL GEOM(I-1,I+3,NS)
      DO 41 JJ=I,I+3
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
41     CONTINUE
      I=JJ
      IPOL=IPOL+1
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      WRITE(IO7,4050)
      WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      WRITE(IO7,4051)
      GO TO 1
C
C  AX5, AX6 (not octahedron) to AX12 Polyhedron 
C
60    IA=I-1
      IF(NPOL(I).EQ.16)NPOL(I)=6
      IB=I+NPOL(I)-1
      IC=IPOL-MPOT
      CALL FACED(IA,IB,NI,NT,IC,MAR,NAR,NQ,NS)
      WRITE(IO7,1005)NID(I),AID(NID(I),1),AID(NID(I),2)
      WRITE(IO7,1060)(COLOR(NCO(I),KK),KK=1,3)
      WRITE(IO7,1015)
      DO 61 JJ=I,I+NPOL(I)-1
      WRITE(IO7,1000)(COOR(JJ,J),J=1,3)
61    CONTINUE
      I=JJ
      IPOL=IPOL+1
      IF(NT.EQ.0)GO TO 71
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      IF(NT.EQ.1)GO TO 70
      DO 62 JJ=1,NT-1
      CALL ACLOC3(NI,JJ,IA+1)
      WRITE(IO7,5060)(NI(IN,JJ)-1,IN=1,3)
62    CONTINUE
70    CALL ACLOC3(NI,NT,IA+1)
      WRITE(IO7,5061)(NI(IN,NT)-1,IN=1,3)
71    IF(NS.EQ.0)GO TO 75
      WRITE(IO7,1016)
      WRITE(IO7,1030)
      IF(NS.EQ.1)GO TO 74
      DO 73 JJ=1,NS-1
      CALL ACLOC4(NQ,JJ,IA+1)
      WRITE(IO7,5070)(NQ(IN,JJ)-1,IN=1,4)
73    CONTINUE
74    CALL ACLOC4(NQ,NS,IA+1)
      WRITE(IO7,5071)(NQ(IN,NS)-1,IN=1,4)
75    WRITE(IO7,1016)
      WRITE(IO7,2000)
      WRITE(IO7,1017)
      DO 63 JJ=1,NAR-1
      WRITE(IO7,5062)MAR(JJ,1),MAR(JJ,2)
63    CONTINUE
      WRITE(IO7,5063)MAR(NAR,1),MAR(NAR,2)
      GO TO 1
100   WRITE(IO7,1019)
      WRITE(IO7,1019)
C
C DRAW SPHERES IF ANY
C
      NOCIRC=0
      DO 3000,I=9,NPT
      IF(NCIRC(I).EQ.0) GO TO 3000
      NOCIRC=NOCIRC+1
3000  CONTINUE
      IF(NOCIRC.EQ.0) GO TO 4000
      WRITE(IO7,1011)
      DO 3001,I=9,NPT
      IF(NCIRC(I).EQ.0) GO TO 3001
      WRITE(IO7,1011)
      WRITE(IO7,3002)(COLOR(ICOL(I),KK),KK=1,3)
      WRITE(IO7,3003)(CART(NCIRC(I),J),J=1,3)
      WRITE(IO7,3004)
3001  CONTINUE
      WRITE(IO7,1019)
C
C  DRAW CELL AXES
C
4000  IF(MCELL.GT.0)THEN
      WRITE(IO7,1020)
      WRITE(IO7,1011)
      WRITE(IO7,1015)
      DO 4,I=1,8
      WRITE(IO7,1000)(CART(I,J),J=1,3)
4     CONTINUE
      WRITE(IO7,1016)
      WRITE(IO7,1017)
      WRITE(IO7,1021)
      WRITE(IO7,1016)
      WRITE(IO7,1019)
      ENDIF
      WRITE(IO7,1019)
      RETURN
C---------------------------------------------------------------------------
999   FORMAT('  ShapeHints { shapeType UNKNOWN_SHAPE_TYPE }')
1000  FORMAT(5X,3F8.3,',')
1001  FORMAT(1X,I4,',',I4,',-1,')
1005  FORMAT ('# POLYHEDRON ',I4,2X,2A1)
1009  FORMAT('DEF BackgroundColor Info { string "1. 1. 1." }')
1010  FORMAT('#VRML V1.0 ascii')
1011  FORMAT('Separator{')
1012  FORMAT('Info{string"Created by STRUVIR" }')
1013  FORMAT('Material{'/'ambientColor 0.1 0.1 0.1'/
     &'   diffuseColor 0.75 0.75 0.75'/'specularColor 0.9 0.9 0.9'/
     &'   shininess 0.8 }'/'Normal { vector 0 0 1 }')
1014  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1015  FORMAT('Coordinate3{point[')
1016  FORMAT(1X,']}')
1017  FORMAT('IndexedLineSet{coordIndex[')
1019  FORMAT(1X,'}')
1020  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
1021  FORMAT(1X,'0,1,4,2,0,3,5,7,6,3,-1,1,5,-1,2,6,-1,4,7,-1')
1030  FORMAT('IndexedFaceSet{coordIndex[')
1040  FORMAT('0,1,2,-1,0,1,3,-1,0,2,3,-1,1,2,3,-1,')
1050  FORMAT('0,2,1,-1,0,1,3,-1,0,3,4,-1,0,4,2,-1,')
1051  FORMAT('5,2,1,-1,5,1,3,-1,5,3,4,-1,5,4,2,-1,')
1060  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
2000  FORMAT('Material{diffuseColor 0.00 0.00 0.00'/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
2001  FORMAT('0,1,2,0,3,1,-1,2,3,-1 ]}')
2002  FORMAT('0,1,5,4,3,1,2,4,0,3,5,2,0,-1 ]}')
3002  FORMAT('Material{diffuseColor '3F6.3/
     &'    specularColor 0.5 0.5 0.5'/'    shininess 0.2 }')
3003  FORMAT('Translation{translation '3F8.3' }')
3004  FORMAT('Sphere{radius 0.5 } }')
3050  FORMAT('0,2,1,-1,')
3051  FORMAT('0,1,2,0,-1 ]}')
4050  FORMAT('0,2,1,-1,0,3,1,-1')
4051  FORMAT('0,2,1,3,0,-1 ]}')
5050  FORMAT('0,2,3,-1,0,3,4,-1,0,4,2,-1,1,2,3,-1,1,3,4,-1,1,4,2,-1')
5051  FORMAT('2,3,4,2,1,4,0,3,1,-1,0,2,-1 ]}')
5060  FORMAT(3(I2',')'-1,')
5061  FORMAT(3(I2',')'-1')
5062  FORMAT(2(I2',')'-1,')
5063  FORMAT(2(I2',')'-1 ]}')
5070  FORMAT(4(I2',')'-1,')
5071  FORMAT(4(I2',')'-1')
      END

C-----------------------------------------------------------------------
C  The ACLOC3 subroutine performs surface tests for triangles
C
      SUBROUTINE ACLOC3(NI,JJ,I)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(6000,3),ICON(6000,2),NPOL(6000),NCO(6000)
      DIMENSION NID(6000),NI(3,220),NTEMP(3),X(3),Y(3),Z(3)
      DO 100 J=1,3
      X(J)=COOR(I+NI(J,JJ)-1,1)
      Y(J)=COOR(I+NI(J,JJ)-1,2)
100   Z(J)=COOR(I+NI(J,JJ)-1,3)
      P1=Z(1)*Y(2)-Y(1)*Z(2)
      P2=X(1)*Z(2)-Z(1)*X(2)
      P3=Y(1)*X(2)-X(1)*Y(2)
      C=X(3)*P1+Y(3)*P2+Z(3)*P3
C      WRITE(4,*)'Triangular face JJ,  C  =',JJ,C
C
C OPTION: C must be negative otherwise reverse order
C 
      IF(C.LT.0.) GO TO 200
      DO 150 J=1,3
150   NTEMP(3-J+1)=NI(J,JJ)
      DO 151 J=1,3
151   NI(J,JJ)=NTEMP(J)
200   CONTINUE   
      RETURN
      END
C
C  The ACLOC4 subroutine performs surface tests for squares
C
      SUBROUTINE ACLOC4(NQ,JJ,I)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(6000,3),ICON(6000,2),NPOL(6000),NCO(6000)
      DIMENSION NID(6000),NQ(4,20),NTEMP(4),X(3),Y(3),Z(3)
      DO 100 J=1,3
      X(J)=COOR(I+NQ(J,JJ)-1,1)
      Y(J)=COOR(I+NQ(J,JJ)-1,2)
100   Z(J)=COOR(I+NQ(J,JJ)-1,3)
      P1=Z(1)*Y(2)-Y(1)*Z(2)
      P2=X(1)*Z(2)-Z(1)*X(2)
      P3=Y(1)*X(2)-X(1)*Y(2)
      C=X(3)*P1+Y(3)*P2+Z(3)*P3
C      WRITE(4,*)'Square face JJ,  C  =',JJ,C
C
C OPTION: C must be negative otherwise reverse order
C 
      IF(C.LT.0.) GO TO 200
      DO 150 J=1,4
150   NTEMP(4-J+1)=NQ(J,JJ)
      DO 151 J=1,4
151   NQ(J,JJ)=NTEMP(J)
200   CONTINUE   
      RETURN
      END
C
C The GEOM subroutine places first of the list the coordinates
C          of the X1 and X2 atoms having the largest X1-M-X2
C          angle in the MXn polyhedron  (n.LE.12). Then X3 and
C          X4 with the shortest X3-M-X4 angles will be listed,
C          unless X3 or X4 is identical to X1 or X2 so only the
C          third group of coordinates will correspond to either
C          X3-M-X1 or X3-M-X2 with shortest angle.
C
C Moreover : NS may have several values according to the
C            polyhedron type :
C            MX5 : NS=3 if triangular bipyramid defined as
C                  3 angles in the range 90-135 
C
      SUBROUTINE GEOM(I,IJ,NS)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(6000,3),ICON(6000,2),NPOL(6000),NCO(6000)
      DIMENSION YZ(100,5),YE(200,5),NID(6000),CO(12,3),MH(20)
C
      YC36=57.29578
      LL=0
      NS=0
      DO 4 J=I+1,IJ
      LL=LL+1
      YZ(LL,1)=FLOAT(J)
      YZ(LL,2)=COOR(I,1)-COOR(J,1)
      YZ(LL,3)=COOR(I,2)-COOR(J,2)
      YZ(LL,4)=COOR(I,3)-COOR(J,3)
      YZ(LL,5)=SQRT(YZ(LL,2)*YZ(LL,2)+
     *             YZ(LL,3)*YZ(LL,3)+
     *             YZ(LL,4)*YZ(LL,4))
    4 CONTINUE
      TEST1=0.
      TEST2=180.
      II=0
      DO 13 J=1,LL-1
      DO 12 K=J+1,LL
      II=II+1
      YE(II,1)=YZ(J,1)
      YE(II,2)=YZ(K,1)
      MH(8)=IFIX(YE(II,2))
      MH(7)=IFIX(YE(II,1))
      IF (ABS(YZ(J,5)*YZ(K,5)).GE.1E-8)THEN
        ARCO=(YZ(J,2)*YZ(K,2)+YZ(J,3)*YZ(K,3)+YZ(J,4)*YZ(K,4))/
     &  (YZ(J,5)*YZ(K,5))
        IF(ARCO.GT. 1.)ARCO= 1.
        IF(ARCO.LT.-1.)ARCO=-1.
      ELSE
        ARCO=1.
      ENDIF
      YE(II,3)=ACOS(ARCO)*YC36
      IF(YE(II,3).LT.135.AND.YE(II,3).GT.90.)NS=NS+1
      IF(YE(II,3).LT.TEST1)GO TO 120
      TEST1=YE(II,3)
      M1=MH(8)
      M2=MH(7)
120   IF(YE(II,3).GT.TEST2)GO TO 12
      TEST2=YE(II,3)
      M3=MH(8)
      M4=MH(7)
   12 CONTINUE
   13 CONTINUE
      CO(1,1)=COOR(M1,1)
      CO(1,2)=COOR(M1,2)
      CO(1,3)=COOR(M1,3)
      CO(2,1)=COOR(M2,1)
      CO(2,2)=COOR(M2,2)
      CO(2,3)=COOR(M2,3)
      LL=2
      IF(M3.EQ.M1.OR.M3.EQ.M2)GO TO 131
      CO(LL+1,1)=COOR(M3,1)
      CO(LL+1,2)=COOR(M3,2)
      CO(LL+1,3)=COOR(M3,3)
      M5=M3
      LL=LL+1
131   IF(M4.EQ.M1.OR.M4.EQ.M2)GO TO 132
      CO(LL+1,1)=COOR(M4,1)
      CO(LL+1,2)=COOR(M4,2)
      CO(LL+1,3)=COOR(M4,3)
      M5=M4
      LL=LL+1
132   IF(LL.NE.4) GO TO 133
      DO 14 J=I+1,IJ
      IF(M1.EQ.J)GO TO 14
      IF(M2.EQ.J)GO TO 14
      IF(M3.EQ.J)GO TO 14
      IF(M4.EQ.J)GO TO 14
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
   14 CONTINUE
      GO TO 140
133   DO 139 J=I+1,IJ
      IF(M1.EQ.J)GO TO 139
      IF(M2.EQ.J)GO TO 139
      IF(M5.EQ.J)GO TO 139
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
139   CONTINUE
140   LL=0
      DO 15 J=I+1,IJ
      LL=LL+1
      COOR(J,1)=CO(LL,1)
      COOR(J,2)=CO(LL,2)
      COOR(J,3)=CO(LL,3)
   15 CONTINUE
      RETURN
      END
C
C The FACED subroutine recovers edges and faces for the
C            bizarre polyhedra
C           
      SUBROUTINE FACED(I,IJ,NI,NT,LL,MAR,NAR,NQ,NS)
C
C  I  is the ID number for the central atom coordinates COOR(I,3)
C  from j = I+1 to IJ are the ID numbers for the polyhedron
C                     vertices coordinates
C  NI(3,1 to NT) will contain the triangle vertices numbers in return
C  NQ(3,1 to NS) will contain the square vertices numbers in return
C  MAR(1 to NAR,2) will contain edges
C
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      DIMENSION COOR(6000,3),ICON(6000,2),NPOL(6000),NCO(6000)
      DIMENSION CO(12,3),NID(6000),NQ(4,20),N(15)
      DIMENSION NI(3,220),MAR(40,2),MVV(12),ICODE(220),C(220)
C
      CALL EDGE(LL,MAR,NAR,MVV)
      LL=0
      DO 4 J=I+1,IJ
      LL=LL+1
      CO(LL,1)=COOR(J,1)
      CO(LL,2)=COOR(J,2)
      CO(LL,3)=COOR(J,3)
    4 CONTINUE
C
C      THEN: find all possible triangle XJ-XK-XL
      NT=0
      DO 150 J=1,LL-2
      DO 140 K=J+1,LL-1
      DO 130 L=K+1,LL
      IF(K.EQ.L)GO TO 130
      NT=NT+1
      NI(1,NT)=J
      NI(2,NT)=K
      NI(3,NT)=L
C      WRITE(4,*)'NT N1 N2,N3',NT,J,K,L
130   CONTINUE
140   CONTINUE
150   CONTINUE
C
C Find those triangles at the polyhedron surface
C            by the "brute force" 
C
      DO 160 KK=1,NT
160   ICODE(KK)=0
      DO 300 KK=1,NT
      J=NI(1,KK)
      K=NI(2,KK)
      L=NI(3,KK)
      X1=CO(K,1)-CO(J,1)
      Y1=CO(K,2)-CO(J,2)
      Z1=CO(K,3)-CO(J,3)
      X2=CO(L,1)-CO(J,1)
      Y2=CO(L,2)-CO(J,2)
      Z2=CO(L,3)-CO(J,3)
      P1=Y1*Z2-Y2*Z1
      P2=X2*Z1-X1*Z2
      P3=X1*Y2-X2*Y1
      DO 290 KL=1,NT
      IF(KL.EQ.KK)C(KL)=0.
      IF(KL.EQ.KK)GO TO 290
C
C X3,Y3,Z3 are coordinates of a vector pointing from
C   the barycenter of the face KL toward a vertex of the face KK
C
      X3=(CO(NI(1,KL),1)+CO(NI(2,KL),1)+CO(NI(3,KL),1))/3.
      Y3=(CO(NI(1,KL),2)+CO(NI(2,KL),2)+CO(NI(3,KL),2))/3.
      Z3=(CO(NI(1,KL),3)+CO(NI(2,KL),3)+CO(NI(3,KL),3))/3.
      X3=CO(J,1)-X3
      Y3=CO(J,2)-Y3
      Z3=CO(J,3)-Z3
      C(KL)=X3*P1+Y3*P2+Z3*P3
C      WRITE(4,*)'KK KL C',KK,KL,C
      IF(ABS(C(KL)).LT.0.0001)C(KL)=0.
      DO 280 KKK=1,KL
      IF(C(KKK).EQ.0.)GO TO 280
      IF(C(KL).EQ.0.)GO TO 280
C If signs are different go to 300
      IF(C(KL)*C(KKK).LT.0.)GO TO 300
280   CONTINUE
290   CONTINUE
      ICODE(KK)=1
300   CONTINUE
      IT=0
      DO 310 KK=1,NT
      IF(ICODE(KK).EQ.0)GO TO 310
      IT=IT+1
      ICODE(IT)=1
      NI(1,IT)=NI(1,KK)
      NI(2,IT)=NI(2,KK)
      NI(3,IT)=NI(3,KK)
C     WRITE(4,*)'IT N1 N2 N3',IT,NI(1,IT),NI(2,IT),NI(3,IT)
310   CONTINUE
      NT=IT
C
C  Are there square faces, if yes, reduce 4 triangles to one face 
C
      NS=0
      DO 400 KK=1,NT-3
      N(1)=NI(1,KK)
      N(2)=NI(2,KK)
      N(3)=NI(3,KK)
      DO 400 IZ=1,2
      DO 390 KL=KK+IZ,NT
      N(4)=NI(1,KL)
      N(5)=NI(2,KL)
      N(6)=NI(3,KL)
      IF(N(1).EQ.N(4).AND.N(2).EQ.N(5))GO TO 391
390   CONTINUE
      GO TO 400
391   DO 392 KM=KL+1,NT
      N(7)=NI(1,KM)
      N(8)=NI(2,KM)
      N(9)=NI(3,KM)
      IF(N(7).EQ.N(1).AND.N(8).EQ.N(3).AND.N(9).EQ.N(6))GO TO 393
392   CONTINUE
      GO TO 400
393   DO 394 KN=KM+1,NT
      N(10)=NI(1,KN)
      N(11)=NI(2,KN)
      N(12)=NI(3,KN)
      IF(N(10).EQ.N(2).AND.N(11).EQ.N(3).AND.N(12).EQ.N(9))GO TO 395
394   CONTINUE
      GO TO 400
C
C  A square face has been found
C         but where is the diagonal ? It cannot belong
C         to another triangle
C
395   NN1=0
      NN2=0
      NN3=0
      NN4=0
      NN5=0
      NN6=0
      DO 397 KP=1,NT
      IF(KP.EQ.KK)GO TO 397
      IF(KP.EQ.KL)GO TO 397
      IF(KP.EQ.KM)GO TO 397
      IF(KP.EQ.KN)GO TO 397
      N(13)=NI(1,KP)
      N(14)=NI(2,KP)
      N(15)=NI(3,KP)
      M1=N(1)
      M2=N(2)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN1=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN1=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN1=1
      M1=N(1)
      M2=N(3)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN2=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN2=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN2=1
      M1=N(4)
      M2=N(6)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN3=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN3=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN3=1
      M1=N(2)
      M2=N(3)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN4=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN4=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN4=1
      M1=N(5)
      M2=N(6)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN5=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN5=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN5=1
      M1=N(11)
      M2=N(12)
      IF(M1.EQ.N(13).AND.M2.EQ.N(14))NN6=1
      IF(M1.EQ.N(14).AND.M2.EQ.N(15))NN6=1
      IF(M1.EQ.N(13).AND.M2.EQ.N(15))NN6=1
397   CONTINUE
398   ICODE(KK)=0
      ICODE(KL)=0
      ICODE(KM)=0
      ICODE(KN)=0
      IF(NN1.EQ.0.AND.NN6.EQ.0)GO TO 401
      IF(NN2.EQ.0.AND.NN5.EQ.0)GO TO 402
      IF(NN3.EQ.0.AND.NN4.EQ.0)GO TO 403
      WRITE(4,*)'square face detected but not counted'
      GO TO 400
401   NS=NS+1
      NQ(1,NS)=N(1)
      NQ(2,NS)=N(3)
      NQ(3,NS)=N(2)
      NQ(4,NS)=N(12)
C      WRITE(4,*)'NS N1 N2 N3 N4',NS,(NQ(KQ,NS),KQ=1,4)
      GO TO 400
402   NS=NS+1
      NQ(1,NS)=N(1)
      NQ(2,NS)=N(2)
      NQ(3,NS)=N(3)
      NQ(4,NS)=N(12)
C      WRITE(4,*)'NS N1 N2 N3 N4',NS,(NQ(KQ,NS),KQ=1,4)
      GO TO 400
403   NS=NS+1
      NQ(1,NS)=N(1)
      NQ(2,NS)=N(2)
      NQ(3,NS)=N(12)
      NQ(4,NS)=N(3)
C      WRITE(4,*)'NS N1 N2 N3 N4',NS,(NQ(KQ,NS),KQ=1,4)
400   CONTINUE
      IF(NS.EQ.0)GO TO 501
      IT=0
      DO 500 KK=1,NT
      IF(ICODE(KK).EQ.0)GO TO 500
      IT=IT+1
      NI(1,IT)=NI(1,KK)
      NI(2,IT)=NI(2,KK)
      NI(3,IT)=NI(3,KK)
C      WRITE(4,*)'IT N1 N2 N3',IT,NI(1,IT),NI(2,IT),NI(3,IT)
500   CONTINUE
      NT=IT
501   CONTINUE
C
C  Are some edge lacking ... ?
C
      LL=IJ-I
      DO 1010 JJ=1,NAR
      DO 1010 J=1,LL
      IF(MAR(JJ,1).EQ.MVV(J))MAR(JJ,1)=J
      IF(MAR(JJ,2).EQ.MVV(J))MAR(JJ,2)=J
1010  CONTINUE
      DO 600 KL=1,NT
      N1=NI(1,KL)
      N2=NI(2,KL)
      N3=NI(3,KL)
      DO 590 JJ=1,NAR
      N4=MAR(JJ,1)
      N5=MAR(JJ,2)
      IF(N4.EQ.N1.AND.N5.EQ.N2)GO TO 591
      IF(N4.EQ.N2.AND.N5.EQ.N1)GO TO 591
590   CONTINUE
      IF(NAR.GT.40)PRINT *,'MORE THAN 40 EDGES =STOP'
      IF(NAR.GT.40)STOP
      NAR=NAR+1
      MAR(NAR,1)=N1
      MAR(NAR,2)=N2
591   CONTINUE
      DO 592 JJ=1,NAR
      N4=MAR(JJ,1)
      N5=MAR(JJ,2)
      IF(N4.EQ.N2.AND.N5.EQ.N3)GO TO 593
      IF(N4.EQ.N3.AND.N5.EQ.N2)GO TO 593
592   CONTINUE
      NAR=NAR+1
      IF(NAR.GT.40)PRINT *,'MORE THAN 40 EDGES =STOP'
      IF(NAR.GT.40)STOP
      MAR(NAR,1)=N2
      MAR(NAR,2)=N3
593   CONTINUE
600   CONTINUE
      DO 1011 L=1,NAR
      MAR(L,1)=MAR(L,1)-1
      MAR(L,2)=MAR(L,2)-1
1011  CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EDGE(LL,MAR,NAR,MVV)
      COMMON/ALL1/YA(4,6000),YP(10,7),YB(25),YC(90),YD(40),MA(20,2),
     *MB(6),MC(80),MD(80),ME(40),YR(194,3),MF(600),MG(68),MI(48),
     *MK(12,3),ML(10,2),MM(70),MN(1000,8),MO(3024),MU(5,21,7),
     *MV(1000,14),IO1,IO2,IO3,IO4
      DIMENSION MAR(40,2),MVV(12)
C
      MG(10)=LL
      I=0
      M=MV(MG(10),14)
      DO 106 K=2,MU(M,1,3)+1
      DO 135 L=1,MU(M,K,7)
      JJ=MOD(L,MU(M,K,7))+1
      N1=MU(M,K,L)
      N2=MU(M,K,JJ)
      DO 137 NN=1,I
      IF(MA(NN,1).EQ.MV(MG(10),N1).AND.MA(NN,2).EQ.MV(MG(10),N2))
     * GOTO 135
      IF(MA(NN,2).EQ.MV(MG(10),N1).AND.MA(NN,1).EQ.MV(MG(10),N2))
     * GOTO 135
  137 CONTINUE
      I=I+1
      MA(I,1)=MV(MG(10),N1)
      MA(I,2)=MV(MG(10),N2)
      MAR(I,1)=MV(MG(10),N1)
      MAR(I,2)=MV(MG(10),N2)
  135 CONTINUE
  106 CONTINUE
  132 IF(I.EQ.20) GOTO 139
      DO 140 J=I+1,20
      MA(J,1)=0
  140 MA(J,2)=0
  139 CONTINUE
      NAR=I
      DO 200 J=1,12
200   MVV(J)=MV(MG(10),J)
      RETURN
      END
C-------------------------------------------------------------------------
      SUBROUTINE DEFCOL(C)
      DIMENSION C(20,3)
C  Blue sky
      C(1,1)=0.0
      C(1,2)=1.0
      C(1,3)=1.0
C  Green light
      C(2,1)=0.5
      C(2,2)=1.5
      C(2,3)=0.0
C  Red pyrope
      C(3,1)=1.0
      C(3,2)=0.1
      C(3,3)=0.5
C  Yellow
      C(4,1)=1.0
      C(4,2)=1.0
      C(4,3)=0.0
C  Blue grey
      C(5,1)=0.6
      C(5,2)=0.6
      C(5,3)=1.0
C  Orange
      C(6,1)=1.0
      C(6,2)=0.6
      C(6,3)=0.0
C  Purple
      C(7,1)=0.5
      C(7,2)=0.0
      C(7,3)=0.5
C  Brown
      C(8,1)=0.5
      C(8,2)=0.3
      C(8,3)=0.0
C  Blue-green-dark
      C(9,1)=0.0
      C(9,2)=0.5
      C(9,3)=0.5
C  Red
      C(10,1)=1.0
      C(10,2)=0.0
      C(10,3)=0.0
C  Green
      C(11,1)=0.0
      C(11,2)=1.0
      C(11,3)=0.0
C  Blue
      C(12,1)=0.0
      C(12,2)=0.0
      C(12,3)=1.0
C  Pink
      C(13,1)=1.0
      C(13,2)=0.0
      C(13,3)=1.0
C  Red dark
      C(14,1)=0.5
      C(14,2)=0.0
      C(14,3)=0.0
C  Green dark
      C(15,1)=0.0
      C(15,2)=0.5
      C(15,3)=0.0
C  Blue night
      C(16,1)=0.0
      C(16,2)=0.0
      C(16,3)=0.5
C  Red wine
      C(17,1)=0.5
      C(17,2)=0.05
      C(17,3)=0.25
C  White
      C(18,1)=1.0
      C(18,2)=1.0
      C(18,3)=1.0
C  Grey
      C(19,1)=0.5
      C(19,2)=0.5
      C(19,3)=0.5
C  Black
      C(20,1)=0.0
      C(20,2)=0.0
      C(20,3)=0.0
      RETURN
      END
C
C  Routines for HPGL 7475 output
C
      SUBROUTINE HPON
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75   
      NEWLIN=1    
      LREC=0
C     PLOTTER ON    <ESC>.(
      CALL INBUF(27)
      CALL INBUF(46)
      CALL INBUF(40)
      CALL INBUF(13)
C     ESC.@:CR    
      CALL INBUF(27)    
      CALL INBUF(46)    
      CALL INBUF(64)    
      CALL INBUF(58)    
      CALL INBUF(13)    
C     ESC.I121;;17:CR   
      CALL INBUF(27)    
      CALL INBUF(46)    
      CALL INBUF(73)    
      CALL ITRANS(121)  
      CALL INBUF(59)    
      CALL INBUF(59)    
      CALL ITRANS(17)   
      CALL INBUF(58)    
      CALL INBUF(13)    
C     ESC.M:CR    
      CALL INBUF(27)    
      CALL INBUF(46)    
      CALL INBUF(77)    
      CALL INBUF(58)    
      CALL INBUF(13)    
C     ESC.N;19:CR 
      CALL INBUF(27)    
      CALL INBUF(46)    
      CALL INBUF(78)    
      CALL INBUF(59)    
      CALL ITRANS(19)   
      CALL INBUF(58)    
      CALL INBUF(13)    
      RETURN
      END
C     -------------------------------
      SUBROUTINE HPOFF 
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75   
C     EINE POSITION ZURUECK, DANN ;PU;SP0;CR
      LREC=LREC-1
      CALL INBUF(59)
      CALL INBUF(80)
      CALL INBUF(85)
      CALL INBUF(59)
      CALL INBUF(83)
      CALL INBUF(80)
      CALL INBUF(48)
      CALL INBUF(59)
      CALL INBUF(13)
C     PLOTTER OFF    <ESC>.)
      CALL INBUF(27)
      CALL INBUF(46)
      CALL INBUF(41)
      CALL INBUF(13)  
      RETURN
      END
C
C     --------------------------
C
      SUBROUTINE PLOTHGL(X,Y,IPEN)     
      IMPLICIT INTEGER(A-Z)   
      REAL X,Y,VFT
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
C     DATA LPX/16158/LPY/11040/   
C       SCALING WITH VFT
      IX=NINT(X*VFT)    
      IY=NINT(Y*VFT)    
C       TEST AT LIMITS
C     IF(IX.LT.0.OR.IX.GT.LPX.OR.IY.LT.0.OR.IY.GT.LPY) GOTO 100   
  200 IF (NEWLIN) 210,220,231 
C     NEWLIN = 1  STARTING A NEW COMMAND LINE 
  220 IF (IPEN-IPENA) 230,230,230 !!!!!!!!!!!!!!!!230,240,230  
C     Change according to IPEN, EINE POSITION ZURUECK, DANN ;
  230 LREC=LREC-1 
      CALL INBUF(59)    
  231 NEWLIN=0    
      GOTO (250,260) IPEN-1   
C     PD BLANK
  250 CALL INBUF(80)    
      CALL INBUF(68)    
      CALL INBUF(32)    
      GOTO 240    
C     PU BLANK
  260 CALL INBUF(80)    
      CALL INBUF(85)    
      CALL INBUF(32)    
C     X-KOORDINATE  ,  Y-KOORDINATE  ,
  240 CALL ITRANS(IX)   
      CALL INBUF(44)    
      CALL ITRANS(IY)   
      CALL INBUF(44)    
      IPENA=IPEN  
      IF(LREC-105) 210,290,290
  290 LREC=LREC-1 
      CALL INBUF(59)    
      CALL INBUF(13)    
      NEWLIN=1    
  210 CONTINUE    
      RETURN
      END   
C
C
C
      SUBROUTINE PS(IPAPER)
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
      IF(IPAPER-3) 104,102,104
C     IPAPER=3 'FORMAT DIN A3 ' PS3;IN;     
102   CALL INBUF(80)    
      CALL INBUF(83)    
      CALL INBUF(51)    
      CALL INBUF(59)    
      CALL INBUF(73)    
      CALL INBUF(78)    
      CALL INBUF(59)    
      CALL INBUF(13)
      LPX=16158   
      LPY=11040   
      GOTO 70
C     IPAPER=4 'FORMAT DIN A4 '   PS4;IN;     
104   CALL INBUF(80)    
      CALL INBUF(83)    
      CALL INBUF(52)    
      CALL INBUF(59)    
      CALL INBUF(73)    
      CALL INBUF(78)    
      CALL INBUF(59)    
      CALL INBUF(13)
      LPX=11040   
      LPY=7721    
70    RETURN
      END   
C
C	---------------------------
C
	SUBROUTINE SP(NR)
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75   
C	INST. SP (Select PEN)
      CALL INBUF(83)    
      CALL INBUF(80)    
C      CALL ITRANS(NR,0) 
      CALL ITRANS(NR) 
      CALL INBUF(59)    
      CALL INBUF(13)
      CALL INBUF(80)
      CALL INBUF(85)
      CALL INBUF(32)
      IPENA=3
      RETURN
      END   
C
C
	SUBROUTINE VS(VEL)
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75   
C       INST. VS (Plotter Speed)
      CALL INBUF(86)    
      CALL INBUF(83)    
      CALL TRANSL(VEL,2)
      CALL INBUF(59)    
      CALL INBUF(13)
      RETURN
	END
C
C	-----------------
C
      SUBROUTINE INBUF(IN)    
      IMPLICIT INTEGER(A-Z)   
      CHARACTER CH(121) 
      COMMON/PLOTHP/IOK,VFT,LREC,IPENA,NEWLIN,C75
      LREC=LREC+1 
      CH(LREC)=CHAR(IN) 
      IF(IN-13) 10,20,10
   20 WRITE(IOK,40) (CH(K), K=1,LREC)    
   40 FORMAT(120A1)     
      LREC=0
   10 CONTINUE    
      RETURN
      END   
C
C
C
      SUBROUTINE ITRANS(INPUT)
      CHARACTER BL,PU(5),PUFFER*5   
      DATA BL/' '/
      WRITE(PUFFER, '(I5)') INPUT   
      READ(PUFFER, '(5A1)') (PU(K), K=1,5)
      DO 10 K=1,5 
      IF (PU(K).EQ.BL) GOTO 10
      IN=ICHAR(PU(K))   
      CALL INBUF(IN)    
   10 CONTINUE    
      RETURN
      END   
C
C
C
      SUBROUTINE TRANSL(INPUT,N)    
      REAL INPUT  
      CHARACTER   BL,PU(11),PUFFER*11     
      DATA BL/' '/
      WRITE(PUFFER, '(F11.4)') INPUT
      READ(PUFFER, '(11A1)') (PU(K), K=1,11)    
      DO 10 K=1,6 
      IF (PU(K).EQ.BL) GOTO 10
      IN= ICHAR(PU(K))  
      CALL INBUF(IN)    
   10 CONTINUE    
      IF (N.GE.1) THEN  
      CALL INBUF(46)    
      DO 20 K=8,N+7     
      IN=ICHAR(PU(K))   
      CALL INBUF(IN)    
   20 CONTINUE    
      ENDIF 
      RETURN
      END   
*
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
*
      subroutine filedel(unit,file)
      integer unit
      character*(*)file
      open (unit,file=file,status='old')
      close (unit,status='delete')
      return
      end
C---------------------------------------------------------------------------
C Writes polyhedron model in POVRAY-format to file
C Mark Koennecke July 1996
C no warranties taken 
C Free for non commercial usage 
C----------------------------------------------------------------------------                                        
      SUBROUTINE WRLPOV(COLOR,MCELL,MPOT,LL)
      COMMON/WRLOUT/COOR,ICON,IO5,JCOR,JICO,NPOL,NCO,NID
      COMMON/WRL/AID,NAID,CART,IO6,IO7,IO8,NCIRC,ICOL,NCOL,NPT
      DIMENSION NAID(6000),CART(6000,3),COOR(6000,3),NCIRC(6000)
      INTEGER ICON(6000,2),AID(6000,2),NPOL(6000),NCO(6000)
      DIMENSION ICOL(6000),NCOL(20,2),COLOR(20,3),NID(6000)
      DIMENSION NI(3,220),MAR(40,2),NQ(4,20)
      INTEGER IOPOV, I	
      CHARACTER*20 COLNAM	
      LOGICAL T	
      REAL MIN(3), MAX(3),MIT(3), DIS
      INTEGER U,UU	

C create a file
      IOPOV = 27	
      INQUIRE(FILE='struplo.pov',EXIST=T)
      IF(T)THEN	
	      CALL FILEDEL(IOPOV,'struplo.pov')
      END IF
      OPEN(IOPOV,FILE='struplo.pov',STATUS='NEW')      	
C create a header
      WRITE(IOPOV,2001)
 2001 FORMAT('/*------------------------------------------------')
      WRITE(IOPOV,*)' POVRAY input file created by STRUPLO'
      WRITE(IOPOV,*)' STRUPLO is a crystal structure plotting package'
      WRITE(IOPOV,*)' Courtesy by Reinhard Fischer'
      WRITE(IOPOV,*)' Modified to produce POVRAY output by:'
      WRITE(IOPOV,*)' Dr. Mark Koennecke PSI'
      WRITE(IOPOV,*)' July 1996 '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)'   '
      WRITE(IOPOV,*)' The following declares provide default properties'
      WRITE(IOPOV,*)' for the polygons. The default is stupid color    '
      WRITE(IOPOV,*)' By editing these declares, the properties of '
      WRITE(IOPOV,*)' polygons can easily be adapted for groups of '
      WRITE(IOPOV,*)' Atoms respective polygons '
      WRITE(IOPOV,2002)
 2002 FORMAT('------------------------------------------------------*/')

C write declares with colours
        DO 2010, I = 1, 20			  	 			
        WRITE(COLNAM,2003)I
 2003   FORMAT('PolyTyp',I2.2)
        WRITE(IOPOV,2004)COLNAM
 2004   FORMAT(' #declare ',A20,' = ')
        WRITE(IOPOV,2005)COLOR(I,1),COLOR(I,2),COLOR(I,3)
 2005   FORMAT('  texture { pigment {color rgb < ',3(F6.3,1X),' > }')
        WRITE(IOPOV,*)'      finish {ambient 0.5 } }'
 2010 CONTINUE

C find center of data for positioning the camera sensibly
      DO 6000, U = 1, 3
	MIN(U) = 999999.
        MAX(U) = -999999.
 6000 CONTINUE
      DO 6010, U = 1, JCOR
	DO 6020, UU = 1,3
          IF(COOR(U,UU) .GT. MAX(UU))MAX(UU) = COOR(U,UU)
          IF(COOR(U,UU) .LT. MIN(UU))MIN(UU) = COOR(U,UU)
 6020   CONTINUE
 6010 CONTINUE
      DO 6030, U = 1, 3
        MIT(U) = MAX(U) - (ABS(MAX(U) - MIN(U))/2)
 6030 CONTINUE 

C get distance: find extent and assume 30degree camera angle
      DIS = ABS(MAX(1)-MIN(1))
      IF(ABS(MAX(2)-MIN(2)) .GT. DIS)DIS = ABS(MAX(2)-MIN(2))
      DIS = DIS /.5777 	

C write the default camera
      WRITE(IOPOV,*)' camera {'
      WRITE(IOPOV,6031)MIT(1), MIT(2), DIS
 6031 FORMAT('        location  < ',2(F8.4,',',1X),F8.4,' >')
      WRITE(IOPOV,6032)(MIT(U), U = 1,3)
 6032 FORMAT('        look_at  < ',2(F8.4,',',1X),F8.4,' >')
      WRITE(IOPOV,*)' }'			

C the default light source
      WRITE(IOPOV,*)' light_source { < 80., 0., 0.>'
      WRITE(IOPOV,*)'           color rgb <1.,1.,1.>}'

      I=0
      IPOL=1
C start loop
1     I=I+1
      IF(I.GT.JCOR)GO TO 100
      IF(NPOL(I).EQ.0)GO TO 1
      IF(NPOL(I).EQ.6)GO TO 6
      IF(NPOL(I).EQ.3)GO TO 30
      IF(NPOL(I).EQ.14)GO TO 40
C      IF(NPOL(I).EQ.5)GO TO 50
      IF(NPOL(I).EQ.5)GO TO 60
      IF(NPOL(I).EQ.16)GO TO 60
      IF(NPOL(I).EQ.7)GO TO 60
      IF(NPOL(I).EQ.8)GO TO 60
      IF(NPOL(I).EQ.9)GO TO 60
      IF(NPOL(I).EQ.10)GO TO 60
      IF(NPOL(I).EQ.11)GO TO 60
      IF(NPOL(I).EQ.12)GO TO 60
C  THEN NPOL(I).EQ.4
      IF(NPOL(I).NE.4)GO TO 1
C
C  AX4 tetrahedron
C
      WRITE(IOPOV,2011)NID(I), AID(NID(I),1),AID(NID(I),2)
 2011 FORMAT(' // Tetrahedron ', I4, 2X, 2A1)
C first triangle
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)
 3009 FORMAT(' union { ')
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+2,J), J=1,3)
 2021 FORMAT('     < ',2(1X,F8.4,','),F8.4,' > , ')
 3001 FORMAT('     < ',2(1X,F8.4,','),F8.4,' > }')
 2022 FORMAT('    texture { ',A20, ' }   } ')
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I+1,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,2022)COLNAM
      I = I + 3
      IPOL = IPOL + 1 
      GO TO 1
C
C  AX6 octahedron
C
6     WRITE(IOPOV,2006)NID(I), AID(NID(I),1),AID(NID(I),2)
 2006 FORMAT(' // Octahedron ', I4, 2X, 2A1)
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+3,J), J=1,3)
 
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+4,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+4,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+2,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I+5,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I+5,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+3,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I+5,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+4,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I+5,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+4,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,2022)COLNAM
      I = I + 5
      IPOL = IPOL + 1	 
      GO TO 1
C
C  AX3 Polyhedron : draw X3 in their plane
C
30    WRITE(IOPOV,2006)NID(I), AID(NID(I),1),AID(NID(I),2)
 2030 FORMAT(' // AX3 Polyhedron ', I4, 2X, 2A1)
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)	
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,2022)COLNAM 
      I = I + 2
      IPOL = IPOL + 1
      GO TO 1
C
C  AX4 Polyhedron not being tetrahedron: presumably square
C               more or less plane
C
40    WRITE(IOPOV,2006)NID(I), AID(NID(I),1),AID(NID(I),2)
 2031 FORMAT(' // AX4 Square-coordination  ', I4, 2X, 2A1)
      WRITE(COLNAM,2003)NCO(I)
      CALL GEOM(I-1,I+3,NS)
      WRITE(IOPOV,3009)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+2,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)

      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(I,J),J=1,3)
      WRITE(IOPOV,2021)(COOR(I+3,J), J=1,3)
      WRITE(IOPOV,3001)(COOR(I+1,J), J=1,3)
      WRITE(IOPOV,2022)COLNAM
      I = I + 3
      IPOL = IPOL + 1 
      GO TO 1
C
C  AX5, AX6 (not octahedron) to AX12 Polyhedron 
C
60    IA=I-1
      IF(NPOL(I).EQ.16)NPOL(I)=6
      IB=I+NPOL(I)-1
      IC=IPOL-MPOT
      CALL FACED(IA,IB,NI,NT,IC,MAR,NAR,NQ,NS)
      WRITE(IOPOV,2012)NID(I), AID(NID(I),1),AID(NID(I),2)
 2012 FORMAT(' // General polyhedron  ', I4, 2X, 2A1)
      WRITE(COLNAM,2003)NCO(I)
      WRITE(IOPOV,3009)
      I= I + NPOL(I) - 1
      IPOL=IPOL+1
      IF(NT.EQ.0)GO TO 71
      IF(NT.EQ.1)GO TO 70
      DO 62 JJ=1,NT-1
      CALL ACLOC3(NI,JJ,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NI(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NI(2,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NI(3,JJ),J), J=1,3)
62    CONTINUE
70    CALL ACLOC3(NI,NT,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NI(1,NT),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NI(2,NT),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NI(3,NT),J), J=1,3)
71    IF(NS.EQ.0)GO TO 75
      IF(NS.EQ.1)GO TO 74
      DO 73 JJ=1,NS-1
      CALL ACLOC4(NQ,JJ,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(2,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(3,JJ),J), J=1,3)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,JJ),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(3,JJ),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(4,JJ),J), J=1,3)
73    CONTINUE
74    CALL ACLOC4(NQ,NS,IA+1)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,NS),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(2,NS),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(3,NS),J), J=1,3)
      WRITE(IOPOV,*)' triangle {'
      WRITE(IOPOV,2021)(COOR(NQ(1,NS),J),J=1,3)
      WRITE(IOPOV,2021)(COOR(NQ(3,NS),J), J=1,3)
      WRITE(IOPOV,3001)(COOR(NQ(4,NS),J), J=1,3)
75    CONTINUE
      WRITE(IOPOV,2022)COLNAM 
      GO TO 1
100   WRITE(IOPOV,*)' '
      WRITE(IOPOV,*)' '
C
C DRAW SPHERES IF ANY
C
      WRITE(IOPOV,*)' // Drawing spheres ........'
      NOCIRC=0
      DO 3000,I=9,NPT
      IF(NCIRC(I).EQ.0) GO TO 3000
      NOCIRC=NOCIRC+1
3000  CONTINUE
      IF(NOCIRC.EQ.0) GO TO 4000
      DO 3002,I=9,NPT
      IF(NCIRC(I).EQ.0) GO TO 3002
      WRITE(IOPOV,2040)
 2040 FORMAT(' sphere { ')
      WRITE(COLNAM,2003)ICOL(I)
      WRITE(IOPOV,2041)(CART(NCIRC(I),J),J=1,3)
 2041 FORMAT('         < ',2(1X,F8.4,','),1X,F8.4, ' >, 0.7 ')
      WRITE(IOPOV,2042)COLNAM
 2042 FORMAT('       texture { ',A20,'} } ')	
 3002 CONTINUE
 4000 CONTINUE
      WRITE(IOPOV,*)' // end of file '
      CLOSE(IOPOV)	
      RETURN
      END
